/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "Agent.h"

#include "../qpid_api.h"

/** Initializes the brokerAgent module */
void
init_Agent(void)
{
    const oid       brokerAgentConnectionRef_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 1 };
    const oid       brokerAgentLabel_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 2 };
    const oid       brokerAgentRegisteredTo_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 3 };
    const oid       brokerAgentSystemId_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 4 };
    const oid       brokerAgentBrokerBank_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 5 };
    const oid       brokerAgentAgentBank_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 4, 6 };

    DEBUGMSGTL(("brokerAgent", "Initializing\n"));

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentConnectionRef",
                             handle_brokerAgentConnectionRef,
                             brokerAgentConnectionRef_oid,
                             OID_LENGTH(brokerAgentConnectionRef_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentLabel", handle_brokerAgentLabel,
                             brokerAgentLabel_oid,
                             OID_LENGTH(brokerAgentLabel_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentRegisteredTo",
                             handle_brokerAgentRegisteredTo,
                             brokerAgentRegisteredTo_oid,
                             OID_LENGTH(brokerAgentRegisteredTo_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentSystemId",
                             handle_brokerAgentSystemId,
                             brokerAgentSystemId_oid,
                             OID_LENGTH(brokerAgentSystemId_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentBrokerBank",
                             handle_brokerAgentBrokerBank,
                             brokerAgentBrokerBank_oid,
                             OID_LENGTH(brokerAgentBrokerBank_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerAgentAgentBank",
                             handle_brokerAgentAgentBank,
                             brokerAgentAgentBank_oid,
                             OID_LENGTH(brokerAgentAgentBank_oid),
                             HANDLER_CAN_RONLY));
}

int
handle_brokerAgentConnectionRef(netsnmp_mib_handler *handler,
                                netsnmp_handler_registration *reginfo,
                                netsnmp_agent_request_info *reqinfo,
                                netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */
	char data[256];
    qpidGetScalarString("agent", "connectionRef", data, 255);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
        		data, 			// a pointer to the scalar's data
                strlen(data)	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerAgentConnectionRef\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerAgentLabel(netsnmp_mib_handler *handler,
                        netsnmp_handler_registration *reginfo,
                        netsnmp_agent_request_info *reqinfo,
                        netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	char data[256];
    qpidGetScalarString("agent", "label", data, 255);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
        		data, 			// a pointer to the scalar's data
                strlen(data)	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR, "unknown mode (%d) in handle_brokerAgentLabel\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerAgentRegisteredTo(netsnmp_mib_handler *handler,
                               netsnmp_handler_registration *reginfo,
                               netsnmp_agent_request_info *reqinfo,
                               netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */
	char data[256];
    qpidGetScalarString("agent", "registeredTo", data, 255);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
        		data, 			// a pointer to the scalar's data
                strlen(data)	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerAgentRegisteredTo\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerAgentSystemId(netsnmp_mib_handler *handler,
                           netsnmp_handler_registration *reginfo,
                           netsnmp_agent_request_info *reqinfo,
                           netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	char data[256];
    qpidGetScalarString("agent", "systemId", data, 255);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_OCTET_STR,
        		data, 			// a pointer to the scalar's data
                strlen(data)	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerAgentSystemId\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerAgentBrokerBank(netsnmp_mib_handler *handler,
                             netsnmp_handler_registration *reginfo,
                             netsnmp_agent_request_info *reqinfo,
                             netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	uint32_t u32;
	qpidGetScalarU32("agent", "brokerBank", &u32);

	switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_UNSIGNED,
        		&u32, 			// a pointer to the scalar's data
                sizeof(u32)		// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerAgentBrokerBank\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerAgentAgentBank(netsnmp_mib_handler *handler,
                            netsnmp_handler_registration *reginfo,
                            netsnmp_agent_request_info *reqinfo,
                            netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	uint32_t u32;
	qpidGetScalarU32("agent", "agentBank", &u32);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_UNSIGNED,
        		&u32, 			// a pointer to the scalar's data
                sizeof(u32)		// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerAgentAgentBank\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
