/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "BindingTable.h"


/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement brokerBindingTable get routines.
 * TODO:240:M: Implement brokerBindingTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerBindingTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerBindingTable is subid 1 of brokerBindings.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement brokerBindingTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 * @param brokerBindingInternalIndex_val
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
brokerBindingTable_indexes_set_tbl_idx(brokerBindingTable_mib_index *
                                       tbl_idx,
                                       u_long
                                       brokerBindingInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_indexes_set_tbl_idx", "called\n"));

    /*
     * brokerBindingInternalIndex(7)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h 
     */
    tbl_idx->brokerBindingInternalIndex = brokerBindingInternalIndex_val;


    return MFD_SUCCESS;
}                               /* brokerBindingTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
brokerBindingTable_indexes_set(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                               u_long brokerBindingInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_indexes_set", "called\n"));

    if (MFD_SUCCESS !=
        brokerBindingTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                               brokerBindingInternalIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != brokerBindingTable_index_to_oid(&rowreq_ctx->oid_idx,
                                             &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* brokerBindingTable_indexes_set */


/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingExchangeRef
 * brokerBindingExchangeRef is subid 1 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.1
 * Description:
Binding exchangeRef
                     Additional info ( nodeType:property, references:Exchange, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerBindingExchangeRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingExchangeRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerBindingExchangeRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerBindingExchangeRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerBindingExchangeRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerBindingExchangeRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerBindingExchangeRef_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                             char **brokerBindingExchangeRef_val_ptr_ptr,
                             size_t
                             *brokerBindingExchangeRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerBindingExchangeRef_val_ptr_ptr)
                   && (NULL != *brokerBindingExchangeRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerBindingExchangeRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingExchangeRef_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerBindingExchangeRef data.
     * copy (* brokerBindingExchangeRef_val_ptr_ptr ) data and (* brokerBindingExchangeRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerBindingExchangeRef data
     */
    if ((NULL == (*brokerBindingExchangeRef_val_ptr_ptr)) ||
        ((*brokerBindingExchangeRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerBindingExchangeRef_len *
          sizeof(rowreq_ctx->data.brokerBindingExchangeRef[0])))) {
        /*
         * allocate space for brokerBindingExchangeRef data
         */
        (*brokerBindingExchangeRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerBindingExchangeRef_len *
                   sizeof(rowreq_ctx->data.brokerBindingExchangeRef[0]));
        if (NULL == (*brokerBindingExchangeRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerBindingExchangeRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerBindingExchangeRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerBindingExchangeRef_len *
        sizeof(rowreq_ctx->data.brokerBindingExchangeRef[0]);
    memcpy((*brokerBindingExchangeRef_val_ptr_ptr),
           rowreq_ctx->data.brokerBindingExchangeRef,
           rowreq_ctx->data.brokerBindingExchangeRef_len *
           sizeof(rowreq_ctx->data.brokerBindingExchangeRef[0]));

    return MFD_SUCCESS;
}                               /* brokerBindingExchangeRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingQueueRef
 * brokerBindingQueueRef is subid 2 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.2
 * Description:
Binding queueRef
                     Additional info ( nodeType:property, references:Queue, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerBindingQueueRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingQueueRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerBindingQueueRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerBindingQueueRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerBindingQueueRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerBindingQueueRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerBindingQueueRef_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                          char **brokerBindingQueueRef_val_ptr_ptr,
                          size_t *brokerBindingQueueRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerBindingQueueRef_val_ptr_ptr)
                   && (NULL != *brokerBindingQueueRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerBindingQueueRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingQueueRef_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerBindingQueueRef data.
     * copy (* brokerBindingQueueRef_val_ptr_ptr ) data and (* brokerBindingQueueRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerBindingQueueRef data
     */
    if ((NULL == (*brokerBindingQueueRef_val_ptr_ptr)) ||
        ((*brokerBindingQueueRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerBindingQueueRef_len *
          sizeof(rowreq_ctx->data.brokerBindingQueueRef[0])))) {
        /*
         * allocate space for brokerBindingQueueRef data
         */
        (*brokerBindingQueueRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerBindingQueueRef_len *
                   sizeof(rowreq_ctx->data.brokerBindingQueueRef[0]));
        if (NULL == (*brokerBindingQueueRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerBindingQueueRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerBindingQueueRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerBindingQueueRef_len *
        sizeof(rowreq_ctx->data.brokerBindingQueueRef[0]);
    memcpy((*brokerBindingQueueRef_val_ptr_ptr),
           rowreq_ctx->data.brokerBindingQueueRef,
           rowreq_ctx->data.brokerBindingQueueRef_len *
           sizeof(rowreq_ctx->data.brokerBindingQueueRef[0]));

    return MFD_SUCCESS;
}                               /* brokerBindingQueueRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingBindingKey
 * brokerBindingBindingKey is subid 3 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.3
 * Description:
Binding bindingKey
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Lstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Extract the current value of the brokerBindingBindingKey data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingBindingKey_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerBindingBindingKey_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerBindingBindingKey.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerBindingBindingKey_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerBindingBindingKey_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerBindingBindingKey_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                            char **brokerBindingBindingKey_val_ptr_ptr,
                            size_t
                            *brokerBindingBindingKey_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerBindingBindingKey_val_ptr_ptr)
                   && (NULL != *brokerBindingBindingKey_val_ptr_ptr));
    netsnmp_assert(NULL != brokerBindingBindingKey_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingBindingKey_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerBindingBindingKey data.
     * copy (* brokerBindingBindingKey_val_ptr_ptr ) data and (* brokerBindingBindingKey_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerBindingBindingKey data
     */
    if ((NULL == (*brokerBindingBindingKey_val_ptr_ptr)) ||
        ((*brokerBindingBindingKey_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerBindingBindingKey_len *
          sizeof(rowreq_ctx->data.brokerBindingBindingKey[0])))) {
        /*
         * allocate space for brokerBindingBindingKey data
         */
        (*brokerBindingBindingKey_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerBindingBindingKey_len *
                   sizeof(rowreq_ctx->data.brokerBindingBindingKey[0]));
        if (NULL == (*brokerBindingBindingKey_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerBindingBindingKey)\n");
            return MFD_ERROR;
        }
    }
    (*brokerBindingBindingKey_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerBindingBindingKey_len *
        sizeof(rowreq_ctx->data.brokerBindingBindingKey[0]);
    memcpy((*brokerBindingBindingKey_val_ptr_ptr),
           rowreq_ctx->data.brokerBindingBindingKey,
           rowreq_ctx->data.brokerBindingBindingKey_len *
           sizeof(rowreq_ctx->data.brokerBindingBindingKey[0]));

    return MFD_SUCCESS;
}                               /* brokerBindingBindingKey_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingArguments
 * brokerBindingArguments is subid 4 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.4
 * Description:
Binding arguments
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Map (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Extract the current value of the brokerBindingArguments data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingArguments_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerBindingArguments_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerBindingArguments.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerBindingArguments_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerBindingArguments_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerBindingArguments_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                           char **brokerBindingArguments_val_ptr_ptr,
                           size_t *brokerBindingArguments_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerBindingArguments_val_ptr_ptr)
                   && (NULL != *brokerBindingArguments_val_ptr_ptr));
    netsnmp_assert(NULL != brokerBindingArguments_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingArguments_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerBindingArguments data.
     * copy (* brokerBindingArguments_val_ptr_ptr ) data and (* brokerBindingArguments_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerBindingArguments data
     */
    if ((NULL == (*brokerBindingArguments_val_ptr_ptr)) ||
        ((*brokerBindingArguments_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerBindingArguments_len *
          sizeof(rowreq_ctx->data.brokerBindingArguments[0])))) {
        /*
         * allocate space for brokerBindingArguments data
         */
        (*brokerBindingArguments_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerBindingArguments_len *
                   sizeof(rowreq_ctx->data.brokerBindingArguments[0]));
        if (NULL == (*brokerBindingArguments_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerBindingArguments)\n");
            return MFD_ERROR;
        }
    }
    (*brokerBindingArguments_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerBindingArguments_len *
        sizeof(rowreq_ctx->data.brokerBindingArguments[0]);
    memcpy((*brokerBindingArguments_val_ptr_ptr),
           rowreq_ctx->data.brokerBindingArguments,
           rowreq_ctx->data.brokerBindingArguments_len *
           sizeof(rowreq_ctx->data.brokerBindingArguments[0]));

    return MFD_SUCCESS;
}                               /* brokerBindingArguments_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingOrigin
 * brokerBindingOrigin is subid 5 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.5
 * Description:
Binding origin
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerBindingOrigin data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingOrigin_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerBindingOrigin_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerBindingOrigin.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerBindingOrigin_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerBindingOrigin_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerBindingOrigin_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                        char **brokerBindingOrigin_val_ptr_ptr,
                        size_t *brokerBindingOrigin_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerBindingOrigin_val_ptr_ptr)
                   && (NULL != *brokerBindingOrigin_val_ptr_ptr));
    netsnmp_assert(NULL != brokerBindingOrigin_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingOrigin_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerBindingOrigin data.
     * copy (* brokerBindingOrigin_val_ptr_ptr ) data and (* brokerBindingOrigin_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerBindingOrigin data
     */
    if ((NULL == (*brokerBindingOrigin_val_ptr_ptr)) ||
        ((*brokerBindingOrigin_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerBindingOrigin_len *
          sizeof(rowreq_ctx->data.brokerBindingOrigin[0])))) {
        /*
         * allocate space for brokerBindingOrigin data
         */
        (*brokerBindingOrigin_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerBindingOrigin_len *
                   sizeof(rowreq_ctx->data.brokerBindingOrigin[0]));
        if (NULL == (*brokerBindingOrigin_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerBindingOrigin)\n");
            return MFD_ERROR;
        }
    }
    (*brokerBindingOrigin_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerBindingOrigin_len *
        sizeof(rowreq_ctx->data.brokerBindingOrigin[0]);
    memcpy((*brokerBindingOrigin_val_ptr_ptr),
           rowreq_ctx->data.brokerBindingOrigin,
           rowreq_ctx->data.brokerBindingOrigin_len *
           sizeof(rowreq_ctx->data.brokerBindingOrigin[0]));

    return MFD_SUCCESS;
}                               /* brokerBindingOrigin_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingMsgMatched
 * brokerBindingMsgMatched is subid 6 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.6
 * Description:
Binding msgMatched
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerBindingMsgMatched data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingMsgMatched_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerBindingMsgMatched_get(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                            U64 * brokerBindingMsgMatched_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerBindingMsgMatched_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerBindingMsgMatched data.
     * get (* brokerBindingMsgMatched_val_ptr ).low and (* brokerBindingMsgMatched_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerBindingMsgMatched_val_ptr).high =
        rowreq_ctx->data.brokerBindingMsgMatched.high;
    (*brokerBindingMsgMatched_val_ptr).low =
        rowreq_ctx->data.brokerBindingMsgMatched.low;


    return MFD_SUCCESS;
}                               /* brokerBindingMsgMatched_get */



/** @} */
