/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "BindingTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerBindingTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerBindingTable is subid 1 of brokerBindings.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerBindingTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerBindingTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerBindingTable_undo_setup(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_undo_setup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerBindingTable undo.
     * set up brokerBindingTable undo information, in preparation for a set.
     * Undo storage is in (* brokerBindingMsgMatched_val_ptr )*
     */

    return rc;
}                               /* brokerBindingTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerBindingTable_undo(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerBindingTable undo.
     * brokerBindingTable undo information, in response to a failed set.
     * Undo storage is in (* brokerBindingMsgMatched_val_ptr )*
     */

    return rc;
}                               /* brokerBindingTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBindingTable_undo_cleanup(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_undo_cleanup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerBindingTable undo.
     * Undo storage is in (* brokerBindingMsgMatched_val_ptr )*
     */

    return rc;
}                               /* brokerBindingTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBindingTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerBindingTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBindingTable_commit(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerBindingTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerBINDINGEXCHANGEREF_FLAG) {
        save_flags &= ~COLUMN_brokerBINDINGEXCHANGEREF_FLAG;    /* clear brokerBindingExchangeRef */
        /*
         * TODO:482:o: |-> commit column brokerBindingExchangeRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBindingTable column brokerBindingExchangeRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBindingExchangeRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBINDINGEXCHANGEREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBINDINGQUEUEREF_FLAG) {
        save_flags &= ~COLUMN_brokerBINDINGQUEUEREF_FLAG;       /* clear brokerBindingQueueRef */
        /*
         * TODO:482:o: |-> commit column brokerBindingQueueRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBindingTable column brokerBindingQueueRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBindingQueueRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBINDINGQUEUEREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBINDINGBINDINGKEY_FLAG) {
        save_flags &= ~COLUMN_brokerBINDINGBINDINGKEY_FLAG;     /* clear brokerBindingBindingKey */
        /*
         * TODO:482:o: |-> commit column brokerBindingBindingKey.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBindingTable column brokerBindingBindingKey commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBindingBindingKey
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBINDINGBINDINGKEY_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBINDINGARGUMENTS_FLAG) {
        save_flags &= ~COLUMN_brokerBINDINGARGUMENTS_FLAG;      /* clear brokerBindingArguments */
        /*
         * TODO:482:o: |-> commit column brokerBindingArguments.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBindingTable column brokerBindingArguments commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBindingArguments
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBINDINGARGUMENTS_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerBindingTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBindingTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerBindingTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBindingTable_undo_commit(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingTable_undo_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerBindingTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerBindingTable_undo_commit */

/*
 * TODO:440:M: Implement brokerBindingTable node value checks.
 * TODO:450:M: Implement brokerBindingTable undo functions.
 * TODO:460:M: Implement brokerBindingTable set functions.
 * TODO:480:M: Implement brokerBindingTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingExchangeRef
 * brokerBindingExchangeRef is subid 1 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.1
 * Description:
Binding exchangeRef
                     Additional info ( nodeType:property, references:Exchange, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingExchangeRef_val_ptr
 *        A char containing the new value.
 * @param brokerBindingExchangeRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingExchangeRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBindingTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBindingExchangeRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBindingExchangeRef_check_value(brokerBindingTable_rowreq_ctx *
                                     rowreq_ctx,
                                     char
                                     *brokerBindingExchangeRef_val_ptr,
                                     size_t
                                     brokerBindingExchangeRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingExchangeRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingExchangeRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBindingExchangeRef value.
     */

    return MFD_SUCCESS;         /* brokerBindingExchangeRef value not illegal */
}                               /* brokerBindingExchangeRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBindingTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBindingExchangeRef_undo_setup(brokerBindingTable_rowreq_ctx *
                                    rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingExchangeRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBindingExchangeRef undo.
     */
    /*
     * copy brokerBindingExchangeRef and brokerBindingExchangeRef_len data
     * set rowreq_ctx->undo->brokerBindingExchangeRef from rowreq_ctx->data.brokerBindingExchangeRef
     */
    memcpy(rowreq_ctx->undo->brokerBindingExchangeRef,
           rowreq_ctx->data.brokerBindingExchangeRef,
           (rowreq_ctx->data.brokerBindingExchangeRef_len *
            sizeof(rowreq_ctx->undo->brokerBindingExchangeRef[0])));
    rowreq_ctx->undo->brokerBindingExchangeRef_len =
        rowreq_ctx->data.brokerBindingExchangeRef_len;


    return MFD_SUCCESS;
}                               /* brokerBindingExchangeRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBindingExchangeRef_val_ptr
 *        A char containing the new value.
 * @param brokerBindingExchangeRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingExchangeRef_val_ptr
 */
int
brokerBindingExchangeRef_set(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                             char *brokerBindingExchangeRef_val_ptr,
                             size_t brokerBindingExchangeRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingExchangeRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingExchangeRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBindingExchangeRef value.
     * set brokerBindingExchangeRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBindingExchangeRef,
           brokerBindingExchangeRef_val_ptr,
           brokerBindingExchangeRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBindingExchangeRef_len =
        brokerBindingExchangeRef_val_ptr_len /
        sizeof(brokerBindingExchangeRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBindingExchangeRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBindingExchangeRef_undo(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingExchangeRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBindingExchangeRef undo.
     */
    /*
     * copy brokerBindingExchangeRef and brokerBindingExchangeRef_len data
     * set rowreq_ctx->data.brokerBindingExchangeRef from rowreq_ctx->undo->brokerBindingExchangeRef
     */
    memcpy(rowreq_ctx->data.brokerBindingExchangeRef,
           rowreq_ctx->undo->brokerBindingExchangeRef,
           (rowreq_ctx->undo->brokerBindingExchangeRef_len *
            sizeof(rowreq_ctx->data.brokerBindingExchangeRef[0])));
    rowreq_ctx->data.brokerBindingExchangeRef_len =
        rowreq_ctx->undo->brokerBindingExchangeRef_len;


    return MFD_SUCCESS;
}                               /* brokerBindingExchangeRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingQueueRef
 * brokerBindingQueueRef is subid 2 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.2
 * Description:
Binding queueRef
                     Additional info ( nodeType:property, references:Queue, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingQueueRef_val_ptr
 *        A char containing the new value.
 * @param brokerBindingQueueRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingQueueRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBindingTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBindingQueueRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBindingQueueRef_check_value(brokerBindingTable_rowreq_ctx *
                                  rowreq_ctx,
                                  char *brokerBindingQueueRef_val_ptr,
                                  size_t brokerBindingQueueRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingQueueRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingQueueRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBindingQueueRef value.
     */

    return MFD_SUCCESS;         /* brokerBindingQueueRef value not illegal */
}                               /* brokerBindingQueueRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBindingTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBindingQueueRef_undo_setup(brokerBindingTable_rowreq_ctx *
                                 rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingQueueRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBindingQueueRef undo.
     */
    /*
     * copy brokerBindingQueueRef and brokerBindingQueueRef_len data
     * set rowreq_ctx->undo->brokerBindingQueueRef from rowreq_ctx->data.brokerBindingQueueRef
     */
    memcpy(rowreq_ctx->undo->brokerBindingQueueRef,
           rowreq_ctx->data.brokerBindingQueueRef,
           (rowreq_ctx->data.brokerBindingQueueRef_len *
            sizeof(rowreq_ctx->undo->brokerBindingQueueRef[0])));
    rowreq_ctx->undo->brokerBindingQueueRef_len =
        rowreq_ctx->data.brokerBindingQueueRef_len;


    return MFD_SUCCESS;
}                               /* brokerBindingQueueRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBindingQueueRef_val_ptr
 *        A char containing the new value.
 * @param brokerBindingQueueRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingQueueRef_val_ptr
 */
int
brokerBindingQueueRef_set(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                          char *brokerBindingQueueRef_val_ptr,
                          size_t brokerBindingQueueRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingQueueRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingQueueRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBindingQueueRef value.
     * set brokerBindingQueueRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBindingQueueRef,
           brokerBindingQueueRef_val_ptr,
           brokerBindingQueueRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBindingQueueRef_len =
        brokerBindingQueueRef_val_ptr_len /
        sizeof(brokerBindingQueueRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBindingQueueRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBindingQueueRef_undo(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingQueueRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBindingQueueRef undo.
     */
    /*
     * copy brokerBindingQueueRef and brokerBindingQueueRef_len data
     * set rowreq_ctx->data.brokerBindingQueueRef from rowreq_ctx->undo->brokerBindingQueueRef
     */
    memcpy(rowreq_ctx->data.brokerBindingQueueRef,
           rowreq_ctx->undo->brokerBindingQueueRef,
           (rowreq_ctx->undo->brokerBindingQueueRef_len *
            sizeof(rowreq_ctx->data.brokerBindingQueueRef[0])));
    rowreq_ctx->data.brokerBindingQueueRef_len =
        rowreq_ctx->undo->brokerBindingQueueRef_len;


    return MFD_SUCCESS;
}                               /* brokerBindingQueueRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingBindingKey
 * brokerBindingBindingKey is subid 3 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.3
 * Description:
Binding bindingKey
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Lstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingBindingKey_val_ptr
 *        A char containing the new value.
 * @param brokerBindingBindingKey_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingBindingKey_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBindingTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBindingBindingKey).
 *    The length is in (one of) the range set(s):  0 - 65535
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBindingBindingKey_check_value(brokerBindingTable_rowreq_ctx *
                                    rowreq_ctx,
                                    char *brokerBindingBindingKey_val_ptr,
                                    size_t
                                    brokerBindingBindingKey_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingBindingKey_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingBindingKey_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBindingBindingKey value.
     */

    return MFD_SUCCESS;         /* brokerBindingBindingKey value not illegal */
}                               /* brokerBindingBindingKey_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBindingTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBindingBindingKey_undo_setup(brokerBindingTable_rowreq_ctx *
                                   rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingBindingKey_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBindingBindingKey undo.
     */
    /*
     * copy brokerBindingBindingKey and brokerBindingBindingKey_len data
     * set rowreq_ctx->undo->brokerBindingBindingKey from rowreq_ctx->data.brokerBindingBindingKey
     */
    memcpy(rowreq_ctx->undo->brokerBindingBindingKey,
           rowreq_ctx->data.brokerBindingBindingKey,
           (rowreq_ctx->data.brokerBindingBindingKey_len *
            sizeof(rowreq_ctx->undo->brokerBindingBindingKey[0])));
    rowreq_ctx->undo->brokerBindingBindingKey_len =
        rowreq_ctx->data.brokerBindingBindingKey_len;


    return MFD_SUCCESS;
}                               /* brokerBindingBindingKey_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBindingBindingKey_val_ptr
 *        A char containing the new value.
 * @param brokerBindingBindingKey_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingBindingKey_val_ptr
 */
int
brokerBindingBindingKey_set(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                            char *brokerBindingBindingKey_val_ptr,
                            size_t brokerBindingBindingKey_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingBindingKey_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingBindingKey_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBindingBindingKey value.
     * set brokerBindingBindingKey value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBindingBindingKey,
           brokerBindingBindingKey_val_ptr,
           brokerBindingBindingKey_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBindingBindingKey_len =
        brokerBindingBindingKey_val_ptr_len /
        sizeof(brokerBindingBindingKey_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBindingBindingKey_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBindingBindingKey_undo(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingBindingKey_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBindingBindingKey undo.
     */
    /*
     * copy brokerBindingBindingKey and brokerBindingBindingKey_len data
     * set rowreq_ctx->data.brokerBindingBindingKey from rowreq_ctx->undo->brokerBindingBindingKey
     */
    memcpy(rowreq_ctx->data.brokerBindingBindingKey,
           rowreq_ctx->undo->brokerBindingBindingKey,
           (rowreq_ctx->undo->brokerBindingBindingKey_len *
            sizeof(rowreq_ctx->data.brokerBindingBindingKey[0])));
    rowreq_ctx->data.brokerBindingBindingKey_len =
        rowreq_ctx->undo->brokerBindingBindingKey_len;


    return MFD_SUCCESS;
}                               /* brokerBindingBindingKey_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBindingEntry.brokerBindingArguments
 * brokerBindingArguments is subid 4 of brokerBindingEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.8.1.1.4
 * Description:
Binding arguments
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Map (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBindingArguments_val_ptr
 *        A char containing the new value.
 * @param brokerBindingArguments_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingArguments_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBindingTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBindingArguments).
 *    The length is in (one of) the range set(s):  0 - 65535
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBindingArguments_check_value(brokerBindingTable_rowreq_ctx *
                                   rowreq_ctx,
                                   char *brokerBindingArguments_val_ptr,
                                   size_t
                                   brokerBindingArguments_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingArguments_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingArguments_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBindingArguments value.
     */

    return MFD_SUCCESS;         /* brokerBindingArguments value not illegal */
}                               /* brokerBindingArguments_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBindingTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBindingTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBindingArguments_undo_setup(brokerBindingTable_rowreq_ctx *
                                  rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingArguments_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBindingArguments undo.
     */
    /*
     * copy brokerBindingArguments and brokerBindingArguments_len data
     * set rowreq_ctx->undo->brokerBindingArguments from rowreq_ctx->data.brokerBindingArguments
     */
    memcpy(rowreq_ctx->undo->brokerBindingArguments,
           rowreq_ctx->data.brokerBindingArguments,
           (rowreq_ctx->data.brokerBindingArguments_len *
            sizeof(rowreq_ctx->undo->brokerBindingArguments[0])));
    rowreq_ctx->undo->brokerBindingArguments_len =
        rowreq_ctx->data.brokerBindingArguments_len;


    return MFD_SUCCESS;
}                               /* brokerBindingArguments_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBindingArguments_val_ptr
 *        A char containing the new value.
 * @param brokerBindingArguments_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBindingArguments_val_ptr
 */
int
brokerBindingArguments_set(brokerBindingTable_rowreq_ctx * rowreq_ctx,
                           char *brokerBindingArguments_val_ptr,
                           size_t brokerBindingArguments_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingArguments_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBindingArguments_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBindingArguments value.
     * set brokerBindingArguments value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBindingArguments,
           brokerBindingArguments_val_ptr,
           brokerBindingArguments_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBindingArguments_len =
        brokerBindingArguments_val_ptr_len /
        sizeof(brokerBindingArguments_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBindingArguments_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBindingArguments_undo(brokerBindingTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBindingTable:brokerBindingArguments_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBindingArguments undo.
     */
    /*
     * copy brokerBindingArguments and brokerBindingArguments_len data
     * set rowreq_ctx->data.brokerBindingArguments from rowreq_ctx->undo->brokerBindingArguments
     */
    memcpy(rowreq_ctx->data.brokerBindingArguments,
           rowreq_ctx->undo->brokerBindingArguments,
           (rowreq_ctx->undo->brokerBindingArguments_len *
            sizeof(rowreq_ctx->data.brokerBindingArguments[0])));
    rowreq_ctx->data.brokerBindingArguments_len =
        rowreq_ctx->undo->brokerBindingArguments_len;


    return MFD_SUCCESS;
}                               /* brokerBindingArguments_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBindingTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerBindingTable if you don't have dependencies)
 */
int
brokerBindingTable_check_dependencies(brokerBindingTable_rowreq_ctx *
                                      rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerBindingTable:brokerBindingTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerBindingTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerBindingTable_check_dependencies */

/** @} */
