/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/** \page MFD helper for brokerBridgeTable
 *
 * \section intro Introduction
 * Introductory text.
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "BridgeTable.h"

#include <net-snmp/agent/mib_modules.h>

#include "BridgeTable_interface.h"

const oid       brokerBridgeTable_oid[] = { brokerBRIDGETABLE_OID };

const int       brokerBridgeTable_oid_size =
OID_LENGTH(brokerBridgeTable_oid);

brokerBridgeTable_registration brokerBridgeTable_user_context;

void            initialize_table_brokerBridgeTable(void);
void            shutdown_table_brokerBridgeTable(void);


/**
 * Initializes the brokerBridgeTable module
 */
void
init_BridgeTable(void)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:init_brokerBridgeTable",
                "called\n"));

    /*
     * TODO:300:o: Perform brokerBridgeTable one-time module initialization.
     */

    /*
     * here we initialize all the tables we're planning on supporting
     */
    if (should_init("brokerBridgeTable")) {
        DEBUGMSGTL(("brokerBridgeTable:init_brokerBridgeTable",
                    "should_init\n"));
        initialize_table_brokerBridgeTable();
    }

}                               /* init_BridgeTable */

/**
 * Shut-down the brokerBridgeTable module (agent is exiting)
 */
void
shutdown_brokerBridgeTable(void)
{
    if (should_init("brokerBridgeTable"))
        shutdown_table_brokerBridgeTable();

}

/**
 * Initialize the table brokerBridgeTable 
 *    (Define its contents and how it's structured)
 */
void
initialize_table_brokerBridgeTable(void)
{
    brokerBridgeTable_registration *user_context;
    u_long          flags;

    DEBUGMSGTL(("verbose:brokerBridgeTable:initialize_table_brokerBridgeTable", "called\n"));

    /*
     * TODO:301:o: Perform brokerBridgeTable one-time table initialization.
     */

    /*
     * TODO:302:o: |->Initialize brokerBridgeTable user context
     * if you'd like to pass in a pointer to some data for this
     * table, allocate or set it up here.
     */
    /*
     * a netsnmp_data_list is a simple way to store void pointers. A simple
     * string token is used to add, find or remove pointers.
     */
    user_context =
        netsnmp_create_data_list("brokerBridgeTable", NULL, NULL);

    /*
     * No support for any flags yet, but in the future you would
     * set any flags here.
     */
    flags = 0;

    /*
     * call interface initialization code
     */
    _brokerBridgeTable_initialize_interface(user_context, flags);
}                               /* initialize_table_brokerBridgeTable */

/**
 * Shutdown the table brokerBridgeTable 
 */
void
shutdown_table_brokerBridgeTable(void)
{
    /*
     * call interface shutdown code
     */
    _brokerBridgeTable_shutdown_interface(&brokerBridgeTable_user_context);
}

/**
 * extra context initialization (eg default values)
 *
 * @param rowreq_ctx    : row request context
 * @param user_init_ctx : void pointer for user (parameter to rowreq_ctx_allocate)
 *
 * @retval MFD_SUCCESS  : no errors
 * @retval MFD_ERROR    : error (context allocate will fail)
 */
int
brokerBridgeTable_rowreq_ctx_init(brokerBridgeTable_rowreq_ctx *
                                  rowreq_ctx, void *user_init_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_rowreq_ctx_init", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * Perform extra brokerBridgeTable rowreq initialization. (eg DEFVALS)
     */
    rowreq_ctx->data.brokerBridgeLinkRef_len = 255;        /* # of char elements, not bytes */
    rowreq_ctx->data.brokerBridgeName_len = 255;
    rowreq_ctx->data.brokerBridgeSrc_len = 255;
    rowreq_ctx->data.brokerBridgeDest_len = 255;
    rowreq_ctx->data.brokerBridgeKey_len = 65535;
    rowreq_ctx->data.brokerBridgeTag_len = 255;
    rowreq_ctx->data.brokerBridgeExcludes_len = 255;

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_rowreq_ctx_init */

/**
 * extra context cleanup
 *
 */
void
brokerBridgeTable_rowreq_ctx_cleanup(brokerBridgeTable_rowreq_ctx *
                                     rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_rowreq_ctx_cleanup", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:211:o: |-> Perform extra brokerBridgeTable rowreq cleanup.
     */
}                               /* brokerBridgeTable_rowreq_ctx_cleanup */

/************************************************************
 * the *_should_save routine is called to determine if a row
 * should be stored persistently.
 *
 * Note that this is not a 'dirty' check (i.e. if a row has changed),
 * but a check for volatile rows that should not be saved between
 * restarts.
 *
 * return 1 if the row should be stored
 * return 0 if the row should not be stored
 */
int
brokerBridgeTable_container_should_save(brokerBridgeTable_rowreq_ctx *
                                        rowreq_ctx)
{

    return 1;                   /* save the row */
}

/**
 * pre-request callback
 *
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_ERROR                : other error
 */
int
brokerBridgeTable_pre_request(brokerBridgeTable_registration *
                              user_context)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_pre_request",
                "called\n"));

    /*
     * TODO:510:o: Perform brokerBridgeTable pre-request actions.
     */

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_pre_request */

/**
 * post-request callback
 *
 * Note:
 *   New rows have been inserted into the container, and
 *   deleted rows have been removed from the container and
 *   released.
 *
 * @param user_context
 * @param rc : MFD_SUCCESS if all requests succeeded
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : other error (ignored)
 */
int
brokerBridgeTable_post_request(brokerBridgeTable_registration *
                               user_context, int rc)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_post_request",
                "called\n"));

    /*
     * TODO:511:o: Perform brokerBridgeTable post-request actions.
     */

    /*
     * check to set if any rows were changed.
     */
    if (brokerBridgeTable_dirty_get()) {
        /*
         * check if request was successful. If so, this would be
         * a good place to save data to its persistent store.
         */
        if (MFD_SUCCESS == rc) {
            /*
             * save changed rows, if you haven't already
             */
            snmp_store(netsnmp_ds_get_string(NETSNMP_DS_LIBRARY_ID,
                                             NETSNMP_DS_LIB_APPTYPE));
        }

        brokerBridgeTable_dirty_set(0); /* clear table dirty flag */
    }

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_post_request */


/** @{ */
