/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../qpid_api.h"

/*
 * include our parent header 
 */
#include "BridgeTable.h"


#include "BridgeTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerBridgeTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerBridgeTable is subid 1 of brokerBridges.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1, length: 11
 */

/**
 * initialization for brokerBridgeTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param brokerBridgeTable_reg
 *        Pointer to brokerBridgeTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
brokerBridgeTable_init_data(brokerBridgeTable_registration *
                            brokerBridgeTable_reg)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_init_data",
                "called\n"));

    /*
     * TODO:303:o: Initialize brokerBridgeTable data.
     */
    /*
     ***************************************************
     ***             START EXAMPLE CODE              ***
     ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
     ***---------------------------------------------***
     ***              END  EXAMPLE CODE              ***
     ***************************************************/

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
brokerBridgeTable_container_init(netsnmp_container ** container_ptr_ptr,
                                 netsnmp_cache * cache)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_container_init", "called\n"));

    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,
                 "bad container param to brokerBridgeTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,
                 "bad cache param to brokerBridgeTable_container_init\n");
        return;
    }

    /*
     * TODO:345:A: Set up brokerBridgeTable cache properties.
     *
     * Also for advanced users, you can set parameters for the
     * cache. Do not change the magic pointer, as it is used
     * by the MFD helper. To completely disable caching, set
     * cache->enabled to 0.
     */
    cache->timeout = brokerBRIDGETABLE_CACHE_TIMEOUT;   /* seconds */
}                               /* brokerBridgeTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before brokerBridgeTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
brokerBridgeTable_container_shutdown(netsnmp_container * container_ptr)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_container_shutdown", "called\n"));

    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,
                 "bad params to brokerBridgeTable_container_shutdown\n");
        return;
    }

}                               /* brokerBridgeTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement brokerBridgeTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  brokerBridgeTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
brokerBridgeTable_container_load(netsnmp_container * container)
{
    brokerBridgeTable_rowreq_ctx *rowreq_ctx;

    /*
     * temporary storage for index values
     */
    /*
     * brokerBridgeInternalIndex(14)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h
     */
    u_long          brokerBridgeInternalIndex;
    brokerBridgeTable_data qmfData;

    void *pEvent = qpidGet("bridge");

    int index;
    uint objects;
    objects = qpidGetCount(pEvent);

    brokerBridgeInternalIndex = 0;
    for (index = 0; index < objects; ++index) {

    	void * pRow = qpidGetDataRow(pEvent, index);
    	if (!pRow)
    		continue;

    	strncpy(qmfData.brokerBridgeLinkRef,
    	        		qpidGetString(pRow, "linkRef"), 254);
    	        qmfData.brokerBridgeLinkRef_len = strlen(qmfData.brokerBridgeLinkRef) + 1;

		strncpy(qmfData.brokerBridgeName,
						qpidGetString(pRow, "name"), 254);
				qmfData.brokerBridgeName_len = strlen(qmfData.brokerBridgeName) + 1;

        qmfData.brokerBridgeChannelId = qpidGetU16(pRow, "channelId");
        qmfData.brokerBridgeDurable = qpidGetBool(pRow, "durable");

        strncpy(qmfData.brokerBridgeSrc,
        		qpidGetString(pRow, "src"), 254);
        qmfData.brokerBridgeSrc_len = strlen(qmfData.brokerBridgeSrc) + 1;

        strncpy(qmfData.brokerBridgeDest,
        		qpidGetString(pRow, "dest"), 254);
        qmfData.brokerBridgeDest_len = strlen(qmfData.brokerBridgeDest) + 1;

        strncpy(qmfData.brokerBridgeKey,
        		qpidGetString(pRow, "key"), 65534);
        qmfData.brokerBridgeKey_len = strlen(qmfData.brokerBridgeKey) + 1;

        qmfData.brokerBridgeSrcIsQueue = qpidGetBool(pRow, "srcIsQueue");
        qmfData.brokerBridgeSrcIsLocal = qpidGetBool(pRow, "srcIsLocal");

        strncpy(qmfData.brokerBridgeTag,
        		qpidGetString(pRow, "tag"), 254);
        qmfData.brokerBridgeTag_len = strlen(qmfData.brokerBridgeTag) + 1;

        strncpy(qmfData.brokerBridgeExcludes,
        		qpidGetString(pRow, "excludes"), 254);
        qmfData.brokerBridgeExcludes_len = strlen(qmfData.brokerBridgeExcludes) + 1;

        qmfData.brokerBridgeDynamic = qpidGetBool(pRow, "dynamic");
        qmfData.brokerBridgeSync = qpidGetU16(pRow, "sync");

        /*
         * TODO:352:M: |   |-> set indexes in new brokerBridgeTable rowreq context.
         * data context will be set from the param (unless NULL,
         *      in which case a new data context will be allocated)
         */
        rowreq_ctx = brokerBridgeTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if (MFD_SUCCESS !=
            brokerBridgeTable_indexes_set(rowreq_ctx,
                                          brokerBridgeInternalIndex)) {
            snmp_log(LOG_ERR,
                     "error setting index while loading "
                     "brokerBridgeTable data.\n");
            brokerBridgeTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }
        brokerBridgeInternalIndex++;

        /*
         * setup/save data for brokerBridgeLinkRef
         * brokerBridgeLinkRef(1)/ObjId/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeLinkRef data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeLinkRef) ||
            (rowreq_ctx->data.brokerBridgeLinkRef_len <
             (qmfData.brokerBridgeLinkRef_len * sizeof(qmfData.brokerBridgeLinkRef[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeLinkRef)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeLinkRef_len =
        		qmfData.brokerBridgeLinkRef_len * sizeof(qmfData.brokerBridgeLinkRef[0]);
        memcpy(rowreq_ctx->data.brokerBridgeLinkRef, qmfData.brokerBridgeLinkRef,
        		qmfData.brokerBridgeLinkRef_len * sizeof(qmfData.brokerBridgeLinkRef[0]));

        /*
         * setup/save data for brokerBridgeName
         * brokerBridgeName(2)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeName data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeName) ||
            (rowreq_ctx->data.brokerBridgeName_len <
             (qmfData.brokerBridgeName_len * sizeof(qmfData.brokerBridgeName[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeName)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeName_len =
        		qmfData.brokerBridgeName_len * sizeof(qmfData.brokerBridgeName[0]);
        memcpy(rowreq_ctx->data.brokerBridgeName, qmfData.brokerBridgeName,
        		qmfData.brokerBridgeName_len * sizeof(qmfData.brokerBridgeName[0]));

        /*
         * setup/save data for brokerBridgeChannelId
         * brokerBridgeChannelId(3)/Uint16/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerBridgeChannelId = qmfData.brokerBridgeChannelId;

        /*
         * setup/save data for brokerBridgeDurable
         * brokerBridgeDurable(4)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** truthvalue mapping */
        rowreq_ctx->data.brokerBridgeDurable = qmfData.brokerBridgeDurable == 0 ? TRUTHVALUE_FALSE: TRUTHVALUE_TRUE;

        /*
         * setup/save data for brokerBridgeSrc
         * brokerBridgeSrc(4)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeSrc data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeSrc) ||
            (rowreq_ctx->data.brokerBridgeSrc_len <
             (qmfData.brokerBridgeSrc_len * sizeof(qmfData.brokerBridgeSrc[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeSrc)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeSrc_len =
        		qmfData.brokerBridgeSrc_len * sizeof(qmfData.brokerBridgeSrc[0]);
        memcpy(rowreq_ctx->data.brokerBridgeSrc, qmfData.brokerBridgeSrc,
        		qmfData.brokerBridgeSrc_len * sizeof(qmfData.brokerBridgeSrc[0]));

        /*
         * setup/save data for brokerBridgeDest
         * brokerBridgeDest(5)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeDest data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeDest) ||
            (rowreq_ctx->data.brokerBridgeDest_len <
             (qmfData.brokerBridgeDest_len * sizeof(qmfData.brokerBridgeDest[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeDest)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeDest_len =
        		qmfData.brokerBridgeDest_len * sizeof(qmfData.brokerBridgeDest[0]);
        memcpy(rowreq_ctx->data.brokerBridgeDest, qmfData.brokerBridgeDest,
        		qmfData.brokerBridgeDest_len * sizeof(qmfData.brokerBridgeDest[0]));

        /*
         * setup/save data for brokerBridgeKey
         * brokerBridgeKey(6)/Lstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeKey data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeKey) ||
            (rowreq_ctx->data.brokerBridgeKey_len <
             (qmfData.brokerBridgeKey_len * sizeof(qmfData.brokerBridgeKey[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeKey)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeKey_len =
        		qmfData.brokerBridgeKey_len * sizeof(qmfData.brokerBridgeKey[0]);
        memcpy(rowreq_ctx->data.brokerBridgeKey, qmfData.brokerBridgeKey,
        		qmfData.brokerBridgeKey_len * sizeof(qmfData.brokerBridgeKey[0]));

        /*
         * setup/save data for brokerBridgeSrcIsQueue
         * brokerBridgeSrcIsQueue(7)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** truth value mapping*/
        rowreq_ctx->data.brokerBridgeSrcIsQueue = qmfData.brokerBridgeSrcIsQueue == 0 ? TRUTHVALUE_FALSE : TRUTHVALUE_TRUE;

        /*
         * setup/save data for brokerBridgeSrcIsLocal
         * brokerBridgeSrcIsLocal(8)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** truth mapping */
        rowreq_ctx->data.brokerBridgeSrcIsLocal = qmfData.brokerBridgeSrcIsLocal == 0 ? TRUTHVALUE_FALSE : TRUTHVALUE_TRUE;

        /*
         * setup/save data for brokerBridgeTag
         * brokerBridgeTag(9)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeTag data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeTag) ||
            (rowreq_ctx->data.brokerBridgeTag_len <
             (qmfData.brokerBridgeTag_len * sizeof(qmfData.brokerBridgeTag[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeTag)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeTag_len =
        		qmfData.brokerBridgeTag_len * sizeof(qmfData.brokerBridgeTag[0]);
        memcpy(rowreq_ctx->data.brokerBridgeTag, qmfData.brokerBridgeTag,
        		qmfData.brokerBridgeTag_len * sizeof(qmfData.brokerBridgeTag[0]));

        /*
         * setup/save data for brokerBridgeExcludes
         * brokerBridgeExcludes(10)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerBridgeExcludes data
         */
        if ((NULL == rowreq_ctx->data.brokerBridgeExcludes) ||
            (rowreq_ctx->data.brokerBridgeExcludes_len <
             (qmfData.brokerBridgeExcludes_len *
              sizeof(qmfData.brokerBridgeExcludes[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerBridgeExcludes)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerBridgeExcludes_len =
        		qmfData.brokerBridgeExcludes_len * sizeof(qmfData.brokerBridgeExcludes[0]);
        memcpy(rowreq_ctx->data.brokerBridgeExcludes, qmfData.brokerBridgeExcludes,
        		qmfData.brokerBridgeExcludes_len * sizeof(qmfData.brokerBridgeExcludes[0]));

        /*
         * setup/save data for brokerBridgeDynamic
         * brokerBridgeDynamic(11)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** truth mapping */
        rowreq_ctx->data.brokerBridgeDynamic = qmfData.brokerBridgeDynamic == 0 ? TRUTHVALUE_FALSE : TRUTHVALUE_TRUE;

        /*
         * setup/save data for brokerBridgeSync
         * brokerBridgeSync(12)/Uint16/ASN_INTEGER/long(long)//l/A/W/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerBridgeSync = qmfData.brokerBridgeSync;


        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        qpidReleaseDataRow(pRow);
    }
    qpidRelease(pEvent);

    DEBUGMSGT(("verbose:brokerBridgeTable:brokerBridgeTable_container_load", "inserted %d records\n", index));

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
brokerBridgeTable_container_free(netsnmp_container * container)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_container_free", "called\n"));

    /*
     * TODO:380:M: Free brokerBridgeTable container data.
     */
}                               /* brokerBridgeTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
brokerBridgeTable_row_prep(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_row_prep",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
}                               /* brokerBridgeTable_row_prep */

/*
 * TODO:420:r: Implement brokerBridgeTable index validation.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeInternalIndex
 * brokerBridgeInternalIndex is subid 14 of brokerBridgeEntry.
 * Its status is Current, and its access level is NoAccess.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.14
 * Description:
Internal index for bridge table
 *
 * Attributes:
 *   accessible 0     isscalar 0     enums  0      hasdefval 0
 *   readable   0     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 *
 *
 *
 * NOTE: NODE brokerBridgeInternalIndex IS NOT ACCESSIBLE
 *
 *
 */
/**
 * check validity of brokerBridgeInternalIndex index portion
 *
 * @retval MFD_SUCCESS   : the incoming value is legal
 * @retval MFD_ERROR     : the incoming value is NOT legal
 *
 * @note this is not the place to do any checks for the sanity
 *       of multiple indexes. Those types of checks should be done in the
 *       brokerBridgeTable_validate_index() function.
 *
 * @note Also keep in mind that if the index refers to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 * The following checks have already been done for you:
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 */
int
brokerBridgeInternalIndex_check_index(brokerBridgeTable_rowreq_ctx *
                                      rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeInternalIndex_check_index", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:426:M: |-> Check brokerBridgeTable index brokerBridgeInternalIndex.
     * check that index value in the table context is legal.
     * (rowreq_ctx->tbl_index.brokerBridgeInternalIndex)
     */

    return MFD_SUCCESS;         /* brokerBridgeInternalIndex index ok */
}                               /* brokerBridgeInternalIndex_check_index */

/**
 * verify specified index is valid.
 *
 * This check is independent of whether or not the values specified for
 * the columns of the new row are valid. Column values and row consistency
 * will be checked later. At this point, only the index values should be
 * checked.
 *
 * All of the individual index validation functions have been called, so this
 * is the place to make sure they are valid as a whole when combined. If
 * you only have one index, then you probably don't need to do anything else
 * here.
 * 
 * @note Keep in mind that if the indexes refer to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 *
 * @param brokerBridgeTable_reg
 *        Pointer to the user registration data
 * @param brokerBridgeTable_rowreq_ctx
 *        Pointer to the users context.
 * @retval MFD_SUCCESS            : success
 * @retval MFD_CANNOT_CREATE_NOW  : index not valid right now
 * @retval MFD_CANNOT_CREATE_EVER : index never valid
 */
int
brokerBridgeTable_validate_index(brokerBridgeTable_registration *
                                 brokerBridgeTable_reg,
                                 brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_validate_index", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:430:M: |-> Validate potential brokerBridgeTable index.
     */
    if (1) {
        snmp_log(LOG_WARNING, "invalid index for a new row in the "
                 "brokerBridgeTable table.\n");
        /*
         * determine failure type.
         *
         * If the index could not ever be created, return MFD_NOT_EVER
         * If the index can not be created under the present circumstances
         * (even though it could be created under other circumstances),
         * return MFD_NOT_NOW.
         */
        if (0) {
            return MFD_CANNOT_CREATE_EVER;
        } else {
            return MFD_CANNOT_CREATE_NOW;
        }
    }

    return rc;
}                               /* brokerBridgeTable_validate_index */

/** @} */
