/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "BridgeTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerBridgeTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerBridgeTable is subid 1 of brokerBridges.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1, length: 11
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerBridgeTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerBridgeTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerBridgeTable_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_undo_setup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerBridgeTable undo.
     * set up brokerBridgeTable undo information, in preparation for a set.
     * Undo storage is in (* brokerBridgeSync_val_ptr )*
     */

    return rc;
}                               /* brokerBridgeTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerBridgeTable_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerBridgeTable undo.
     * brokerBridgeTable undo information, in response to a failed set.
     * Undo storage is in (* brokerBridgeSync_val_ptr )*
     */

    return rc;
}                               /* brokerBridgeTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBridgeTable_undo_cleanup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_undo_cleanup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerBridgeTable undo.
     * Undo storage is in (* brokerBridgeSync_val_ptr )*
     */

    return rc;
}                               /* brokerBridgeTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBridgeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerBridgeTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBridgeTable_commit(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerBridgeTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerBRIDGELINKREF_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGELINKREF_FLAG; /* clear brokerBridgeLinkRef */
        /*
         * TODO:482:o: |-> commit column brokerBridgeLinkRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeLinkRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeLinkRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGELINKREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGENAME_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGENAME_FLAG;    /* clear brokerBridgeName */
        /*
         * TODO:482:o: |-> commit column brokerBridgeName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeName
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGENAME_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGEDURABLE_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGEDURABLE_FLAG; /* clear brokerBridgeDurable */
        /*
         * TODO:482:o: |-> commit column brokerBridgeDurable.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeDurable commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeDurable
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGEDURABLE_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGESRC_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGESRC_FLAG;     /* clear brokerBridgeSrc */
        /*
         * TODO:482:o: |-> commit column brokerBridgeSrc.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeSrc commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeSrc
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGESRC_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGEDEST_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGEDEST_FLAG;    /* clear brokerBridgeDest */
        /*
         * TODO:482:o: |-> commit column brokerBridgeDest.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeDest commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeDest
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGEDEST_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGEKEY_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGEKEY_FLAG;     /* clear brokerBridgeKey */
        /*
         * TODO:482:o: |-> commit column brokerBridgeKey.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeKey commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeKey
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGEKEY_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGESRCISQUEUE_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGESRCISQUEUE_FLAG;      /* clear brokerBridgeSrcIsQueue */
        /*
         * TODO:482:o: |-> commit column brokerBridgeSrcIsQueue.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeSrcIsQueue commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeSrcIsQueue
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGESRCISQUEUE_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGESRCISLOCAL_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGESRCISLOCAL_FLAG;      /* clear brokerBridgeSrcIsLocal */
        /*
         * TODO:482:o: |-> commit column brokerBridgeSrcIsLocal.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeSrcIsLocal commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeSrcIsLocal
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGESRCISLOCAL_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGETAG_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGETAG_FLAG;     /* clear brokerBridgeTag */
        /*
         * TODO:482:o: |-> commit column brokerBridgeTag.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeTag commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeTag
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGETAG_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGEEXCLUDES_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGEEXCLUDES_FLAG;        /* clear brokerBridgeExcludes */
        /*
         * TODO:482:o: |-> commit column brokerBridgeExcludes.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeExcludes commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeExcludes
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGEEXCLUDES_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGEDYNAMIC_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGEDYNAMIC_FLAG; /* clear brokerBridgeDynamic */
        /*
         * TODO:482:o: |-> commit column brokerBridgeDynamic.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeDynamic commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeDynamic
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerBRIDGEDYNAMIC_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerBRIDGESYNC_FLAG) {
        save_flags &= ~COLUMN_brokerBRIDGESYNC_FLAG;    /* clear brokerBridgeSync */
        /*
         * TODO:482:o: |-> commit column brokerBridgeSync.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerBridgeTable column brokerBridgeSync commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerBridgeSync
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerBRIDGESYNC_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerBridgeTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBridgeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerBridgeTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerBridgeTable_undo_commit(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTable_undo_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerBridgeTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerBridgeTable_undo_commit */

/*
 * TODO:440:M: Implement brokerBridgeTable node value checks.
 * TODO:450:M: Implement brokerBridgeTable undo functions.
 * TODO:460:M: Implement brokerBridgeTable set functions.
 * TODO:480:M: Implement brokerBridgeTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeLinkRef
 * brokerBridgeLinkRef is subid 1 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.1
 * Description:
Bridge linkRef
                     Additional info ( nodeType:property, references:Link, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeLinkRef_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeLinkRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeLinkRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeLinkRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeLinkRef_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                                char *brokerBridgeLinkRef_val_ptr,
                                size_t brokerBridgeLinkRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeLinkRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeLinkRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeLinkRef value.
     */

    return MFD_SUCCESS;         /* brokerBridgeLinkRef value not illegal */
}                               /* brokerBridgeLinkRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeLinkRef_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeLinkRef_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeLinkRef undo.
     */
    /*
     * copy brokerBridgeLinkRef and brokerBridgeLinkRef_len data
     * set rowreq_ctx->undo->brokerBridgeLinkRef from rowreq_ctx->data.brokerBridgeLinkRef
     */
    memcpy(rowreq_ctx->undo->brokerBridgeLinkRef,
           rowreq_ctx->data.brokerBridgeLinkRef,
           (rowreq_ctx->data.brokerBridgeLinkRef_len *
            sizeof(rowreq_ctx->undo->brokerBridgeLinkRef[0])));
    rowreq_ctx->undo->brokerBridgeLinkRef_len =
        rowreq_ctx->data.brokerBridgeLinkRef_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeLinkRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeLinkRef_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeLinkRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeLinkRef_val_ptr
 */
int
brokerBridgeLinkRef_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                        char *brokerBridgeLinkRef_val_ptr,
                        size_t brokerBridgeLinkRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeLinkRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeLinkRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeLinkRef value.
     * set brokerBridgeLinkRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeLinkRef,
           brokerBridgeLinkRef_val_ptr, brokerBridgeLinkRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeLinkRef_len =
        brokerBridgeLinkRef_val_ptr_len /
        sizeof(brokerBridgeLinkRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeLinkRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeLinkRef_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeLinkRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeLinkRef undo.
     */
    /*
     * copy brokerBridgeLinkRef and brokerBridgeLinkRef_len data
     * set rowreq_ctx->data.brokerBridgeLinkRef from rowreq_ctx->undo->brokerBridgeLinkRef
     */
    memcpy(rowreq_ctx->data.brokerBridgeLinkRef,
           rowreq_ctx->undo->brokerBridgeLinkRef,
           (rowreq_ctx->undo->brokerBridgeLinkRef_len *
            sizeof(rowreq_ctx->data.brokerBridgeLinkRef[0])));
    rowreq_ctx->data.brokerBridgeLinkRef_len =
        rowreq_ctx->undo->brokerBridgeLinkRef_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeLinkRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeName
 * brokerBridgeName is subid 2 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.2
 * Description:
Bridge name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeName_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeName_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                             char *brokerBridgeName_val_ptr,
                             size_t brokerBridgeName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeName_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeName value.
     */

    return MFD_SUCCESS;         /* brokerBridgeName value not illegal */
}                               /* brokerBridgeName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeName_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeName_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeName undo.
     */
    /*
     * copy brokerBridgeName and brokerBridgeName_len data
     * set rowreq_ctx->undo->brokerBridgeName from rowreq_ctx->data.brokerBridgeName
     */
    memcpy(rowreq_ctx->undo->brokerBridgeName,
           rowreq_ctx->data.brokerBridgeName,
           (rowreq_ctx->data.brokerBridgeName_len *
            sizeof(rowreq_ctx->undo->brokerBridgeName[0])));
    rowreq_ctx->undo->brokerBridgeName_len =
        rowreq_ctx->data.brokerBridgeName_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeName_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeName_val_ptr
 */
int
brokerBridgeName_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                     char *brokerBridgeName_val_ptr,
                     size_t brokerBridgeName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeName_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeName value.
     * set brokerBridgeName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeName, brokerBridgeName_val_ptr,
           brokerBridgeName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeName_len =
        brokerBridgeName_val_ptr_len / sizeof(brokerBridgeName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeName_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeName_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeName undo.
     */
    /*
     * copy brokerBridgeName and brokerBridgeName_len data
     * set rowreq_ctx->data.brokerBridgeName from rowreq_ctx->undo->brokerBridgeName
     */
    memcpy(rowreq_ctx->data.brokerBridgeName,
           rowreq_ctx->undo->brokerBridgeName,
           (rowreq_ctx->undo->brokerBridgeName_len *
            sizeof(rowreq_ctx->data.brokerBridgeName[0])));
    rowreq_ctx->data.brokerBridgeName_len =
        rowreq_ctx->undo->brokerBridgeName_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeName_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeDurable
 * brokerBridgeDurable is subid 4 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.4
 * Description:
Bridge durable
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeDurable_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeDurable_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                                u_long brokerBridgeDurable_val)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDurable_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeDurable value.
     */

    return MFD_SUCCESS;         /* brokerBridgeDurable value not illegal */
}                               /* brokerBridgeDurable_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeDurable_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDurable_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeDurable undo.
     */
    /*
     * copy brokerBridgeDurable data
     * set rowreq_ctx->undo->brokerBridgeDurable from rowreq_ctx->data.brokerBridgeDurable
     */
    rowreq_ctx->undo->brokerBridgeDurable =
        rowreq_ctx->data.brokerBridgeDurable;


    return MFD_SUCCESS;
}                               /* brokerBridgeDurable_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeDurable_val
 *        A long containing the new value.
 */
int
brokerBridgeDurable_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                        u_long brokerBridgeDurable_val)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDurable_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerBridgeDurable value.
     * set brokerBridgeDurable value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerBridgeDurable = brokerBridgeDurable_val;

    return MFD_SUCCESS;
}                               /* brokerBridgeDurable_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeDurable_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDurable_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeDurable undo.
     */
    /*
     * copy brokerBridgeDurable data
     * set rowreq_ctx->data.brokerBridgeDurable from rowreq_ctx->undo->brokerBridgeDurable
     */
    rowreq_ctx->data.brokerBridgeDurable =
        rowreq_ctx->undo->brokerBridgeDurable;


    return MFD_SUCCESS;
}                               /* brokerBridgeDurable_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeSrc
 * brokerBridgeSrc is subid 5 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.5
 * Description:
Bridge src
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeSrc_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeSrc_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeSrc_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeSrc).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeSrc_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                            char *brokerBridgeSrc_val_ptr,
                            size_t brokerBridgeSrc_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrc_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeSrc_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeSrc value.
     */

    return MFD_SUCCESS;         /* brokerBridgeSrc value not illegal */
}                               /* brokerBridgeSrc_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeSrc_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrc_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeSrc undo.
     */
    /*
     * copy brokerBridgeSrc and brokerBridgeSrc_len data
     * set rowreq_ctx->undo->brokerBridgeSrc from rowreq_ctx->data.brokerBridgeSrc
     */
    memcpy(rowreq_ctx->undo->brokerBridgeSrc,
           rowreq_ctx->data.brokerBridgeSrc,
           (rowreq_ctx->data.brokerBridgeSrc_len *
            sizeof(rowreq_ctx->undo->brokerBridgeSrc[0])));
    rowreq_ctx->undo->brokerBridgeSrc_len =
        rowreq_ctx->data.brokerBridgeSrc_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrc_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeSrc_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeSrc_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeSrc_val_ptr
 */
int
brokerBridgeSrc_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                    char *brokerBridgeSrc_val_ptr,
                    size_t brokerBridgeSrc_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrc_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeSrc_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeSrc value.
     * set brokerBridgeSrc value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeSrc, brokerBridgeSrc_val_ptr,
           brokerBridgeSrc_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeSrc_len =
        brokerBridgeSrc_val_ptr_len / sizeof(brokerBridgeSrc_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeSrc_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeSrc_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrc_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeSrc undo.
     */
    /*
     * copy brokerBridgeSrc and brokerBridgeSrc_len data
     * set rowreq_ctx->data.brokerBridgeSrc from rowreq_ctx->undo->brokerBridgeSrc
     */
    memcpy(rowreq_ctx->data.brokerBridgeSrc,
           rowreq_ctx->undo->brokerBridgeSrc,
           (rowreq_ctx->undo->brokerBridgeSrc_len *
            sizeof(rowreq_ctx->data.brokerBridgeSrc[0])));
    rowreq_ctx->data.brokerBridgeSrc_len =
        rowreq_ctx->undo->brokerBridgeSrc_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrc_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeDest
 * brokerBridgeDest is subid 6 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.6
 * Description:
Bridge dest
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeDest_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeDest_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeDest_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeDest).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeDest_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                             char *brokerBridgeDest_val_ptr,
                             size_t brokerBridgeDest_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDest_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeDest_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeDest value.
     */

    return MFD_SUCCESS;         /* brokerBridgeDest value not illegal */
}                               /* brokerBridgeDest_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeDest_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDest_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeDest undo.
     */
    /*
     * copy brokerBridgeDest and brokerBridgeDest_len data
     * set rowreq_ctx->undo->brokerBridgeDest from rowreq_ctx->data.brokerBridgeDest
     */
    memcpy(rowreq_ctx->undo->brokerBridgeDest,
           rowreq_ctx->data.brokerBridgeDest,
           (rowreq_ctx->data.brokerBridgeDest_len *
            sizeof(rowreq_ctx->undo->brokerBridgeDest[0])));
    rowreq_ctx->undo->brokerBridgeDest_len =
        rowreq_ctx->data.brokerBridgeDest_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeDest_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeDest_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeDest_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeDest_val_ptr
 */
int
brokerBridgeDest_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                     char *brokerBridgeDest_val_ptr,
                     size_t brokerBridgeDest_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDest_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeDest_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeDest value.
     * set brokerBridgeDest value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeDest, brokerBridgeDest_val_ptr,
           brokerBridgeDest_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeDest_len =
        brokerBridgeDest_val_ptr_len / sizeof(brokerBridgeDest_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeDest_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeDest_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDest_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeDest undo.
     */
    /*
     * copy brokerBridgeDest and brokerBridgeDest_len data
     * set rowreq_ctx->data.brokerBridgeDest from rowreq_ctx->undo->brokerBridgeDest
     */
    memcpy(rowreq_ctx->data.brokerBridgeDest,
           rowreq_ctx->undo->brokerBridgeDest,
           (rowreq_ctx->undo->brokerBridgeDest_len *
            sizeof(rowreq_ctx->data.brokerBridgeDest[0])));
    rowreq_ctx->data.brokerBridgeDest_len =
        rowreq_ctx->undo->brokerBridgeDest_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeDest_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeKey
 * brokerBridgeKey is subid 7 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.7
 * Description:
Bridge key
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Lstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeKey_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeKey_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeKey_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeKey).
 *    The length is in (one of) the range set(s):  0 - 65535
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeKey_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                            char *brokerBridgeKey_val_ptr,
                            size_t brokerBridgeKey_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeKey_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeKey_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeKey value.
     */

    return MFD_SUCCESS;         /* brokerBridgeKey value not illegal */
}                               /* brokerBridgeKey_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeKey_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeKey_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeKey undo.
     */
    /*
     * copy brokerBridgeKey and brokerBridgeKey_len data
     * set rowreq_ctx->undo->brokerBridgeKey from rowreq_ctx->data.brokerBridgeKey
     */
    memcpy(rowreq_ctx->undo->brokerBridgeKey,
           rowreq_ctx->data.brokerBridgeKey,
           (rowreq_ctx->data.brokerBridgeKey_len *
            sizeof(rowreq_ctx->undo->brokerBridgeKey[0])));
    rowreq_ctx->undo->brokerBridgeKey_len =
        rowreq_ctx->data.brokerBridgeKey_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeKey_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeKey_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeKey_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeKey_val_ptr
 */
int
brokerBridgeKey_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                    char *brokerBridgeKey_val_ptr,
                    size_t brokerBridgeKey_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeKey_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeKey_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeKey value.
     * set brokerBridgeKey value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeKey, brokerBridgeKey_val_ptr,
           brokerBridgeKey_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeKey_len =
        brokerBridgeKey_val_ptr_len / sizeof(brokerBridgeKey_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeKey_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeKey_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeKey_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeKey undo.
     */
    /*
     * copy brokerBridgeKey and brokerBridgeKey_len data
     * set rowreq_ctx->data.brokerBridgeKey from rowreq_ctx->undo->brokerBridgeKey
     */
    memcpy(rowreq_ctx->data.brokerBridgeKey,
           rowreq_ctx->undo->brokerBridgeKey,
           (rowreq_ctx->undo->brokerBridgeKey_len *
            sizeof(rowreq_ctx->data.brokerBridgeKey[0])));
    rowreq_ctx->data.brokerBridgeKey_len =
        rowreq_ctx->undo->brokerBridgeKey_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeKey_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeSrcIsQueue
 * brokerBridgeSrcIsQueue is subid 8 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.8
 * Description:
Bridge srcIsQueue
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeSrcIsQueue_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeSrcIsQueue_check_value(brokerBridgeTable_rowreq_ctx *
                                   rowreq_ctx,
                                   u_long brokerBridgeSrcIsQueue_val)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsQueue_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeSrcIsQueue value.
     */

    return MFD_SUCCESS;         /* brokerBridgeSrcIsQueue value not illegal */
}                               /* brokerBridgeSrcIsQueue_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeSrcIsQueue_undo_setup(brokerBridgeTable_rowreq_ctx *
                                  rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsQueue_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeSrcIsQueue undo.
     */
    /*
     * copy brokerBridgeSrcIsQueue data
     * set rowreq_ctx->undo->brokerBridgeSrcIsQueue from rowreq_ctx->data.brokerBridgeSrcIsQueue
     */
    rowreq_ctx->undo->brokerBridgeSrcIsQueue =
        rowreq_ctx->data.brokerBridgeSrcIsQueue;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsQueue_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeSrcIsQueue_val
 *        A long containing the new value.
 */
int
brokerBridgeSrcIsQueue_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                           u_long brokerBridgeSrcIsQueue_val)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsQueue_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerBridgeSrcIsQueue value.
     * set brokerBridgeSrcIsQueue value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerBridgeSrcIsQueue = brokerBridgeSrcIsQueue_val;

    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsQueue_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeSrcIsQueue_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsQueue_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeSrcIsQueue undo.
     */
    /*
     * copy brokerBridgeSrcIsQueue data
     * set rowreq_ctx->data.brokerBridgeSrcIsQueue from rowreq_ctx->undo->brokerBridgeSrcIsQueue
     */
    rowreq_ctx->data.brokerBridgeSrcIsQueue =
        rowreq_ctx->undo->brokerBridgeSrcIsQueue;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsQueue_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeSrcIsLocal
 * brokerBridgeSrcIsLocal is subid 9 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.9
 * Description:
Bridge srcIsLocal
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeSrcIsLocal_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeSrcIsLocal_check_value(brokerBridgeTable_rowreq_ctx *
                                   rowreq_ctx,
                                   u_long brokerBridgeSrcIsLocal_val)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsLocal_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeSrcIsLocal value.
     */

    return MFD_SUCCESS;         /* brokerBridgeSrcIsLocal value not illegal */
}                               /* brokerBridgeSrcIsLocal_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeSrcIsLocal_undo_setup(brokerBridgeTable_rowreq_ctx *
                                  rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsLocal_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeSrcIsLocal undo.
     */
    /*
     * copy brokerBridgeSrcIsLocal data
     * set rowreq_ctx->undo->brokerBridgeSrcIsLocal from rowreq_ctx->data.brokerBridgeSrcIsLocal
     */
    rowreq_ctx->undo->brokerBridgeSrcIsLocal =
        rowreq_ctx->data.brokerBridgeSrcIsLocal;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsLocal_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeSrcIsLocal_val
 *        A long containing the new value.
 */
int
brokerBridgeSrcIsLocal_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                           u_long brokerBridgeSrcIsLocal_val)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsLocal_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerBridgeSrcIsLocal value.
     * set brokerBridgeSrcIsLocal value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerBridgeSrcIsLocal = brokerBridgeSrcIsLocal_val;

    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsLocal_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeSrcIsLocal_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSrcIsLocal_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeSrcIsLocal undo.
     */
    /*
     * copy brokerBridgeSrcIsLocal data
     * set rowreq_ctx->data.brokerBridgeSrcIsLocal from rowreq_ctx->undo->brokerBridgeSrcIsLocal
     */
    rowreq_ctx->data.brokerBridgeSrcIsLocal =
        rowreq_ctx->undo->brokerBridgeSrcIsLocal;


    return MFD_SUCCESS;
}                               /* brokerBridgeSrcIsLocal_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeTag
 * brokerBridgeTag is subid 10 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.10
 * Description:
Bridge tag
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeTag_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeTag_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeTag_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeTag).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeTag_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                            char *brokerBridgeTag_val_ptr,
                            size_t brokerBridgeTag_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTag_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeTag_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeTag value.
     */

    return MFD_SUCCESS;         /* brokerBridgeTag value not illegal */
}                               /* brokerBridgeTag_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeTag_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTag_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeTag undo.
     */
    /*
     * copy brokerBridgeTag and brokerBridgeTag_len data
     * set rowreq_ctx->undo->brokerBridgeTag from rowreq_ctx->data.brokerBridgeTag
     */
    memcpy(rowreq_ctx->undo->brokerBridgeTag,
           rowreq_ctx->data.brokerBridgeTag,
           (rowreq_ctx->data.brokerBridgeTag_len *
            sizeof(rowreq_ctx->undo->brokerBridgeTag[0])));
    rowreq_ctx->undo->brokerBridgeTag_len =
        rowreq_ctx->data.brokerBridgeTag_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeTag_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeTag_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeTag_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeTag_val_ptr
 */
int
brokerBridgeTag_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                    char *brokerBridgeTag_val_ptr,
                    size_t brokerBridgeTag_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTag_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeTag_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeTag value.
     * set brokerBridgeTag value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeTag, brokerBridgeTag_val_ptr,
           brokerBridgeTag_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeTag_len =
        brokerBridgeTag_val_ptr_len / sizeof(brokerBridgeTag_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeTag_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeTag_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeTag_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeTag undo.
     */
    /*
     * copy brokerBridgeTag and brokerBridgeTag_len data
     * set rowreq_ctx->data.brokerBridgeTag from rowreq_ctx->undo->brokerBridgeTag
     */
    memcpy(rowreq_ctx->data.brokerBridgeTag,
           rowreq_ctx->undo->brokerBridgeTag,
           (rowreq_ctx->undo->brokerBridgeTag_len *
            sizeof(rowreq_ctx->data.brokerBridgeTag[0])));
    rowreq_ctx->data.brokerBridgeTag_len =
        rowreq_ctx->undo->brokerBridgeTag_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeTag_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeExcludes
 * brokerBridgeExcludes is subid 11 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.11
 * Description:
Bridge excludes
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeExcludes_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeExcludes_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeExcludes_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerBridgeExcludes).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeExcludes_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                                 char *brokerBridgeExcludes_val_ptr,
                                 size_t brokerBridgeExcludes_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeExcludes_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeExcludes_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeExcludes value.
     */

    return MFD_SUCCESS;         /* brokerBridgeExcludes value not illegal */
}                               /* brokerBridgeExcludes_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeExcludes_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeExcludes_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeExcludes undo.
     */
    /*
     * copy brokerBridgeExcludes and brokerBridgeExcludes_len data
     * set rowreq_ctx->undo->brokerBridgeExcludes from rowreq_ctx->data.brokerBridgeExcludes
     */
    memcpy(rowreq_ctx->undo->brokerBridgeExcludes,
           rowreq_ctx->data.brokerBridgeExcludes,
           (rowreq_ctx->data.brokerBridgeExcludes_len *
            sizeof(rowreq_ctx->undo->brokerBridgeExcludes[0])));
    rowreq_ctx->undo->brokerBridgeExcludes_len =
        rowreq_ctx->data.brokerBridgeExcludes_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeExcludes_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeExcludes_val_ptr
 *        A char containing the new value.
 * @param brokerBridgeExcludes_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerBridgeExcludes_val_ptr
 */
int
brokerBridgeExcludes_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                         char *brokerBridgeExcludes_val_ptr,
                         size_t brokerBridgeExcludes_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeExcludes_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerBridgeExcludes_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerBridgeExcludes value.
     * set brokerBridgeExcludes value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerBridgeExcludes,
           brokerBridgeExcludes_val_ptr, brokerBridgeExcludes_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerBridgeExcludes_len =
        brokerBridgeExcludes_val_ptr_len /
        sizeof(brokerBridgeExcludes_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerBridgeExcludes_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeExcludes_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeExcludes_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeExcludes undo.
     */
    /*
     * copy brokerBridgeExcludes and brokerBridgeExcludes_len data
     * set rowreq_ctx->data.brokerBridgeExcludes from rowreq_ctx->undo->brokerBridgeExcludes
     */
    memcpy(rowreq_ctx->data.brokerBridgeExcludes,
           rowreq_ctx->undo->brokerBridgeExcludes,
           (rowreq_ctx->undo->brokerBridgeExcludes_len *
            sizeof(rowreq_ctx->data.brokerBridgeExcludes[0])));
    rowreq_ctx->data.brokerBridgeExcludes_len =
        rowreq_ctx->undo->brokerBridgeExcludes_len;


    return MFD_SUCCESS;
}                               /* brokerBridgeExcludes_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeDynamic
 * brokerBridgeDynamic is subid 12 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.12
 * Description:
Bridge dynamic
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeDynamic_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeDynamic_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                                u_long brokerBridgeDynamic_val)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDynamic_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeDynamic value.
     */

    return MFD_SUCCESS;         /* brokerBridgeDynamic value not illegal */
}                               /* brokerBridgeDynamic_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeDynamic_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDynamic_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeDynamic undo.
     */
    /*
     * copy brokerBridgeDynamic data
     * set rowreq_ctx->undo->brokerBridgeDynamic from rowreq_ctx->data.brokerBridgeDynamic
     */
    rowreq_ctx->undo->brokerBridgeDynamic =
        rowreq_ctx->data.brokerBridgeDynamic;


    return MFD_SUCCESS;
}                               /* brokerBridgeDynamic_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeDynamic_val
 *        A long containing the new value.
 */
int
brokerBridgeDynamic_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                        u_long brokerBridgeDynamic_val)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDynamic_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerBridgeDynamic value.
     * set brokerBridgeDynamic value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerBridgeDynamic = brokerBridgeDynamic_val;

    return MFD_SUCCESS;
}                               /* brokerBridgeDynamic_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeDynamic_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeDynamic_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeDynamic undo.
     */
    /*
     * copy brokerBridgeDynamic data
     * set rowreq_ctx->data.brokerBridgeDynamic from rowreq_ctx->undo->brokerBridgeDynamic
     */
    rowreq_ctx->data.brokerBridgeDynamic =
        rowreq_ctx->undo->brokerBridgeDynamic;


    return MFD_SUCCESS;
}                               /* brokerBridgeDynamic_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerBridgeEntry.brokerBridgeSync
 * brokerBridgeSync is subid 13 of brokerBridgeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.12.1.1.13
 * Description:
Bridge sync
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   1
 *   settable   1
 *   hint: d
 *
 *
 * Its syntax is Uint16 (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerBridgeSync_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerBridgeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerBridgeSync_check_value(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                             long brokerBridgeSync_val)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSync_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerBridgeSync value.
     */

    return MFD_SUCCESS;         /* brokerBridgeSync value not illegal */
}                               /* brokerBridgeSync_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerBridgeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerBridgeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerBridgeSync_undo_setup(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSync_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerBridgeSync undo.
     */
    /*
     * copy brokerBridgeSync data
     * set rowreq_ctx->undo->brokerBridgeSync from rowreq_ctx->data.brokerBridgeSync
     */
    rowreq_ctx->undo->brokerBridgeSync = rowreq_ctx->data.brokerBridgeSync;


    return MFD_SUCCESS;
}                               /* brokerBridgeSync_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerBridgeSync_val
 *        A long containing the new value.
 */
int
brokerBridgeSync_set(brokerBridgeTable_rowreq_ctx * rowreq_ctx,
                     long brokerBridgeSync_val)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSync_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerBridgeSync value.
     * set brokerBridgeSync value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerBridgeSync = brokerBridgeSync_val;

    return MFD_SUCCESS;
}                               /* brokerBridgeSync_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerBridgeSync_undo(brokerBridgeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerBridgeTable:brokerBridgeSync_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerBridgeSync undo.
     */
    /*
     * copy brokerBridgeSync data
     * set rowreq_ctx->data.brokerBridgeSync from rowreq_ctx->undo->brokerBridgeSync
     */
    rowreq_ctx->data.brokerBridgeSync = rowreq_ctx->undo->brokerBridgeSync;


    return MFD_SUCCESS;
}                               /* brokerBridgeSync_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerBridgeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerBridgeTable if you don't have dependencies)
 */
int
brokerBridgeTable_check_dependencies(brokerBridgeTable_rowreq_ctx *
                                     rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerBridgeTable:brokerBridgeTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerBridgeTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerBridgeTable_check_dependencies */

/** @} */
