/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "ConnectionTable.h"


/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement brokerConnectionTable get routines.
 * TODO:240:M: Implement brokerConnectionTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerConnectionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerConnectionTable is subid 1 of brokerConnections.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement brokerConnectionTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 * @param brokerConnectionInternalIndex_val
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
brokerConnectionTable_indexes_set_tbl_idx(brokerConnectionTable_mib_index *
                                          tbl_idx,
                                          u_long
                                          brokerConnectionInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_indexes_set_tbl_idx", "called\n"));

    /*
     * brokerConnectionInternalIndex(21)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h 
     */
    tbl_idx->brokerConnectionInternalIndex =
        brokerConnectionInternalIndex_val;


    return MFD_SUCCESS;
}                               /* brokerConnectionTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
brokerConnectionTable_indexes_set(brokerConnectionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  u_long brokerConnectionInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_indexes_set", "called\n"));

    if (MFD_SUCCESS !=
        brokerConnectionTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                                  brokerConnectionInternalIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != brokerConnectionTable_index_to_oid(&rowreq_ctx->oid_idx,
                                                &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* brokerConnectionTable_indexes_set */


/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionVhostRef
 * brokerConnectionVhostRef is subid 1 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.1
 * Description:
Connection vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerConnectionVhostRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionVhostRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerConnectionVhostRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerConnectionVhostRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerConnectionVhostRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerConnectionVhostRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerConnectionVhostRef_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                             char **brokerConnectionVhostRef_val_ptr_ptr,
                             size_t
                             *brokerConnectionVhostRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerConnectionVhostRef_val_ptr_ptr)
                   && (NULL != *brokerConnectionVhostRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerConnectionVhostRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionVhostRef_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionVhostRef data.
     * copy (* brokerConnectionVhostRef_val_ptr_ptr ) data and (* brokerConnectionVhostRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerConnectionVhostRef data
     */
    if ((NULL == (*brokerConnectionVhostRef_val_ptr_ptr)) ||
        ((*brokerConnectionVhostRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerConnectionVhostRef_len *
          sizeof(rowreq_ctx->data.brokerConnectionVhostRef[0])))) {
        /*
         * allocate space for brokerConnectionVhostRef data
         */
        (*brokerConnectionVhostRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerConnectionVhostRef_len *
                   sizeof(rowreq_ctx->data.brokerConnectionVhostRef[0]));
        if (NULL == (*brokerConnectionVhostRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerConnectionVhostRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerConnectionVhostRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerConnectionVhostRef_len *
        sizeof(rowreq_ctx->data.brokerConnectionVhostRef[0]);
    memcpy((*brokerConnectionVhostRef_val_ptr_ptr),
           rowreq_ctx->data.brokerConnectionVhostRef,
           rowreq_ctx->data.brokerConnectionVhostRef_len *
           sizeof(rowreq_ctx->data.brokerConnectionVhostRef[0]));

    return MFD_SUCCESS;
}                               /* brokerConnectionVhostRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionAddress
 * brokerConnectionAddress is subid 2 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.2
 * Description:
Connection address
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerConnectionAddress data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionAddress_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerConnectionAddress_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerConnectionAddress.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerConnectionAddress_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerConnectionAddress_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerConnectionAddress_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                            char **brokerConnectionAddress_val_ptr_ptr,
                            size_t
                            *brokerConnectionAddress_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerConnectionAddress_val_ptr_ptr)
                   && (NULL != *brokerConnectionAddress_val_ptr_ptr));
    netsnmp_assert(NULL != brokerConnectionAddress_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAddress_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionAddress data.
     * copy (* brokerConnectionAddress_val_ptr_ptr ) data and (* brokerConnectionAddress_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerConnectionAddress data
     */
    if ((NULL == (*brokerConnectionAddress_val_ptr_ptr)) ||
        ((*brokerConnectionAddress_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerConnectionAddress_len *
          sizeof(rowreq_ctx->data.brokerConnectionAddress[0])))) {
        /*
         * allocate space for brokerConnectionAddress data
         */
        (*brokerConnectionAddress_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerConnectionAddress_len *
                   sizeof(rowreq_ctx->data.brokerConnectionAddress[0]));
        if (NULL == (*brokerConnectionAddress_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerConnectionAddress)\n");
            return MFD_ERROR;
        }
    }
    (*brokerConnectionAddress_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerConnectionAddress_len *
        sizeof(rowreq_ctx->data.brokerConnectionAddress[0]);
    memcpy((*brokerConnectionAddress_val_ptr_ptr),
           rowreq_ctx->data.brokerConnectionAddress,
           rowreq_ctx->data.brokerConnectionAddress_len *
           sizeof(rowreq_ctx->data.brokerConnectionAddress[0]));

    return MFD_SUCCESS;
}                               /* brokerConnectionAddress_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionIncoming
 * brokerConnectionIncoming is subid 3 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.3
 * Description:
Connection incoming
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionIncoming data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionIncoming_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionIncoming_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                             u_long * brokerConnectionIncoming_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionIncoming_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionIncoming_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionIncoming data.
     * copy (* brokerConnectionIncoming_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionIncoming_val_ptr) =
        rowreq_ctx->data.brokerConnectionIncoming;

    return MFD_SUCCESS;
}                               /* brokerConnectionIncoming_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionSystemConnection
 * brokerConnectionSystemConnection is subid 4 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.4
 * Description:
Infrastructure/ Inter-system connection (Cluster, Federation, ...)
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionSystemConnection data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionSystemConnection_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionSystemConnection_get(brokerConnectionTable_rowreq_ctx *
                                     rowreq_ctx,
                                     u_long *
                                     brokerConnectionSystemConnection_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionSystemConnection_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSystemConnection_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionSystemConnection data.
     * copy (* brokerConnectionSystemConnection_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionSystemConnection_val_ptr) =
        rowreq_ctx->data.brokerConnectionSystemConnection;

    return MFD_SUCCESS;
}                               /* brokerConnectionSystemConnection_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionUserProxyAuth
 * brokerConnectionUserProxyAuth is subid 5 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.5
 * Description:
Authorization to proxy for users not on broker
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionUserProxyAuth data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionUserProxyAuth_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionUserProxyAuth_get(brokerConnectionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  u_long *
                                  brokerConnectionUserProxyAuth_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionUserProxyAuth_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionUserProxyAuth_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionUserProxyAuth data.
     * copy (* brokerConnectionUserProxyAuth_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionUserProxyAuth_val_ptr) =
        rowreq_ctx->data.brokerConnectionUserProxyAuth;

    return MFD_SUCCESS;
}                               /* brokerConnectionUserProxyAuth_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionFederationLink
 * brokerConnectionFederationLink is subid 6 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.6
 * Description:
Is this a federation link
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionFederationLink data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionFederationLink_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionFederationLink_get(brokerConnectionTable_rowreq_ctx *
                                   rowreq_ctx,
                                   u_long *
                                   brokerConnectionFederationLink_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionFederationLink_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionFederationLink_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionFederationLink data.
     * copy (* brokerConnectionFederationLink_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionFederationLink_val_ptr) =
        rowreq_ctx->data.brokerConnectionFederationLink;

    return MFD_SUCCESS;
}                               /* brokerConnectionFederationLink_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionAuthIdentity
 * brokerConnectionAuthIdentity is subid 7 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.7
 * Description:
authId of connection if authentication enabled
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerConnectionAuthIdentity data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionAuthIdentity_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerConnectionAuthIdentity_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerConnectionAuthIdentity.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerConnectionAuthIdentity_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerConnectionAuthIdentity_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerConnectionAuthIdentity_get(brokerConnectionTable_rowreq_ctx *
                                 rowreq_ctx,
                                 char
                                 **brokerConnectionAuthIdentity_val_ptr_ptr,
                                 size_t
                                 *brokerConnectionAuthIdentity_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerConnectionAuthIdentity_val_ptr_ptr)
                   && (NULL != *brokerConnectionAuthIdentity_val_ptr_ptr));
    netsnmp_assert(NULL != brokerConnectionAuthIdentity_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAuthIdentity_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionAuthIdentity data.
     * copy (* brokerConnectionAuthIdentity_val_ptr_ptr ) data and (* brokerConnectionAuthIdentity_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerConnectionAuthIdentity data
     */
    if ((NULL == (*brokerConnectionAuthIdentity_val_ptr_ptr)) ||
        ((*brokerConnectionAuthIdentity_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerConnectionAuthIdentity_len *
          sizeof(rowreq_ctx->data.brokerConnectionAuthIdentity[0])))) {
        /*
         * allocate space for brokerConnectionAuthIdentity data
         */
        (*brokerConnectionAuthIdentity_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerConnectionAuthIdentity_len *
                   sizeof(rowreq_ctx->data.
                          brokerConnectionAuthIdentity[0]));
        if (NULL == (*brokerConnectionAuthIdentity_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerConnectionAuthIdentity)\n");
            return MFD_ERROR;
        }
    }
    (*brokerConnectionAuthIdentity_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerConnectionAuthIdentity_len *
        sizeof(rowreq_ctx->data.brokerConnectionAuthIdentity[0]);
    memcpy((*brokerConnectionAuthIdentity_val_ptr_ptr),
           rowreq_ctx->data.brokerConnectionAuthIdentity,
           rowreq_ctx->data.brokerConnectionAuthIdentity_len *
           sizeof(rowreq_ctx->data.brokerConnectionAuthIdentity[0]));

    return MFD_SUCCESS;
}                               /* brokerConnectionAuthIdentity_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionRemoteProcessName
 * brokerConnectionRemoteProcessName is subid 8 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.8
 * Description:
Name of executable running as remote client
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Lstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Extract the current value of the brokerConnectionRemoteProcessName data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionRemoteProcessName_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerConnectionRemoteProcessName_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerConnectionRemoteProcessName.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerConnectionRemoteProcessName_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerConnectionRemoteProcessName_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerConnectionRemoteProcessName_get(brokerConnectionTable_rowreq_ctx *
                                      rowreq_ctx,
                                      char
                                      **brokerConnectionRemoteProcessName_val_ptr_ptr,
                                      size_t
                                      *brokerConnectionRemoteProcessName_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerConnectionRemoteProcessName_val_ptr_ptr)
                   && (NULL !=
                       *brokerConnectionRemoteProcessName_val_ptr_ptr));
    netsnmp_assert(NULL !=
                   brokerConnectionRemoteProcessName_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionRemoteProcessName_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionRemoteProcessName data.
     * copy (* brokerConnectionRemoteProcessName_val_ptr_ptr ) data and (* brokerConnectionRemoteProcessName_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerConnectionRemoteProcessName data
     */
    if ((NULL == (*brokerConnectionRemoteProcessName_val_ptr_ptr)) ||
        ((*brokerConnectionRemoteProcessName_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerConnectionRemoteProcessName_len *
          sizeof(rowreq_ctx->data.
                 brokerConnectionRemoteProcessName[0])))) {
        /*
         * allocate space for brokerConnectionRemoteProcessName data
         */
        (*brokerConnectionRemoteProcessName_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerConnectionRemoteProcessName_len *
                   sizeof(rowreq_ctx->data.
                          brokerConnectionRemoteProcessName[0]));
        if (NULL == (*brokerConnectionRemoteProcessName_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerConnectionRemoteProcessName)\n");
            return MFD_ERROR;
        }
    }
    (*brokerConnectionRemoteProcessName_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerConnectionRemoteProcessName_len *
        sizeof(rowreq_ctx->data.brokerConnectionRemoteProcessName[0]);
    memcpy((*brokerConnectionRemoteProcessName_val_ptr_ptr),
           rowreq_ctx->data.brokerConnectionRemoteProcessName,
           rowreq_ctx->data.brokerConnectionRemoteProcessName_len *
           sizeof(rowreq_ctx->data.brokerConnectionRemoteProcessName[0]));

    return MFD_SUCCESS;
}                               /* brokerConnectionRemoteProcessName_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionRemotePid
 * brokerConnectionRemotePid is subid 9 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.9
 * Description:
Process ID of remote client
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionRemotePid data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionRemotePid_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionRemotePid_get(brokerConnectionTable_rowreq_ctx *
                              rowreq_ctx,
                              u_long * brokerConnectionRemotePid_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionRemotePid_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionRemotePid_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionRemotePid data.
     * copy (* brokerConnectionRemotePid_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionRemotePid_val_ptr) =
        rowreq_ctx->data.brokerConnectionRemotePid;

    return MFD_SUCCESS;
}                               /* brokerConnectionRemotePid_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionRemoteParentPid
 * brokerConnectionRemoteParentPid is subid 10 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.10
 * Description:
Parent Process ID of remote client
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionRemoteParentPid data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionRemoteParentPid_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionRemoteParentPid_get(brokerConnectionTable_rowreq_ctx *
                                    rowreq_ctx,
                                    u_long *
                                    brokerConnectionRemoteParentPid_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionRemoteParentPid_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionRemoteParentPid_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionRemoteParentPid data.
     * copy (* brokerConnectionRemoteParentPid_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionRemoteParentPid_val_ptr) =
        rowreq_ctx->data.brokerConnectionRemoteParentPid;

    return MFD_SUCCESS;
}                               /* brokerConnectionRemoteParentPid_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionShadow
 * brokerConnectionShadow is subid 11 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.11
 * Description:
True for shadow connections
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionShadow data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionShadow_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionShadow_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                           u_long * brokerConnectionShadow_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionShadow_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionShadow_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionShadow data.
     * copy (* brokerConnectionShadow_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionShadow_val_ptr) =
        rowreq_ctx->data.brokerConnectionShadow;

    return MFD_SUCCESS;
}                               /* brokerConnectionShadow_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionSaslMechanism
 * brokerConnectionSaslMechanism is subid 12 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.12
 * Description:
SASL mechanism
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerConnectionSaslMechanism data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionSaslMechanism_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerConnectionSaslMechanism_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerConnectionSaslMechanism.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerConnectionSaslMechanism_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerConnectionSaslMechanism_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerConnectionSaslMechanism_get(brokerConnectionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  char
                                  **brokerConnectionSaslMechanism_val_ptr_ptr,
                                  size_t
                                  *brokerConnectionSaslMechanism_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerConnectionSaslMechanism_val_ptr_ptr)
                   && (NULL !=
                       *brokerConnectionSaslMechanism_val_ptr_ptr));
    netsnmp_assert(NULL != brokerConnectionSaslMechanism_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSaslMechanism_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionSaslMechanism data.
     * copy (* brokerConnectionSaslMechanism_val_ptr_ptr ) data and (* brokerConnectionSaslMechanism_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerConnectionSaslMechanism data
     */
    if ((NULL == (*brokerConnectionSaslMechanism_val_ptr_ptr)) ||
        ((*brokerConnectionSaslMechanism_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerConnectionSaslMechanism_len *
          sizeof(rowreq_ctx->data.brokerConnectionSaslMechanism[0])))) {
        /*
         * allocate space for brokerConnectionSaslMechanism data
         */
        (*brokerConnectionSaslMechanism_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerConnectionSaslMechanism_len *
                   sizeof(rowreq_ctx->data.
                          brokerConnectionSaslMechanism[0]));
        if (NULL == (*brokerConnectionSaslMechanism_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerConnectionSaslMechanism)\n");
            return MFD_ERROR;
        }
    }
    (*brokerConnectionSaslMechanism_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerConnectionSaslMechanism_len *
        sizeof(rowreq_ctx->data.brokerConnectionSaslMechanism[0]);
    memcpy((*brokerConnectionSaslMechanism_val_ptr_ptr),
           rowreq_ctx->data.brokerConnectionSaslMechanism,
           rowreq_ctx->data.brokerConnectionSaslMechanism_len *
           sizeof(rowreq_ctx->data.brokerConnectionSaslMechanism[0]));

    return MFD_SUCCESS;
}                               /* brokerConnectionSaslMechanism_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionSaslSsf
 * brokerConnectionSaslSsf is subid 13 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.13
 * Description:
SASL security strength factor
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   1
 *   settable   0
 *   hint: d
 *
 *
 * Its syntax is Uint16 (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the brokerConnectionSaslSsf data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionSaslSsf_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionSaslSsf_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                            long *brokerConnectionSaslSsf_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionSaslSsf_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSaslSsf_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionSaslSsf data.
     * copy (* brokerConnectionSaslSsf_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionSaslSsf_val_ptr) =
        rowreq_ctx->data.brokerConnectionSaslSsf;

    return MFD_SUCCESS;
}                               /* brokerConnectionSaslSsf_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionClosing
 * brokerConnectionClosing is subid 14 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.14
 * Description:
This client is closing by management request
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerConnectionClosing data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionClosing_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionClosing_get(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                            u_long * brokerConnectionClosing_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionClosing_val_ptr);


    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionClosing_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerConnectionClosing data.
     * copy (* brokerConnectionClosing_val_ptr ) from rowreq_ctx->data
     */
    (*brokerConnectionClosing_val_ptr) =
        rowreq_ctx->data.brokerConnectionClosing;

    return MFD_SUCCESS;
}                               /* brokerConnectionClosing_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionFramesFromClient
 * brokerConnectionFramesFromClient is subid 15 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.15
 * Description:
Connection framesFromClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionFramesFromClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionFramesFromClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionFramesFromClient_get(brokerConnectionTable_rowreq_ctx *
                                     rowreq_ctx,
                                     U64 *
                                     brokerConnectionFramesFromClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionFramesFromClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionFramesFromClient data.
     * get (* brokerConnectionFramesFromClient_val_ptr ).low and (* brokerConnectionFramesFromClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionFramesFromClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionFramesFromClient.high;
    (*brokerConnectionFramesFromClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionFramesFromClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionFramesFromClient_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionFramesToClient
 * brokerConnectionFramesToClient is subid 16 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.16
 * Description:
Connection framesToClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionFramesToClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionFramesToClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionFramesToClient_get(brokerConnectionTable_rowreq_ctx *
                                   rowreq_ctx,
                                   U64 *
                                   brokerConnectionFramesToClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionFramesToClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionFramesToClient data.
     * get (* brokerConnectionFramesToClient_val_ptr ).low and (* brokerConnectionFramesToClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionFramesToClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionFramesToClient.high;
    (*brokerConnectionFramesToClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionFramesToClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionFramesToClient_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionBytesFromClient
 * brokerConnectionBytesFromClient is subid 17 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.17
 * Description:
Connection bytesFromClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionBytesFromClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionBytesFromClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionBytesFromClient_get(brokerConnectionTable_rowreq_ctx *
                                    rowreq_ctx,
                                    U64 *
                                    brokerConnectionBytesFromClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionBytesFromClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionBytesFromClient data.
     * get (* brokerConnectionBytesFromClient_val_ptr ).low and (* brokerConnectionBytesFromClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionBytesFromClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionBytesFromClient.high;
    (*brokerConnectionBytesFromClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionBytesFromClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionBytesFromClient_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionBytesToClient
 * brokerConnectionBytesToClient is subid 18 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.18
 * Description:
Connection bytesToClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionBytesToClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionBytesToClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionBytesToClient_get(brokerConnectionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  U64 *
                                  brokerConnectionBytesToClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionBytesToClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionBytesToClient data.
     * get (* brokerConnectionBytesToClient_val_ptr ).low and (* brokerConnectionBytesToClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionBytesToClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionBytesToClient.high;
    (*brokerConnectionBytesToClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionBytesToClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionBytesToClient_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionMsgsFromClient
 * brokerConnectionMsgsFromClient is subid 19 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.19
 * Description:
Connection msgsFromClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionMsgsFromClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionMsgsFromClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionMsgsFromClient_get(brokerConnectionTable_rowreq_ctx *
                                   rowreq_ctx,
                                   U64 *
                                   brokerConnectionMsgsFromClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionMsgsFromClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionMsgsFromClient data.
     * get (* brokerConnectionMsgsFromClient_val_ptr ).low and (* brokerConnectionMsgsFromClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionMsgsFromClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionMsgsFromClient.high;
    (*brokerConnectionMsgsFromClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionMsgsFromClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionMsgsFromClient_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionMsgsToClient
 * brokerConnectionMsgsToClient is subid 20 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.20
 * Description:
Connection msgsToClient
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerConnectionMsgsToClient data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionMsgsToClient_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerConnectionMsgsToClient_get(brokerConnectionTable_rowreq_ctx *
                                 rowreq_ctx,
                                 U64 *
                                 brokerConnectionMsgsToClient_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerConnectionMsgsToClient_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerConnectionMsgsToClient data.
     * get (* brokerConnectionMsgsToClient_val_ptr ).low and (* brokerConnectionMsgsToClient_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerConnectionMsgsToClient_val_ptr).high =
        rowreq_ctx->data.brokerConnectionMsgsToClient.high;
    (*brokerConnectionMsgsToClient_val_ptr).low =
        rowreq_ctx->data.brokerConnectionMsgsToClient.low;


    return MFD_SUCCESS;
}                               /* brokerConnectionMsgsToClient_get */



/** @} */
