/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "ConnectionTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerConnectionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerConnectionTable is subid 1 of brokerConnections.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerConnectionTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerConnectionTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerConnectionTable_undo_setup(brokerConnectionTable_rowreq_ctx *
                                 rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_undo_setup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerConnectionTable undo.
     * set up brokerConnectionTable undo information, in preparation for a set.
     * Undo storage is in (* brokerConnectionMsgsToClient_val_ptr )*
     */

    return rc;
}                               /* brokerConnectionTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerConnectionTable_undo(brokerConnectionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerConnectionTable undo.
     * brokerConnectionTable undo information, in response to a failed set.
     * Undo storage is in (* brokerConnectionMsgsToClient_val_ptr )*
     */

    return rc;
}                               /* brokerConnectionTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerConnectionTable_undo_cleanup(brokerConnectionTable_rowreq_ctx *
                                   rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_undo_cleanup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerConnectionTable undo.
     * Undo storage is in (* brokerConnectionMsgsToClient_val_ptr )*
     */

    return rc;
}                               /* brokerConnectionTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerConnectionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerConnectionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerConnectionTable_commit(brokerConnectionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerConnectionTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerCONNECTIONVHOSTREF_FLAG) {
        save_flags &= ~COLUMN_brokerCONNECTIONVHOSTREF_FLAG;    /* clear brokerConnectionVhostRef */
        /*
         * TODO:482:o: |-> commit column brokerConnectionVhostRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerConnectionTable column brokerConnectionVhostRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerConnectionVhostRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerCONNECTIONVHOSTREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerCONNECTIONADDRESS_FLAG) {
        save_flags &= ~COLUMN_brokerCONNECTIONADDRESS_FLAG;     /* clear brokerConnectionAddress */
        /*
         * TODO:482:o: |-> commit column brokerConnectionAddress.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerConnectionTable column brokerConnectionAddress commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerConnectionAddress
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerCONNECTIONADDRESS_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerCONNECTIONINCOMING_FLAG) {
        save_flags &= ~COLUMN_brokerCONNECTIONINCOMING_FLAG;    /* clear brokerConnectionIncoming */
        /*
         * TODO:482:o: |-> commit column brokerConnectionIncoming.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerConnectionTable column brokerConnectionIncoming commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerConnectionIncoming
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerCONNECTIONINCOMING_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerCONNECTIONSYSTEMCONNECTION_FLAG) {
        save_flags &= ~COLUMN_brokerCONNECTIONSYSTEMCONNECTION_FLAG;    /* clear brokerConnectionSystemConnection */
        /*
         * TODO:482:o: |-> commit column brokerConnectionSystemConnection.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerConnectionTable column brokerConnectionSystemConnection commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerConnectionSystemConnection
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerCONNECTIONSYSTEMCONNECTION_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerConnectionTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerConnectionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerConnectionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerConnectionTable_undo_commit(brokerConnectionTable_rowreq_ctx *
                                  rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionTable_undo_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerConnectionTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerConnectionTable_undo_commit */

/*
 * TODO:440:M: Implement brokerConnectionTable node value checks.
 * TODO:450:M: Implement brokerConnectionTable undo functions.
 * TODO:460:M: Implement brokerConnectionTable set functions.
 * TODO:480:M: Implement brokerConnectionTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionVhostRef
 * brokerConnectionVhostRef is subid 1 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.1
 * Description:
Connection vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerConnectionVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerConnectionVhostRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerConnectionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerConnectionVhostRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerConnectionVhostRef_check_value(brokerConnectionTable_rowreq_ctx *
                                     rowreq_ctx,
                                     char
                                     *brokerConnectionVhostRef_val_ptr,
                                     size_t
                                     brokerConnectionVhostRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionVhostRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerConnectionVhostRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerConnectionVhostRef value.
     */

    return MFD_SUCCESS;         /* brokerConnectionVhostRef value not illegal */
}                               /* brokerConnectionVhostRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerConnectionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerConnectionVhostRef_undo_setup(brokerConnectionTable_rowreq_ctx *
                                    rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionVhostRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerConnectionVhostRef undo.
     */
    /*
     * copy brokerConnectionVhostRef and brokerConnectionVhostRef_len data
     * set rowreq_ctx->undo->brokerConnectionVhostRef from rowreq_ctx->data.brokerConnectionVhostRef
     */
    memcpy(rowreq_ctx->undo->brokerConnectionVhostRef,
           rowreq_ctx->data.brokerConnectionVhostRef,
           (rowreq_ctx->data.brokerConnectionVhostRef_len *
            sizeof(rowreq_ctx->undo->brokerConnectionVhostRef[0])));
    rowreq_ctx->undo->brokerConnectionVhostRef_len =
        rowreq_ctx->data.brokerConnectionVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerConnectionVhostRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerConnectionVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerConnectionVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerConnectionVhostRef_val_ptr
 */
int
brokerConnectionVhostRef_set(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                             char *brokerConnectionVhostRef_val_ptr,
                             size_t brokerConnectionVhostRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionVhostRef_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerConnectionVhostRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerConnectionVhostRef value.
     * set brokerConnectionVhostRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerConnectionVhostRef,
           brokerConnectionVhostRef_val_ptr,
           brokerConnectionVhostRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerConnectionVhostRef_len =
        brokerConnectionVhostRef_val_ptr_len /
        sizeof(brokerConnectionVhostRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerConnectionVhostRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerConnectionVhostRef_undo(brokerConnectionTable_rowreq_ctx *
                              rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionVhostRef_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerConnectionVhostRef undo.
     */
    /*
     * copy brokerConnectionVhostRef and brokerConnectionVhostRef_len data
     * set rowreq_ctx->data.brokerConnectionVhostRef from rowreq_ctx->undo->brokerConnectionVhostRef
     */
    memcpy(rowreq_ctx->data.brokerConnectionVhostRef,
           rowreq_ctx->undo->brokerConnectionVhostRef,
           (rowreq_ctx->undo->brokerConnectionVhostRef_len *
            sizeof(rowreq_ctx->data.brokerConnectionVhostRef[0])));
    rowreq_ctx->data.brokerConnectionVhostRef_len =
        rowreq_ctx->undo->brokerConnectionVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerConnectionVhostRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionAddress
 * brokerConnectionAddress is subid 2 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.2
 * Description:
Connection address
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionAddress_val_ptr
 *        A char containing the new value.
 * @param brokerConnectionAddress_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerConnectionAddress_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerConnectionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerConnectionAddress).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerConnectionAddress_check_value(brokerConnectionTable_rowreq_ctx *
                                    rowreq_ctx,
                                    char *brokerConnectionAddress_val_ptr,
                                    size_t
                                    brokerConnectionAddress_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAddress_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerConnectionAddress_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerConnectionAddress value.
     */

    return MFD_SUCCESS;         /* brokerConnectionAddress value not illegal */
}                               /* brokerConnectionAddress_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerConnectionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerConnectionAddress_undo_setup(brokerConnectionTable_rowreq_ctx *
                                   rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAddress_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerConnectionAddress undo.
     */
    /*
     * copy brokerConnectionAddress and brokerConnectionAddress_len data
     * set rowreq_ctx->undo->brokerConnectionAddress from rowreq_ctx->data.brokerConnectionAddress
     */
    memcpy(rowreq_ctx->undo->brokerConnectionAddress,
           rowreq_ctx->data.brokerConnectionAddress,
           (rowreq_ctx->data.brokerConnectionAddress_len *
            sizeof(rowreq_ctx->undo->brokerConnectionAddress[0])));
    rowreq_ctx->undo->brokerConnectionAddress_len =
        rowreq_ctx->data.brokerConnectionAddress_len;


    return MFD_SUCCESS;
}                               /* brokerConnectionAddress_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerConnectionAddress_val_ptr
 *        A char containing the new value.
 * @param brokerConnectionAddress_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerConnectionAddress_val_ptr
 */
int
brokerConnectionAddress_set(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                            char *brokerConnectionAddress_val_ptr,
                            size_t brokerConnectionAddress_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAddress_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerConnectionAddress_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerConnectionAddress value.
     * set brokerConnectionAddress value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerConnectionAddress,
           brokerConnectionAddress_val_ptr,
           brokerConnectionAddress_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerConnectionAddress_len =
        brokerConnectionAddress_val_ptr_len /
        sizeof(brokerConnectionAddress_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerConnectionAddress_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerConnectionAddress_undo(brokerConnectionTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionAddress_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerConnectionAddress undo.
     */
    /*
     * copy brokerConnectionAddress and brokerConnectionAddress_len data
     * set rowreq_ctx->data.brokerConnectionAddress from rowreq_ctx->undo->brokerConnectionAddress
     */
    memcpy(rowreq_ctx->data.brokerConnectionAddress,
           rowreq_ctx->undo->brokerConnectionAddress,
           (rowreq_ctx->undo->brokerConnectionAddress_len *
            sizeof(rowreq_ctx->data.brokerConnectionAddress[0])));
    rowreq_ctx->data.brokerConnectionAddress_len =
        rowreq_ctx->undo->brokerConnectionAddress_len;


    return MFD_SUCCESS;
}                               /* brokerConnectionAddress_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionIncoming
 * brokerConnectionIncoming is subid 3 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.3
 * Description:
Connection incoming
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionIncoming_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerConnectionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerConnectionIncoming_check_value(brokerConnectionTable_rowreq_ctx *
                                     rowreq_ctx,
                                     u_long brokerConnectionIncoming_val)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionIncoming_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerConnectionIncoming value.
     */

    return MFD_SUCCESS;         /* brokerConnectionIncoming value not illegal */
}                               /* brokerConnectionIncoming_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerConnectionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerConnectionIncoming_undo_setup(brokerConnectionTable_rowreq_ctx *
                                    rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionIncoming_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerConnectionIncoming undo.
     */
    /*
     * copy brokerConnectionIncoming data
     * set rowreq_ctx->undo->brokerConnectionIncoming from rowreq_ctx->data.brokerConnectionIncoming
     */
    rowreq_ctx->undo->brokerConnectionIncoming =
        rowreq_ctx->data.brokerConnectionIncoming;


    return MFD_SUCCESS;
}                               /* brokerConnectionIncoming_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerConnectionIncoming_val
 *        A long containing the new value.
 */
int
brokerConnectionIncoming_set(brokerConnectionTable_rowreq_ctx * rowreq_ctx,
                             u_long brokerConnectionIncoming_val)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionIncoming_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerConnectionIncoming value.
     * set brokerConnectionIncoming value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerConnectionIncoming =
        brokerConnectionIncoming_val;

    return MFD_SUCCESS;
}                               /* brokerConnectionIncoming_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerConnectionIncoming_undo(brokerConnectionTable_rowreq_ctx *
                              rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionIncoming_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerConnectionIncoming undo.
     */
    /*
     * copy brokerConnectionIncoming data
     * set rowreq_ctx->data.brokerConnectionIncoming from rowreq_ctx->undo->brokerConnectionIncoming
     */
    rowreq_ctx->data.brokerConnectionIncoming =
        rowreq_ctx->undo->brokerConnectionIncoming;


    return MFD_SUCCESS;
}                               /* brokerConnectionIncoming_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerConnectionEntry.brokerConnectionSystemConnection
 * brokerConnectionSystemConnection is subid 4 of brokerConnectionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.10.1.1.4
 * Description:
Infrastructure/ Inter-system connection (Cluster, Federation, ...)
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerConnectionSystemConnection_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerConnectionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerConnectionSystemConnection_check_value
    (brokerConnectionTable_rowreq_ctx * rowreq_ctx,
     u_long brokerConnectionSystemConnection_val)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSystemConnection_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerConnectionSystemConnection value.
     */

    return MFD_SUCCESS;         /* brokerConnectionSystemConnection value not illegal */
}                               /* brokerConnectionSystemConnection_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerConnectionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerConnectionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerConnectionSystemConnection_undo_setup
    (brokerConnectionTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSystemConnection_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerConnectionSystemConnection undo.
     */
    /*
     * copy brokerConnectionSystemConnection data
     * set rowreq_ctx->undo->brokerConnectionSystemConnection from rowreq_ctx->data.brokerConnectionSystemConnection
     */
    rowreq_ctx->undo->brokerConnectionSystemConnection =
        rowreq_ctx->data.brokerConnectionSystemConnection;


    return MFD_SUCCESS;
}                               /* brokerConnectionSystemConnection_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerConnectionSystemConnection_val
 *        A long containing the new value.
 */
int
brokerConnectionSystemConnection_set(brokerConnectionTable_rowreq_ctx *
                                     rowreq_ctx,
                                     u_long
                                     brokerConnectionSystemConnection_val)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSystemConnection_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerConnectionSystemConnection value.
     * set brokerConnectionSystemConnection value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerConnectionSystemConnection =
        brokerConnectionSystemConnection_val;

    return MFD_SUCCESS;
}                               /* brokerConnectionSystemConnection_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerConnectionSystemConnection_undo(brokerConnectionTable_rowreq_ctx *
                                      rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerConnectionTable:brokerConnectionSystemConnection_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerConnectionSystemConnection undo.
     */
    /*
     * copy brokerConnectionSystemConnection data
     * set rowreq_ctx->data.brokerConnectionSystemConnection from rowreq_ctx->undo->brokerConnectionSystemConnection
     */
    rowreq_ctx->data.brokerConnectionSystemConnection =
        rowreq_ctx->undo->brokerConnectionSystemConnection;


    return MFD_SUCCESS;
}                               /* brokerConnectionSystemConnection_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerConnectionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerConnectionTable if you don't have dependencies)
 */
int
brokerConnectionTable_check_dependencies(brokerConnectionTable_rowreq_ctx *
                                         rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerConnectionTable:brokerConnectionTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerConnectionTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerConnectionTable_check_dependencies */

/** @} */
