/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/** \page MFD helper for brokerExchangeTable
 *
 * \section intro Introduction
 * Introductory text.
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "ExchangeTable.h"

#include <net-snmp/agent/mib_modules.h>

#include "ExchangeTable_interface.h"

const oid       brokerExchangeTable_oid[] = { brokerEXCHANGETABLE_OID };

const int       brokerExchangeTable_oid_size =
OID_LENGTH(brokerExchangeTable_oid);

brokerExchangeTable_registration brokerExchangeTable_user_context;

void            initialize_table_brokerExchangeTable(void);
void            shutdown_table_brokerExchangeTable(void);


/**
 * Initializes the brokerExchangeTable module
 */
void
init_ExchangeTable(void)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:init_ExchangeTable",
                "called\n"));

    /*
     * TODO:300:o: Perform brokerExchangeTable one-time module initialization.
     */

    /*
     * here we initialize all the tables we're planning on supporting
     */
    if (should_init("brokerExchangeTable"))
        initialize_table_brokerExchangeTable();

}                               /* init_ExchangeTable */

/**
 * Shut-down the brokerExchangeTable module (agent is exiting)
 */
void
shutdown_brokerExchangeTable(void)
{
    if (should_init("brokerExchangeTable"))
        shutdown_table_brokerExchangeTable();

}

/**
 * Initialize the table brokerExchangeTable 
 *    (Define its contents and how it's structured)
 */
void
initialize_table_brokerExchangeTable(void)
{
    brokerExchangeTable_registration *user_context;
    u_long          flags;

    DEBUGMSGTL(("verbose:brokerExchangeTable:initialize_table_brokerExchangeTable", "called\n"));

    /*
     * TODO:301:o: Perform brokerExchangeTable one-time table initialization.
     */

    /*
     * TODO:302:o: |->Initialize brokerExchangeTable user context
     * if you'd like to pass in a pointer to some data for this
     * table, allocate or set it up here.
     */
    /*
     * a netsnmp_data_list is a simple way to store void pointers. A simple
     * string token is used to add, find or remove pointers.
     */
    user_context =
        netsnmp_create_data_list("brokerExchangeTable", NULL, NULL);

    /*
     * No support for any flags yet, but in the future you would
     * set any flags here.
     */
    flags = 0;

    /*
     * call interface initialization code
     */
    _brokerExchangeTable_initialize_interface(user_context, flags);
}                               /* initialize_table_brokerExchangeTable */

/**
 * Shutdown the table brokerExchangeTable 
 */
void
shutdown_table_brokerExchangeTable(void)
{
    /*
     * call interface shutdown code
     */
    _brokerExchangeTable_shutdown_interface
        (&brokerExchangeTable_user_context);
}

/**
 * extra context initialization (eg default values)
 *
 * @param rowreq_ctx    : row request context
 * @param user_init_ctx : void pointer for user (parameter to rowreq_ctx_allocate)
 *
 * @retval MFD_SUCCESS  : no errors
 * @retval MFD_ERROR    : error (context allocate will fail)
 */
int
brokerExchangeTable_rowreq_ctx_init(brokerExchangeTable_rowreq_ctx *
                                    rowreq_ctx, void *user_init_ctx)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_rowreq_ctx_init", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * Perform extra brokerExchangeTable rowreq initialization. (eg DEFVALS)
     */
    rowreq_ctx->data.brokerExchangeVhostRef_len = 255;
    rowreq_ctx->data.brokerExchangeName_len = 255;
    rowreq_ctx->data.brokerExchangeType_len = 255;
    rowreq_ctx->data.brokerExchangeArguments_len = 65535;
    rowreq_ctx->data.brokerExchangeAltExchange_len = 255;

    return MFD_SUCCESS;
}                               /* brokerExchangeTable_rowreq_ctx_init */

/**
 * extra context cleanup
 *
 */
void
brokerExchangeTable_rowreq_ctx_cleanup(brokerExchangeTable_rowreq_ctx *
                                       rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_rowreq_ctx_cleanup", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:211:o: |-> Perform extra brokerExchangeTable rowreq cleanup.
     */
}                               /* brokerExchangeTable_rowreq_ctx_cleanup */

/************************************************************
 * the *_should_save routine is called to determine if a row
 * should be stored persistently.
 *
 * Note that this is not a 'dirty' check (i.e. if a row has changed),
 * but a check for volatile rows that should not be saved between
 * restarts.
 *
 * return 1 if the row should be stored
 * return 0 if the row should not be stored
 */
int
brokerExchangeTable_container_should_save(brokerExchangeTable_rowreq_ctx *
                                          rowreq_ctx)
{

    return 1;                   /* save the row */
}

/**
 * pre-request callback
 *
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_ERROR                : other error
 */
int
brokerExchangeTable_pre_request(brokerExchangeTable_registration *
                                user_context)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_pre_request", "called\n"));

    /*
     * TODO:510:o: Perform brokerExchangeTable pre-request actions.
     */

    return MFD_SUCCESS;
}                               /* brokerExchangeTable_pre_request */

/**
 * post-request callback
 *
 * Note:
 *   New rows have been inserted into the container, and
 *   deleted rows have been removed from the container and
 *   released.
 *
 * @param user_context
 * @param rc : MFD_SUCCESS if all requests succeeded
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : other error (ignored)
 */
int
brokerExchangeTable_post_request(brokerExchangeTable_registration *
                                 user_context, int rc)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_post_request", "called\n"));

    /*
     * TODO:511:o: Perform brokerExchangeTable post-request actions.
     */

    /*
     * check to set if any rows were changed.
     */
    if (brokerExchangeTable_dirty_get()) {
        /*
         * check if request was successful. If so, this would be
         * a good place to save data to its persistent store.
         */
        if (MFD_SUCCESS == rc) {
            /*
             * save changed rows, if you haven't already
             */
            snmp_store(netsnmp_ds_get_string(NETSNMP_DS_LIBRARY_ID,
                                             NETSNMP_DS_LIB_APPTYPE));
        }

        brokerExchangeTable_dirty_set(0);       /* clear table dirty flag */
    }

    return MFD_SUCCESS;
}                               /* brokerExchangeTable_post_request */


/** @{ */
