/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "ExchangeTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerExchangeTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerExchangeTable is subid 1 of brokerExchanges.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.7.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerExchangeTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerExchangeTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerExchangeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerExchangeTable_undo_setup(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_undo_setup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerExchangeTable undo.
     * set up brokerExchangeTable undo information, in preparation for a set.
     * Undo storage is in (* brokerExchangeByteRoutes_val_ptr )*
     */

    return rc;
}                               /* brokerExchangeTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerExchangeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerExchangeTable_undo(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerExchangeTable undo.
     * brokerExchangeTable undo information, in response to a failed set.
     * Undo storage is in (* brokerExchangeByteRoutes_val_ptr )*
     */

    return rc;
}                               /* brokerExchangeTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerExchangeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerExchangeTable_undo_cleanup(brokerExchangeTable_rowreq_ctx *
                                 rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_undo_cleanup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerExchangeTable undo.
     * Undo storage is in (* brokerExchangeByteRoutes_val_ptr )*
     */

    return rc;
}                               /* brokerExchangeTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerExchangeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerExchangeTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerExchangeTable_commit(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerExchangeTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerEXCHANGEVHOSTREF_FLAG) {
        save_flags &= ~COLUMN_brokerEXCHANGEVHOSTREF_FLAG;      /* clear brokerExchangeVhostRef */
        /*
         * TODO:482:o: |-> commit column brokerExchangeVhostRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerExchangeTable column brokerExchangeVhostRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerExchangeVhostRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerEXCHANGEVHOSTREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerEXCHANGENAME_FLAG) {
        save_flags &= ~COLUMN_brokerEXCHANGENAME_FLAG;  /* clear brokerExchangeName */
        /*
         * TODO:482:o: |-> commit column brokerExchangeName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerExchangeTable column brokerExchangeName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerExchangeName
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerEXCHANGENAME_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerExchangeTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerExchangeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerExchangeTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerExchangeTable_undo_commit(brokerExchangeTable_rowreq_ctx *
                                rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeTable_undo_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerExchangeTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerExchangeTable_undo_commit */

/*
 * TODO:440:M: Implement brokerExchangeTable node value checks.
 * TODO:450:M: Implement brokerExchangeTable undo functions.
 * TODO:460:M: Implement brokerExchangeTable set functions.
 * TODO:480:M: Implement brokerExchangeTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerExchangeEntry.brokerExchangeVhostRef
 * brokerExchangeVhostRef is subid 1 of brokerExchangeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.7.1.1.1
 * Description:
Exchange vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerExchangeVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerExchangeVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerExchangeVhostRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerExchangeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerExchangeVhostRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerExchangeVhostRef_check_value(brokerExchangeTable_rowreq_ctx *
                                   rowreq_ctx,
                                   char *brokerExchangeVhostRef_val_ptr,
                                   size_t
                                   brokerExchangeVhostRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeVhostRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerExchangeVhostRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerExchangeVhostRef value.
     */

    return MFD_SUCCESS;         /* brokerExchangeVhostRef value not illegal */
}                               /* brokerExchangeVhostRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerExchangeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerExchangeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerExchangeVhostRef_undo_setup(brokerExchangeTable_rowreq_ctx *
                                  rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeVhostRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerExchangeVhostRef undo.
     */
    /*
     * copy brokerExchangeVhostRef and brokerExchangeVhostRef_len data
     * set rowreq_ctx->undo->brokerExchangeVhostRef from rowreq_ctx->data.brokerExchangeVhostRef
     */
    memcpy(rowreq_ctx->undo->brokerExchangeVhostRef,
           rowreq_ctx->data.brokerExchangeVhostRef,
           (rowreq_ctx->data.brokerExchangeVhostRef_len *
            sizeof(rowreq_ctx->undo->brokerExchangeVhostRef[0])));
    rowreq_ctx->undo->brokerExchangeVhostRef_len =
        rowreq_ctx->data.brokerExchangeVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerExchangeVhostRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerExchangeVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerExchangeVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerExchangeVhostRef_val_ptr
 */
int
brokerExchangeVhostRef_set(brokerExchangeTable_rowreq_ctx * rowreq_ctx,
                           char *brokerExchangeVhostRef_val_ptr,
                           size_t brokerExchangeVhostRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeVhostRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerExchangeVhostRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerExchangeVhostRef value.
     * set brokerExchangeVhostRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerExchangeVhostRef,
           brokerExchangeVhostRef_val_ptr,
           brokerExchangeVhostRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerExchangeVhostRef_len =
        brokerExchangeVhostRef_val_ptr_len /
        sizeof(brokerExchangeVhostRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerExchangeVhostRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerExchangeVhostRef_undo(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeVhostRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerExchangeVhostRef undo.
     */
    /*
     * copy brokerExchangeVhostRef and brokerExchangeVhostRef_len data
     * set rowreq_ctx->data.brokerExchangeVhostRef from rowreq_ctx->undo->brokerExchangeVhostRef
     */
    memcpy(rowreq_ctx->data.brokerExchangeVhostRef,
           rowreq_ctx->undo->brokerExchangeVhostRef,
           (rowreq_ctx->undo->brokerExchangeVhostRef_len *
            sizeof(rowreq_ctx->data.brokerExchangeVhostRef[0])));
    rowreq_ctx->data.brokerExchangeVhostRef_len =
        rowreq_ctx->undo->brokerExchangeVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerExchangeVhostRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerExchangeEntry.brokerExchangeName
 * brokerExchangeName is subid 2 of brokerExchangeEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.7.1.1.2
 * Description:
Exchange name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerExchangeName_val_ptr
 *        A char containing the new value.
 * @param brokerExchangeName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerExchangeName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerExchangeTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerExchangeName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerExchangeName_check_value(brokerExchangeTable_rowreq_ctx * rowreq_ctx,
                               char *brokerExchangeName_val_ptr,
                               size_t brokerExchangeName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeName_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerExchangeName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerExchangeName value.
     */

    return MFD_SUCCESS;         /* brokerExchangeName value not illegal */
}                               /* brokerExchangeName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerExchangeTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerExchangeTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerExchangeName_undo_setup(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeName_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerExchangeName undo.
     */
    /*
     * copy brokerExchangeName and brokerExchangeName_len data
     * set rowreq_ctx->undo->brokerExchangeName from rowreq_ctx->data.brokerExchangeName
     */
    memcpy(rowreq_ctx->undo->brokerExchangeName,
           rowreq_ctx->data.brokerExchangeName,
           (rowreq_ctx->data.brokerExchangeName_len *
            sizeof(rowreq_ctx->undo->brokerExchangeName[0])));
    rowreq_ctx->undo->brokerExchangeName_len =
        rowreq_ctx->data.brokerExchangeName_len;


    return MFD_SUCCESS;
}                               /* brokerExchangeName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerExchangeName_val_ptr
 *        A char containing the new value.
 * @param brokerExchangeName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerExchangeName_val_ptr
 */
int
brokerExchangeName_set(brokerExchangeTable_rowreq_ctx * rowreq_ctx,
                       char *brokerExchangeName_val_ptr,
                       size_t brokerExchangeName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeName_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerExchangeName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerExchangeName value.
     * set brokerExchangeName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerExchangeName, brokerExchangeName_val_ptr,
           brokerExchangeName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerExchangeName_len =
        brokerExchangeName_val_ptr_len /
        sizeof(brokerExchangeName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerExchangeName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerExchangeName_undo(brokerExchangeTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerExchangeTable:brokerExchangeName_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerExchangeName undo.
     */
    /*
     * copy brokerExchangeName and brokerExchangeName_len data
     * set rowreq_ctx->data.brokerExchangeName from rowreq_ctx->undo->brokerExchangeName
     */
    memcpy(rowreq_ctx->data.brokerExchangeName,
           rowreq_ctx->undo->brokerExchangeName,
           (rowreq_ctx->undo->brokerExchangeName_len *
            sizeof(rowreq_ctx->data.brokerExchangeName[0])));
    rowreq_ctx->data.brokerExchangeName_len =
        rowreq_ctx->undo->brokerExchangeName_len;


    return MFD_SUCCESS;
}                               /* brokerExchangeName_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerExchangeTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerExchangeTable if you don't have dependencies)
 */
int
brokerExchangeTable_check_dependencies(brokerExchangeTable_rowreq_ctx *
                                       rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerExchangeTable:brokerExchangeTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerExchangeTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerExchangeTable_check_dependencies */

/** @} */
