/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/** \page MFD helper for brokerLinkTable
 *
 * \section intro Introduction
 * Introductory text.
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "LinkTable.h"

#include <net-snmp/agent/mib_modules.h>

#include "LinkTable_interface.h"

const oid       brokerLinkTable_oid[] = { brokerLINKTABLE_OID };

const int       brokerLinkTable_oid_size =
OID_LENGTH(brokerLinkTable_oid);

brokerLinkTable_registration brokerLinkTable_user_context;

void            initialize_table_brokerLinkTable(void);
void            shutdown_table_brokerLinkTable(void);


/**
 * Initializes the brokerLinkTable module
 */
void
init_LinkTable(void)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:init_brokerLinkTable",
                "called\n"));

    /*
     * TODO:300:o: Perform brokerLinkTable one-time module initialization.
     */

    /*
     * here we initialize all the tables we're planning on supporting
     */
    if (should_init("brokerLinkTable"))
        initialize_table_brokerLinkTable();

}                               /* init_brokerLinkTable */

/**
 * Shut-down the brokerLinkTable module (agent is exiting)
 */
void
shutdown_brokerLinkTable(void)
{
    if (should_init("brokerLinkTable"))
        shutdown_table_brokerLinkTable();

}

/**
 * Initialize the table brokerLinkTable 
 *    (Define its contents and how it's structured)
 */
void
initialize_table_brokerLinkTable(void)
{
    brokerLinkTable_registration *user_context;
    u_long          flags;

    DEBUGMSGTL(("verbose:brokerLinkTable:initialize_table_brokerLinkTable", "called\n"));

    /*
     * TODO:301:o: Perform brokerLinkTable one-time table initialization.
     */

    /*
     * TODO:302:o: |->Initialize brokerLinkTable user context
     * if you'd like to pass in a pointer to some data for this
     * table, allocate or set it up here.
     */
    /*
     * a netsnmp_data_list is a simple way to store void pointers. A simple
     * string token is used to add, find or remove pointers.
     */
    user_context =
        netsnmp_create_data_list("brokerLinkTable", NULL, NULL);

    /*
     * No support for any flags yet, but in the future you would
     * set any flags here.
     */
    flags = 0;

    /*
     * call interface initialization code
     */
    _brokerLinkTable_initialize_interface(user_context, flags);
}                               /* initialize_table_brokerLinkTable */

/**
 * Shutdown the table brokerLinkTable 
 */
void
shutdown_table_brokerLinkTable(void)
{
    /*
     * call interface shutdown code
     */
    _brokerLinkTable_shutdown_interface(&brokerLinkTable_user_context);
}

/**
 * extra context initialization (eg default values)
 *
 * @param rowreq_ctx    : row request context
 * @param user_init_ctx : void pointer for user (parameter to rowreq_ctx_allocate)
 *
 * @retval MFD_SUCCESS  : no errors
 * @retval MFD_ERROR    : error (context allocate will fail)
 */
int
brokerLinkTable_rowreq_ctx_init(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                                 void *user_init_ctx)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_rowreq_ctx_init", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:210:o: |-> Perform extra brokerLinkTable rowreq initialization. (eg DEFVALS)
     */

    rowreq_ctx->data.brokerLinkVhostRef_len = 255;
    rowreq_ctx->data.brokerLinkName_len = 255;
    rowreq_ctx->data.brokerLinkHost_len = 255;
    rowreq_ctx->data.brokerLinkTransport_len = 255;
    rowreq_ctx->data.brokerLinkConnectionRef_len = 255;
    rowreq_ctx->data.brokerLinkState_len = 255;
    rowreq_ctx->data.brokerLinkLastError_len = 65535;

    return MFD_SUCCESS;
}                               /* brokerLinkTable_rowreq_ctx_init */

/**
 * extra context cleanup
 *
 */
void
brokerLinkTable_rowreq_ctx_cleanup(brokerLinkTable_rowreq_ctx *
                                    rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_rowreq_ctx_cleanup", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:211:o: |-> Perform extra brokerLinkTable rowreq cleanup.
     */
}                               /* brokerLinkTable_rowreq_ctx_cleanup */

/************************************************************
 * the *_should_save routine is called to determine if a row
 * should be stored persistently.
 *
 * Note that this is not a 'dirty' check (i.e. if a row has changed),
 * but a check for volatile rows that should not be saved between
 * restarts.
 *
 * return 1 if the row should be stored
 * return 0 if the row should not be stored
 */
int
brokerLinkTable_container_should_save(brokerLinkTable_rowreq_ctx *
                                       rowreq_ctx)
{

    return 1;                   /* save the row */
}

/**
 * pre-request callback
 *
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_ERROR                : other error
 */
int
brokerLinkTable_pre_request(brokerLinkTable_registration * user_context)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_pre_request",
                "called\n"));

    /*
     * TODO:510:o: Perform brokerLinkTable pre-request actions.
     */

    return MFD_SUCCESS;
}                               /* brokerLinkTable_pre_request */

/**
 * post-request callback
 *
 * Note:
 *   New rows have been inserted into the container, and
 *   deleted rows have been removed from the container and
 *   released.
 *
 * @param user_context
 * @param rc : MFD_SUCCESS if all requests succeeded
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : other error (ignored)
 */
int
brokerLinkTable_post_request(brokerLinkTable_registration * user_context,
                              int rc)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_post_request",
                "called\n"));

    /*
     * TODO:511:o: Perform brokerLinkTable post-request actions.
     */

    /*
     * check to set if any rows were changed.
     */
    if (brokerLinkTable_dirty_get()) {
        /*
         * check if request was successful. If so, this would be
         * a good place to save data to its persistent store.
         */
        if (MFD_SUCCESS == rc) {
            /*
             * save changed rows, if you haven't already
             */
            snmp_store(netsnmp_ds_get_string(NETSNMP_DS_LIBRARY_ID,
                                             NETSNMP_DS_LIB_APPTYPE));
        }

        brokerLinkTable_dirty_set(0);  /* clear table dirty flag */
    }

    return MFD_SUCCESS;
}                               /* brokerLinkTable_post_request */


/** @{ */
