/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "LinkTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerLinkTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerLinkTable is subid 1 of brokerLinks.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.11.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerLinkTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerLinkTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerLinkTable_undo_setup(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_undo_setup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerLinkTable undo.
     * set up brokerLinkTable undo information, in preparation for a set.
     * Undo storage is in (* brokerLinkLastError_val_ptr_ptr )*
     */

    return rc;
}                               /* brokerLinkTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerLinkTable_undo(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerLinkTable undo.
     * brokerLinkTable undo information, in response to a failed set.
     * Undo storage is in (* brokerLinkLastError_val_ptr_ptr )*
     */

    return rc;
}                               /* brokerLinkTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerLinkTable_undo_cleanup(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_undo_cleanup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerLinkTable undo.
     * Undo storage is in (* brokerLinkLastError_val_ptr_ptr )*
     */

    return rc;
}                               /* brokerLinkTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerLinkTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerLinkTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerLinkTable_commit(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerLinkTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerLINKVHOSTREF_FLAG) {
        save_flags &= ~COLUMN_brokerLINKVHOSTREF_FLAG; /* clear brokerLinkVhostRef */
        /*
         * TODO:482:o: |-> commit column brokerLinkVhostRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerLinkTable column brokerLinkVhostRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerLinkVhostRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerLINKVHOSTREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerLINKNAME_FLAG) {
        save_flags &= ~COLUMN_brokerLINKNAME_FLAG;     /* clear brokerLinkName */
        /*
         * TODO:482:o: |-> commit column brokerLinkName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerLinkTable column brokerLinkName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerLinkName
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerLINKNAME_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerLINKDURABLE_FLAG) {
        save_flags &= ~COLUMN_brokerLINKDURABLE_FLAG;  /* clear brokerLinkDurable */
        /*
         * TODO:482:o: |-> commit column brokerLinkDurable.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerLinkTable column brokerLinkDurable commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerLinkDurable
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerLINKDURABLE_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerLinkTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerLinkTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerLinkTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerLinkTable_undo_commit(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkTable_undo_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerLinkTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerLinkTable_undo_commit */

/*
 * TODO:440:M: Implement brokerLinkTable node value checks.
 * TODO:450:M: Implement brokerLinkTable undo functions.
 * TODO:460:M: Implement brokerLinkTable set functions.
 * TODO:480:M: Implement brokerLinkTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerLinkEntry.brokerLinkVhostRef
 * brokerLinkVhostRef is subid 1 of brokerLinkEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.11.1.1.1
 * Description:
Link vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerLinkVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerLinkVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerLinkVhostRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerLinkTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerLinkVhostRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerLinkVhostRef_check_value(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                                char *brokerLinkVhostRef_val_ptr,
                                size_t brokerLinkVhostRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkVhostRef_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerLinkVhostRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerLinkVhostRef value.
     */

    return MFD_SUCCESS;         /* brokerLinkVhostRef value not illegal */
}                               /* brokerLinkVhostRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerLinkTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerLinkVhostRef_undo_setup(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkVhostRef_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerLinkVhostRef undo.
     */
    /*
     * copy brokerLinkVhostRef and brokerLinkVhostRef_len data
     * set rowreq_ctx->undo->brokerLinkVhostRef from rowreq_ctx->data.brokerLinkVhostRef
     */
    memcpy(rowreq_ctx->undo->brokerLinkVhostRef,
           rowreq_ctx->data.brokerLinkVhostRef,
           (rowreq_ctx->data.brokerLinkVhostRef_len *
            sizeof(rowreq_ctx->undo->brokerLinkVhostRef[0])));
    rowreq_ctx->undo->brokerLinkVhostRef_len =
        rowreq_ctx->data.brokerLinkVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerLinkVhostRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerLinkVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerLinkVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerLinkVhostRef_val_ptr
 */
int
brokerLinkVhostRef_set(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                        char *brokerLinkVhostRef_val_ptr,
                        size_t brokerLinkVhostRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkVhostRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerLinkVhostRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerLinkVhostRef value.
     * set brokerLinkVhostRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerLinkVhostRef,
           brokerLinkVhostRef_val_ptr, brokerLinkVhostRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerLinkVhostRef_len =
        brokerLinkVhostRef_val_ptr_len /
        sizeof(brokerLinkVhostRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerLinkVhostRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerLinkVhostRef_undo(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkVhostRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerLinkVhostRef undo.
     */
    /*
     * copy brokerLinkVhostRef and brokerLinkVhostRef_len data
     * set rowreq_ctx->data.brokerLinkVhostRef from rowreq_ctx->undo->brokerLinkVhostRef
     */
    memcpy(rowreq_ctx->data.brokerLinkVhostRef,
           rowreq_ctx->undo->brokerLinkVhostRef,
           (rowreq_ctx->undo->brokerLinkVhostRef_len *
            sizeof(rowreq_ctx->data.brokerLinkVhostRef[0])));
    rowreq_ctx->data.brokerLinkVhostRef_len =
        rowreq_ctx->undo->brokerLinkVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerLinkVhostRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerLinkEntry.brokerLinkName
 * brokerLinkName is subid 2 of brokerLinkEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.11.1.1.2
 * Description:
Link name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerLinkName_val_ptr
 *        A char containing the new value.
 * @param brokerLinkName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerLinkName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerLinkTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerLinkName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerLinkName_check_value(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                            char *brokerLinkName_val_ptr,
                            size_t brokerLinkName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkName_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerLinkName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerLinkName value.
     */

    return MFD_SUCCESS;         /* brokerLinkName value not illegal */
}                               /* brokerLinkName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerLinkTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerLinkName_undo_setup(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkName_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerLinkName undo.
     */
    /*
     * copy brokerLinkName and brokerLinkName_len data
     * set rowreq_ctx->undo->brokerLinkName from rowreq_ctx->data.brokerLinkName
     */
    memcpy(rowreq_ctx->undo->brokerLinkName,
           rowreq_ctx->data.brokerLinkName,
           (rowreq_ctx->data.brokerLinkName_len *
            sizeof(rowreq_ctx->undo->brokerLinkName[0])));
    rowreq_ctx->undo->brokerLinkName_len =
        rowreq_ctx->data.brokerLinkName_len;


    return MFD_SUCCESS;
}                               /* brokerLinkName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerLinkName_val_ptr
 *        A char containing the new value.
 * @param brokerLinkName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerLinkName_val_ptr
 */
int
brokerLinkName_set(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                    char *brokerLinkName_val_ptr,
                    size_t brokerLinkName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkName_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerLinkName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerLinkName value.
     * set brokerLinkName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerLinkName, brokerLinkName_val_ptr,
           brokerLinkName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerLinkName_len =
        brokerLinkName_val_ptr_len / sizeof(brokerLinkName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerLinkName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerLinkName_undo(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkName_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerLinkName undo.
     */
    /*
     * copy brokerLinkName and brokerLinkName_len data
     * set rowreq_ctx->data.brokerLinkName from rowreq_ctx->undo->brokerLinkName
     */
    memcpy(rowreq_ctx->data.brokerLinkName,
           rowreq_ctx->undo->brokerLinkName,
           (rowreq_ctx->undo->brokerLinkName_len *
            sizeof(rowreq_ctx->data.brokerLinkName[0])));
    rowreq_ctx->data.brokerLinkName_len =
        rowreq_ctx->undo->brokerLinkName_len;


    return MFD_SUCCESS;
}                               /* brokerLinkName_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerLinkEntry.brokerLinkDurable
 * brokerLinkDurable is subid 6 of brokerLinkEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.11.1.1.6
 * Description:
Link durable
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerLinkDurable_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerLinkTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerLinkDurable_check_value(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                               u_long brokerLinkDurable_val)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkDurable_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerLinkDurable value.
     */

    return MFD_SUCCESS;         /* brokerLinkDurable value not illegal */
}                               /* brokerLinkDurable_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerLinkTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerLinkTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerLinkDurable_undo_setup(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkDurable_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerLinkDurable undo.
     */
    /*
     * copy brokerLinkDurable data
     * set rowreq_ctx->undo->brokerLinkDurable from rowreq_ctx->data.brokerLinkDurable
     */
    rowreq_ctx->undo->brokerLinkDurable =
        rowreq_ctx->data.brokerLinkDurable;


    return MFD_SUCCESS;
}                               /* brokerLinkDurable_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerLinkDurable_val
 *        A long containing the new value.
 */
int
brokerLinkDurable_set(brokerLinkTable_rowreq_ctx * rowreq_ctx,
                       u_long brokerLinkDurable_val)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkDurable_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerLinkDurable value.
     * set brokerLinkDurable value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerLinkDurable = brokerLinkDurable_val;

    return MFD_SUCCESS;
}                               /* brokerLinkDurable_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerLinkDurable_undo(brokerLinkTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerLinkTable:brokerLinkDurable_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerLinkDurable undo.
     */
    /*
     * copy brokerLinkDurable data
     * set rowreq_ctx->data.brokerLinkDurable from rowreq_ctx->undo->brokerLinkDurable
     */
    rowreq_ctx->data.brokerLinkDurable =
        rowreq_ctx->undo->brokerLinkDurable;


    return MFD_SUCCESS;
}                               /* brokerLinkDurable_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerLinkTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerLinkTable if you don't have dependencies)
 */
int
brokerLinkTable_check_dependencies(brokerLinkTable_rowreq_ctx *
                                    rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerLinkTable:brokerLinkTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerLinkTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerLinkTable_check_dependencies */

/** @} */
