/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/** \page MFD helper for brokerQueueTable
 *
 * \section intro Introduction
 * Introductory text.
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "QueueTable.h"

#include <net-snmp/agent/mib_modules.h>

const oid       brokerQueueTable_oid[] = { brokerQUEUETABLE_OID };

const int       brokerQueueTable_oid_size =
OID_LENGTH(brokerQueueTable_oid);

brokerQueueTable_registration brokerQueueTable_user_context;

void            initialize_table_brokerQueueTable(void);
void            shutdown_table_brokerQueueTable(void);


/**
 * Initializes the brokerQueueTable module
 */
void
init_QueueTable(void)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:init_QueueTable",
                "called\n"));

    /*
     * TODO:300:o: Perform brokerQueueTable one-time module initialization.
     */

    /*
     * here we initialize all the tables we're planning on supporting
     */
    if (should_init("brokerQueueTable"))
        initialize_table_brokerQueueTable();

}                               /* init_QueueTable */

/**
 * Shut-down the brokerQueueTable module (agent is exiting)
 */
void
shutdown_brokerQueueTable(void)
{
    if (should_init("brokerQueueTable"))
        shutdown_table_brokerQueueTable();

}

/**
 * Initialize the table brokerQueueTable 
 *    (Define its contents and how it's structured)
 */
void
initialize_table_brokerQueueTable(void)
{
    brokerQueueTable_registration *user_context;
    u_long          flags;

    DEBUGMSGTL(("verbose:brokerQueueTable:initialize_table_brokerQueueTable", "called\n"));

    /*
     * TODO:301:o: Perform brokerQueueTable one-time table initialization.
     */

    /*
     * TODO:302:o: |->Initialize brokerQueueTable user context
     * if you'd like to pass in a pointer to some data for this
     * table, allocate or set it up here.
     */
    /*
     * a netsnmp_data_list is a simple way to store void pointers. A simple
     * string token is used to add, find or remove pointers.
     */
    user_context =
        netsnmp_create_data_list("brokerQueueTable", NULL, NULL);

    /*
     * No support for any flags yet, but in the future you would
     * set any flags here.
     */
    flags = 0;

    /*
     * call interface initialization code
     */
    _brokerQueueTable_initialize_interface(user_context, flags);
}                               /* initialize_table_brokerQueueTable */

/**
 * Shutdown the table brokerQueueTable 
 */
void
shutdown_table_brokerQueueTable(void)
{
    /*
     * call interface shutdown code
     */
    _brokerQueueTable_shutdown_interface(&brokerQueueTable_user_context);
}

/**
 * extra context initialization (eg default values)
 *
 * @param rowreq_ctx    : row request context
 * @param user_init_ctx : void pointer for user (parameter to rowreq_ctx_allocate)
 *
 * @retval MFD_SUCCESS  : no errors
 * @retval MFD_ERROR    : error (context allocate will fail)
 */
int
brokerQueueTable_rowreq_ctx_init(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                                 void *user_init_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_rowreq_ctx_init", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:210:o: |-> Perform extra brokerQueueTable rowreq initialization. (eg DEFVALS)
     */
    rowreq_ctx->data.brokerQueueVhostRef_len = 255;
    rowreq_ctx->data.brokerQueueName_len = 255;
    rowreq_ctx->data.brokerQueueArguments_len = 65535;
    rowreq_ctx->data.brokerQueueAltExchange_len = 255;

    return MFD_SUCCESS;
}                               /* brokerQueueTable_rowreq_ctx_init */

/**
 * extra context cleanup
 *
 */
void
brokerQueueTable_rowreq_ctx_cleanup(brokerQueueTable_rowreq_ctx *
                                    rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_rowreq_ctx_cleanup", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:211:o: |-> Perform extra brokerQueueTable rowreq cleanup.
     */
}                               /* brokerQueueTable_rowreq_ctx_cleanup */

/************************************************************
 * the *_should_save routine is called to determine if a row
 * should be stored persistently.
 *
 * Note that this is not a 'dirty' check (i.e. if a row has changed),
 * but a check for volatile rows that should not be saved between
 * restarts.
 *
 * return 1 if the row should be stored
 * return 0 if the row should not be stored
 */
int
brokerQueueTable_container_should_save(brokerQueueTable_rowreq_ctx *
                                       rowreq_ctx)
{

    return 1;                   /* save the row */
}

/**
 * pre-request callback
 *
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_ERROR                : other error
 */
int
brokerQueueTable_pre_request(brokerQueueTable_registration * user_context)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_pre_request",
                "called\n"));

    /*
     * TODO:510:o: Perform brokerQueueTable pre-request actions.
     */

    return MFD_SUCCESS;
}                               /* brokerQueueTable_pre_request */

/**
 * post-request callback
 *
 * Note:
 *   New rows have been inserted into the container, and
 *   deleted rows have been removed from the container and
 *   released.
 *
 * @param user_context
 * @param rc : MFD_SUCCESS if all requests succeeded
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : other error (ignored)
 */
int
brokerQueueTable_post_request(brokerQueueTable_registration * user_context,
                              int rc)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_post_request",
                "called\n"));

    /*
     * TODO:511:o: Perform brokerQueueTable post-request actions.
     */

    /*
     * check to set if any rows were changed.
     */
    if (brokerQueueTable_dirty_get()) {
        /*
         * check if request was successful. If so, this would be
         * a good place to save data to its persistent store.
         */
        if (MFD_SUCCESS == rc) {
            /*
             * save changed rows, if you haven't already
             */
            snmp_store(netsnmp_ds_get_string(NETSNMP_DS_LIBRARY_ID,
                                             NETSNMP_DS_LIB_APPTYPE));
        }

        brokerQueueTable_dirty_set(0);  /* clear table dirty flag */
    }

    return MFD_SUCCESS;
}                               /* brokerQueueTable_post_request */


/** @{ */
