/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../qpid_api.h"

/*
 * include our parent header 
 */
#include "QueueTable.h"


#include "QueueTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerQueueTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerQueueTable is subid 1 of brokerQueues.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1, length: 12
 */

/**
 * initialization for brokerQueueTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param brokerQueueTable_reg
 *        Pointer to brokerQueueTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
brokerQueueTable_init_data(brokerQueueTable_registration *
                           brokerQueueTable_reg)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_init_data",
                "called\n"));

    /*
     * TODO:303:o: Initialize brokerQueueTable data.
     */
    /*
     ***************************************************
     ***             START EXAMPLE CODE              ***
     ***---------------------------------------------***/

    /*
     ***---------------------------------------------***
     ***              END  EXAMPLE CODE              ***
     ***************************************************/

    return MFD_SUCCESS;
}                               /* brokerQueueTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
brokerQueueTable_container_init(netsnmp_container ** container_ptr_ptr,
                                netsnmp_cache * cache)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_container_init",
                "called\n"));

    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,
                 "bad container param to brokerQueueTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,
                 "bad cache param to brokerQueueTable_container_init\n");
        return;
    }

    /*
     * TODO:345:A: Set up brokerQueueTable cache properties.
     *
     * Also for advanced users, you can set parameters for the
     * cache. Do not change the magic pointer, as it is used
     * by the MFD helper. To completely disable caching, set
     * cache->enabled to 0.
     */
    cache->timeout = brokerQUEUETABLE_CACHE_TIMEOUT;    /* seconds */


    /* **EA**
        * preload to assign initial index values
        */
//       cache->flags |= NETSNMP_CACHE_PRELOAD;
}                               /* brokerQueueTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before brokerQueueTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
brokerQueueTable_container_shutdown(netsnmp_container * container_ptr)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_container_shutdown", "called\n"));

    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,
                 "bad params to brokerQueueTable_container_shutdown\n");
        return;
    }
}                               /* brokerQueueTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement brokerQueueTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  brokerQueueTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
brokerQueueTable_container_load(netsnmp_container * container)
{
    brokerQueueTable_rowreq_ctx *rowreq_ctx;
    size_t          count = 0;

    /*
     * temporary storage for index values
     */
    /*
     * brokerQueueInternalIndex(49)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h
     */
    u_long          brokerQueueInternalIndex;
    brokerQueueTable_data qmfData;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_container_load",
                "called\n"));

    /*
     * Load/update data in the brokerQueueTable container.
     * loop over your brokerQueueTable data, allocate a rowreq context,
     * set the index(es) [and data, optionally] and insert into
     * the container.
     */

    uint64_t u64Data;

    void *pEvent = qpidGet("queue");

    int queueIndex;
    uint queues;
    queues = qpidGetCount(pEvent);

    brokerQueueInternalIndex = 0;
    for (queueIndex = 0; queueIndex < queues; ++queueIndex) {

    	void * pRow = qpidGetDataRow(pEvent, queueIndex);
    	if (!pRow)
    		continue;

        strncpy(qmfData.brokerQueueVhostRef,
        		qpidGetString(pRow, "vhostRef"), 254);
        qmfData.brokerQueueVhostRef_len = strlen(qmfData.brokerQueueVhostRef) + 1;

        strncpy(qmfData.brokerQueueName,
        		qpidGetString(pRow, "name"), 254);
        qmfData.brokerQueueName_len = strlen(qmfData.brokerQueueName) + 1;

        strncpy(qmfData.brokerQueueArguments,
        		qpidGetString(pRow, "arguments"), 65534);
        qmfData.brokerQueueArguments_len = strlen(qmfData.brokerQueueArguments) + 1;

        strncpy(qmfData.brokerQueueAltExchange,
        		qpidGetString(pRow, "altExchange"), 254);
        qmfData.brokerQueueAltExchange_len = strlen(qmfData.brokerQueueAltExchange) + 1;

        qmfData.brokerQueueDurable = qpidGetBool(pRow, "durable");
        qmfData.brokerQueueAutoDelete = qpidGetBool(pRow, "autoDelete");
        qmfData.brokerQueueExclusive = qpidGetBool(pRow, "exclusive");

        u64Data = qpidGetU64(pRow, "msgTotalEnqueues");
        qmfData.brokerQueueMsgTotalEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgTotalEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgTotalDequeues");
        qmfData.brokerQueueMsgTotalDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgTotalDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgTxnEnqueues");
        qmfData.brokerQueueMsgTxnEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgTxnEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgTxnDequeues");
        qmfData.brokerQueueMsgTxnDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgTxnDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgPersistEnqueues");
        qmfData.brokerQueueMsgPersistEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgPersistEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgPersistDequeues");
        qmfData.brokerQueueMsgPersistDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgPersistDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgDepth");
        qmfData.brokerQueueMsgDepth.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgDepth.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteDepth");
        qmfData.brokerQueueByteDepth.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteDepth.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteTotalEnqueues");
        qmfData.brokerQueueByteTotalEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteTotalEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteTotalDequeues");
        qmfData.brokerQueueByteTotalDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteTotalDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteTxnEnqueues");
        qmfData.brokerQueueByteTxnEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteTxnEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteTxnDequeues");
        qmfData.brokerQueueByteTxnDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteTxnDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "bytePersistEnqueues");
        qmfData.brokerQueueBytePersistEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueBytePersistEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "bytePersistDequeues");
        qmfData.brokerQueueBytePersistDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueBytePersistDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgFtdEnqueues");
        qmfData.brokerQueueMsgFtdEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgFtdEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgFtdDequeues");
        qmfData.brokerQueueMsgFtdDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgFtdDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteFtdEnqueues");
        qmfData.brokerQueueByteFtdEnqueues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteFtdEnqueues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteFtdDequeues");
        qmfData.brokerQueueByteFtdDequeues.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteFtdDequeues.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "msgFtdDepth");
        qmfData.brokerQueueMsgFtdDepth.high = HIGHLONG(u64Data);
        qmfData.brokerQueueMsgFtdDepth.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "byteFtdDepth");
        qmfData.brokerQueueByteFtdDepth.high = HIGHLONG(u64Data);
        qmfData.brokerQueueByteFtdDepth.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "releases");
        qmfData.brokerQueueReleases.high = HIGHLONG(u64Data);
        qmfData.brokerQueueReleases.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "acquires");
        qmfData.brokerQueueAcquires.high = HIGHLONG(u64Data);
        qmfData.brokerQueueAcquires.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsTtl");
        qmfData.brokerQueueDiscardsTtl.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsTtl.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsRing");
        qmfData.brokerQueueDiscardsRing.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsRing.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsLvq");
        qmfData.brokerQueueDiscardsLvq.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsLvq.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsOverflow");
        qmfData.brokerQueueDiscardsOverflow.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsOverflow.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsSubscriber");
        qmfData.brokerQueueDiscardsSubscriber.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsSubscriber.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "discardsPurge");
        qmfData.brokerQueueDiscardsPurge.high = HIGHLONG(u64Data);
        qmfData.brokerQueueDiscardsPurge.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "reroutes");
        qmfData.brokerQueueReroutes.high = HIGHLONG(u64Data);
        qmfData.brokerQueueReroutes.low = LOWLONG(u64Data);

        qmfData.brokerQueueConsumerCount = qpidGetU32(pRow, "consumerCount");
        qmfData.brokerQueueConsumerCountHi = qpidGetU32(pRow, "consumerCountHigh");
        qmfData.brokerQueueConsumerCountLow = qpidGetU32(pRow, "consumerCountLow");
        qmfData.brokerQueueBindingCount = qpidGetU32(pRow, "bindingCount");
        qmfData.brokerQueueBindingCountHi = qpidGetU32(pRow, "bindingCountHigh");
        qmfData.brokerQueueBindingCountLow = qpidGetU32(pRow, "bindingCountLow");
        qmfData.brokerQueueUnackedMessages = qpidGetU32(pRow, "unackedMessages");
        qmfData.brokerQueueUnackedMessagesHi = qpidGetU32(pRow, "unackedMessagesHigh");
        qmfData.brokerQueueUnackedMessagesLow = qpidGetU32(pRow, "unackedMessagesLow");
        qmfData.brokerQueueMessageLatency = qpidGetU32(pRow, "messageLatency");
        qmfData.brokerQueueFlowStopped = qpidGetBool(pRow, "flowStopped");
        qmfData.brokerQueueFlowStoppedCount = qpidGetU32(pRow, "flowStoppedCount");

        rowreq_ctx = brokerQueueTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if (MFD_SUCCESS !=
            brokerQueueTable_indexes_set(rowreq_ctx,
                                         brokerQueueInternalIndex)) {
            snmp_log(LOG_ERR,
                     "error setting index while loading "
                     "brokerQueueTable data.\n");
            brokerQueueTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }
        ++brokerQueueInternalIndex;

        /*
         * Populate data context here.)
         */
        /*
         * TRANSIENT or semi-TRANSIENT data:
         * copy data or save any info needed to do it in row_prep.
         */
        /*
         * setup/save data for brokerQueueVhostRef
         * brokerQueueVhostRef(1)/ObjId/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerQueueVhostRef data
         */
        if (NULL == rowreq_ctx->data.brokerQueueVhostRef) {
            snmp_log(LOG_ERR,
                     "rowreq_ctx->data.brokerQueueVhostRef was NULL\n");
            return MFD_ERROR;
        }

        if (rowreq_ctx->data.brokerQueueVhostRef_len <
             (qmfData.brokerQueueVhostRef_len * sizeof(qmfData.brokerQueueVhostRef[0]))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerQueueVhostRef)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerQueueVhostRef_len =
            qmfData.brokerQueueVhostRef_len * sizeof(qmfData.brokerQueueVhostRef[0]);
        memcpy(rowreq_ctx->data.brokerQueueVhostRef, qmfData.brokerQueueVhostRef,
               qmfData.brokerQueueVhostRef_len * sizeof(qmfData.brokerQueueVhostRef[0]));

        /*
         * setup/save data for brokerQueueName
         * brokerQueueName(2)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerQueueName data
         */
        if ((NULL == rowreq_ctx->data.brokerQueueName) ||
            (rowreq_ctx->data.brokerQueueName_len <
             (qmfData.brokerQueueName_len * sizeof(qmfData.brokerQueueName[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerQueueName)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerQueueName_len =
            qmfData.brokerQueueName_len * sizeof(qmfData.brokerQueueName[0]);
        memcpy(rowreq_ctx->data.brokerQueueName, qmfData.brokerQueueName,
               qmfData.brokerQueueName_len * sizeof(qmfData.brokerQueueName[0]));

        /*
         * setup/save data for brokerQueueDurable
         * brokerQueueDurable(3)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDurable = qmfData.brokerQueueDurable;

        /*
         * setup/save data for brokerQueueAutoDelete
         * brokerQueueAutoDelete(4)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueAutoDelete = qmfData.brokerQueueAutoDelete;

        /*
         * setup/save data for brokerQueueExclusive
         * brokerQueueExclusive(5)/TruthValue/ASN_INTEGER/long(u_long)//l/A/W/E/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueExclusive = qmfData.brokerQueueExclusive;

        /*
         * setup/save data for brokerQueueArguments
         * brokerQueueArguments(6)/Map/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerQueueArguments data
         */
        if ((NULL == rowreq_ctx->data.brokerQueueArguments) ||
            (rowreq_ctx->data.brokerQueueArguments_len <
             (qmfData.brokerQueueArguments_len *
              sizeof(qmfData.brokerQueueArguments[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerQueueArguments)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerQueueArguments_len =
            qmfData.brokerQueueArguments_len * sizeof(qmfData.brokerQueueArguments[0]);
        memcpy(rowreq_ctx->data.brokerQueueArguments, qmfData.brokerQueueArguments,
               qmfData.brokerQueueArguments_len * sizeof(qmfData.brokerQueueArguments[0]));

        /*
         * setup/save data for brokerQueueAltExchange
         * brokerQueueAltExchange(7)/ObjId/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerQueueAltExchange data
         */
        if ((NULL == rowreq_ctx->data.brokerQueueAltExchange) ||
            (rowreq_ctx->data.brokerQueueAltExchange_len <
             (qmfData.brokerQueueAltExchange_len *
              sizeof(qmfData.brokerQueueAltExchange[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerQueueAltExchange)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerQueueAltExchange_len =
            qmfData.brokerQueueAltExchange_len * sizeof(qmfData.brokerQueueAltExchange[0]);
        memcpy(rowreq_ctx->data.brokerQueueAltExchange,
               qmfData.brokerQueueAltExchange,
               qmfData.brokerQueueAltExchange_len *
               sizeof(qmfData.brokerQueueAltExchange[0]));

        /*
         * setup/save data for brokerQueueMsgTotalEnqueues
         * brokerQueueMsgTotalEnqueues(8)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgTotalEnqueues.high =
            qmfData.brokerQueueMsgTotalEnqueues.high;
        rowreq_ctx->data.brokerQueueMsgTotalEnqueues.low =
            qmfData.brokerQueueMsgTotalEnqueues.low;

        /*
         * setup/save data for brokerQueueMsgTotalDequeues
         * brokerQueueMsgTotalDequeues(9)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgTotalDequeues.high =
            qmfData.brokerQueueMsgTotalDequeues.high;
        rowreq_ctx->data.brokerQueueMsgTotalDequeues.low =
            qmfData.brokerQueueMsgTotalDequeues.low;

        /*
         * setup/save data for brokerQueueMsgTxnEnqueues
         * brokerQueueMsgTxnEnqueues(10)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgTxnEnqueues.high =
            qmfData.brokerQueueMsgTxnEnqueues.high;
        rowreq_ctx->data.brokerQueueMsgTxnEnqueues.low =
            qmfData.brokerQueueMsgTxnEnqueues.low;

        /*
         * setup/save data for brokerQueueMsgTxnDequeues
         * brokerQueueMsgTxnDequeues(11)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgTxnDequeues.high =
            qmfData.brokerQueueMsgTxnDequeues.high;
        rowreq_ctx->data.brokerQueueMsgTxnDequeues.low =
            qmfData.brokerQueueMsgTxnDequeues.low;

        /*
         * setup/save data for brokerQueueMsgPersistEnqueues
         * brokerQueueMsgPersistEnqueues(12)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgPersistEnqueues.high =
            qmfData.brokerQueueMsgPersistEnqueues.high;
        rowreq_ctx->data.brokerQueueMsgPersistEnqueues.low =
            qmfData.brokerQueueMsgPersistEnqueues.low;

        /*
         * setup/save data for brokerQueueMsgPersistDequeues
         * brokerQueueMsgPersistDequeues(13)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgPersistDequeues.high =
            qmfData.brokerQueueMsgPersistDequeues.high;
        rowreq_ctx->data.brokerQueueMsgPersistDequeues.low =
            qmfData.brokerQueueMsgPersistDequeues.low;

        /*
         * setup/save data for brokerQueueMsgDepth
         * brokerQueueMsgDepth(14)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgDepth.high =
            qmfData.brokerQueueMsgDepth.high;
        rowreq_ctx->data.brokerQueueMsgDepth.low = qmfData.brokerQueueMsgDepth.low;

        /*
         * setup/save data for brokerQueueByteDepth
         * brokerQueueByteDepth(15)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteDepth.high =
            qmfData.brokerQueueByteDepth.high;
        rowreq_ctx->data.brokerQueueByteDepth.low =
            qmfData.brokerQueueByteDepth.low;

        /*
         * setup/save data for brokerQueueByteTotalEnqueues
         * brokerQueueByteTotalEnqueues(16)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteTotalEnqueues.high =
            qmfData.brokerQueueByteTotalEnqueues.high;
        rowreq_ctx->data.brokerQueueByteTotalEnqueues.low =
            qmfData.brokerQueueByteTotalEnqueues.low;

        /*
         * setup/save data for brokerQueueByteTotalDequeues
         * brokerQueueByteTotalDequeues(17)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteTotalDequeues.high =
            qmfData.brokerQueueByteTotalDequeues.high;
        rowreq_ctx->data.brokerQueueByteTotalDequeues.low =
            qmfData.brokerQueueByteTotalDequeues.low;

        /*
         * setup/save data for brokerQueueByteTxnEnqueues
         * brokerQueueByteTxnEnqueues(18)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteTxnEnqueues.high =
            qmfData.brokerQueueByteTxnEnqueues.high;
        rowreq_ctx->data.brokerQueueByteTxnEnqueues.low =
            qmfData.brokerQueueByteTxnEnqueues.low;

        /*
         * setup/save data for brokerQueueByteTxnDequeues
         * brokerQueueByteTxnDequeues(19)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteTxnDequeues.high =
            qmfData.brokerQueueByteTxnDequeues.high;
        rowreq_ctx->data.brokerQueueByteTxnDequeues.low =
            qmfData.brokerQueueByteTxnDequeues.low;

        /*
         * setup/save data for brokerQueueBytePersistEnqueues
         * brokerQueueBytePersistEnqueues(20)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueBytePersistEnqueues.high =
            qmfData.brokerQueueBytePersistEnqueues.high;
        rowreq_ctx->data.brokerQueueBytePersistEnqueues.low =
            qmfData.brokerQueueBytePersistEnqueues.low;

        /*
         * setup/save data for brokerQueueBytePersistDequeues
         * brokerQueueBytePersistDequeues(21)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueBytePersistDequeues.high =
            qmfData.brokerQueueBytePersistDequeues.high;
        rowreq_ctx->data.brokerQueueBytePersistDequeues.low =
            qmfData.brokerQueueBytePersistDequeues.low;

        /*
         * setup/save data for brokerQueueMsgFtdEnqueues
         * brokerQueueMsgFtdEnqueues(22)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgFtdEnqueues.high =
            qmfData.brokerQueueMsgFtdEnqueues.high;
        rowreq_ctx->data.brokerQueueMsgFtdEnqueues.low =
            qmfData.brokerQueueMsgFtdEnqueues.low;

        /*
         * setup/save data for brokerQueueMsgFtdDequeues
         * brokerQueueMsgFtdDequeues(23)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgFtdDequeues.high =
            qmfData.brokerQueueMsgFtdDequeues.high;
        rowreq_ctx->data.brokerQueueMsgFtdDequeues.low =
            qmfData.brokerQueueMsgFtdDequeues.low;

        /*
         * setup/save data for brokerQueueByteFtdEnqueues
         * brokerQueueByteFtdEnqueues(24)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteFtdEnqueues.high =
            qmfData.brokerQueueByteFtdEnqueues.high;
        rowreq_ctx->data.brokerQueueByteFtdEnqueues.low =
            qmfData.brokerQueueByteFtdEnqueues.low;

        /*
         * setup/save data for brokerQueueByteFtdDequeues
         * brokerQueueByteFtdDequeues(25)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteFtdDequeues.high =
            qmfData.brokerQueueByteFtdDequeues.high;
        rowreq_ctx->data.brokerQueueByteFtdDequeues.low =
            qmfData.brokerQueueByteFtdDequeues.low;

        /*
         * setup/save data for brokerQueueMsgFtdDepth
         * brokerQueueMsgFtdDepth(26)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMsgFtdDepth.high =
            qmfData.brokerQueueMsgFtdDepth.high;
        rowreq_ctx->data.brokerQueueMsgFtdDepth.low =
            qmfData.brokerQueueMsgFtdDepth.low;

        /*
         * setup/save data for brokerQueueByteFtdDepth
         * brokerQueueByteFtdDepth(27)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueByteFtdDepth.high =
            qmfData.brokerQueueByteFtdDepth.high;
        rowreq_ctx->data.brokerQueueByteFtdDepth.low =
            qmfData.brokerQueueByteFtdDepth.low;

        /*
         * setup/save data for brokerQueueReleases
         * brokerQueueReleases(28)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueReleases.high =
            qmfData.brokerQueueReleases.high;
        rowreq_ctx->data.brokerQueueReleases.low = qmfData.brokerQueueReleases.low;

        /*
         * setup/save data for brokerQueueAcquires
         * brokerQueueAcquires(29)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueAcquires.high =
            qmfData.brokerQueueAcquires.high;
        rowreq_ctx->data.brokerQueueAcquires.low = qmfData.brokerQueueAcquires.low;

        /*
         * setup/save data for brokerQueueDiscardsTtl
         * brokerQueueDiscardsTtl(30)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsTtl.high =
            qmfData.brokerQueueDiscardsTtl.high;
        rowreq_ctx->data.brokerQueueDiscardsTtl.low =
            qmfData.brokerQueueDiscardsTtl.low;

        /*
         * setup/save data for brokerQueueDiscardsRing
         * brokerQueueDiscardsRing(31)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsRing.high =
            qmfData.brokerQueueDiscardsRing.high;
        rowreq_ctx->data.brokerQueueDiscardsRing.low =
            qmfData.brokerQueueDiscardsRing.low;

        /*
         * setup/save data for brokerQueueDiscardsLvq
         * brokerQueueDiscardsLvq(32)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsLvq.high =
            qmfData.brokerQueueDiscardsLvq.high;
        rowreq_ctx->data.brokerQueueDiscardsLvq.low =
            qmfData.brokerQueueDiscardsLvq.low;

        /*
         * setup/save data for brokerQueueDiscardsOverflow
         * brokerQueueDiscardsOverflow(33)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsOverflow.high =
            qmfData.brokerQueueDiscardsOverflow.high;
        rowreq_ctx->data.brokerQueueDiscardsOverflow.low =
            qmfData.brokerQueueDiscardsOverflow.low;

        /*
         * setup/save data for brokerQueueDiscardsSubscriber
         * brokerQueueDiscardsSubscriber(34)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsSubscriber.high =
            qmfData.brokerQueueDiscardsSubscriber.high;
        rowreq_ctx->data.brokerQueueDiscardsSubscriber.low =
            qmfData.brokerQueueDiscardsSubscriber.low;

        /*
         * setup/save data for brokerQueueDiscardsPurge
         * brokerQueueDiscardsPurge(35)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueDiscardsPurge.high =
            qmfData.brokerQueueDiscardsPurge.high;
        rowreq_ctx->data.brokerQueueDiscardsPurge.low =
            qmfData.brokerQueueDiscardsPurge.low;

        /*
         * setup/save data for brokerQueueReroutes
         * brokerQueueReroutes(36)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueReroutes.high =
            qmfData.brokerQueueReroutes.high;
        rowreq_ctx->data.brokerQueueReroutes.low = qmfData.brokerQueueReroutes.low;

        /*
         * setup/save data for brokerQueueConsumerCount
         * brokerQueueConsumerCount(37)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueConsumerCount =
            qmfData.brokerQueueConsumerCount;

        /*
         * setup/save data for brokerQueueConsumerCountHi
         * brokerQueueConsumerCountHi(38)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueConsumerCountHi =
            qmfData.brokerQueueConsumerCountHi;

        /*
         * setup/save data for brokerQueueConsumerCountLow
         * brokerQueueConsumerCountLow(39)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueConsumerCountLow =
            qmfData.brokerQueueConsumerCountLow;

        /*
         * setup/save data for brokerQueueBindingCount
         * brokerQueueBindingCount(40)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueBindingCount = qmfData.brokerQueueBindingCount;

        /*
         * setup/save data for brokerQueueBindingCountHi
         * brokerQueueBindingCountHi(41)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueBindingCountHi =
            qmfData.brokerQueueBindingCountHi;

        /*
         * setup/save data for brokerQueueBindingCountLow
         * brokerQueueBindingCountLow(42)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueBindingCountLow =
            qmfData.brokerQueueBindingCountLow;

        /*
         * setup/save data for brokerQueueUnackedMessages
         * brokerQueueUnackedMessages(43)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueUnackedMessages =
            qmfData.brokerQueueUnackedMessages;

        /*
         * setup/save data for brokerQueueUnackedMessagesHi
         * brokerQueueUnackedMessagesHi(44)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueUnackedMessagesHi =
            qmfData.brokerQueueUnackedMessagesHi;

        /*
         * setup/save data for brokerQueueUnackedMessagesLow
         * brokerQueueUnackedMessagesLow(45)/Hilo32/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueUnackedMessagesLow =
            qmfData.brokerQueueUnackedMessagesLow;

        /*
         * setup/save data for brokerQueueMessageLatency
         * brokerQueueMessageLatency(46)/TICKS/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueMessageLatency =
            qmfData.brokerQueueMessageLatency;

        /*
         * setup/save data for brokerQueueFlowStopped
         * brokerQueueFlowStopped(47)/TruthValue/ASN_INTEGER/long(u_long)//l/A/w/E/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueFlowStopped = qmfData.brokerQueueFlowStopped;

        /*
         * setup/save data for brokerQueueFlowStoppedCount
         * brokerQueueFlowStoppedCount(48)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerQueueFlowStoppedCount =
            qmfData.brokerQueueFlowStoppedCount;


        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        ++count;

        qpidReleaseDataRow(pRow);


    }
    qpidRelease(pEvent);

    DEBUGMSGT(("verbose:brokerQueueTable:brokerQueueTable_container_load",
               "inserted %d records\n", (int)count));

    return MFD_SUCCESS;
}                               /* brokerQueueTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
brokerQueueTable_container_free(netsnmp_container * container)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_container_free",
                "called\n"));

    /*
     * TODO:380:M: Free brokerQueueTable container data.
     */
}                               /* brokerQueueTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
brokerQueueTable_row_prep(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_row_prep",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
}                               /* brokerQueueTable_row_prep */

/*
 * TODO:420:r: Implement brokerQueueTable index validation.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueInternalIndex
 * brokerQueueInternalIndex is subid 49 of brokerQueueEntry.
 * Its status is Current, and its access level is NoAccess.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.49
 * Description:
Internal index for queue table
 *
 * Attributes:
 *   accessible 0     isscalar 0     enums  0      hasdefval 0
 *   readable   0     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 *
 *
 *
 * NOTE: NODE brokerQueueInternalIndex IS NOT ACCESSIBLE
 *
 *
 */
/**
 * check validity of brokerQueueInternalIndex index portion
 *
 * @retval MFD_SUCCESS   : the incoming value is legal
 * @retval MFD_ERROR     : the incoming value is NOT legal
 *
 * @note this is not the place to do any checks for the sanity
 *       of multiple indexes. Those types of checks should be done in the
 *       brokerQueueTable_validate_index() function.
 *
 * @note Also keep in mind that if the index refers to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 * The following checks have already been done for you:
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 */
int
brokerQueueInternalIndex_check_index(brokerQueueTable_rowreq_ctx *
                                     rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueInternalIndex_check_index", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:426:M: |-> Check brokerQueueTable index brokerQueueInternalIndex.
     * check that index value in the table context is legal.
     * (rowreq_ctx->tbl_index.brokerQueueInternalIndex)
     */

    return MFD_SUCCESS;         /* brokerQueueInternalIndex index ok */
}                               /* brokerQueueInternalIndex_check_index */

/**
 * verify specified index is valid.
 *
 * This check is independent of whether or not the values specified for
 * the columns of the new row are valid. Column values and row consistency
 * will be checked later. At this point, only the index values should be
 * checked.
 *
 * All of the individual index validation functions have been called, so this
 * is the place to make sure they are valid as a whole when combined. If
 * you only have one index, then you probably don't need to do anything else
 * here.
 * 
 * @note Keep in mind that if the indexes refer to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 *
 * @param brokerQueueTable_reg
 *        Pointer to the user registration data
 * @param brokerQueueTable_rowreq_ctx
 *        Pointer to the users context.
 * @retval MFD_SUCCESS            : success
 * @retval MFD_CANNOT_CREATE_NOW  : index not valid right now
 * @retval MFD_CANNOT_CREATE_EVER : index never valid
 */
int
brokerQueueTable_validate_index(brokerQueueTable_registration *
                                brokerQueueTable_reg,
                                brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_validate_index",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:430:M: |-> Validate potential brokerQueueTable index.
     */
    if (0) {
        snmp_log(LOG_WARNING, "invalid index for a new row in the "
                 "brokerQueueTable table.\n");
        /*
         * determine failure type.
         *
         * If the index could not ever be created, return MFD_NOT_EVER
         * If the index can not be created under the present circumstances
         * (even though it could be created under other circumstances),
         * return MFD_NOT_NOW.
         */
        if (0) {
            return MFD_CANNOT_CREATE_EVER;
        } else {
            return MFD_CANNOT_CREATE_NOW;
        }
    }

    return rc;
}                               /* brokerQueueTable_validate_index */

/** @} */
