/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "QueueTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerQueueTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerQueueTable is subid 1 of brokerQueues.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerQueueTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerQueueTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerQueueTable_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_undo_setup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerQueueTable undo.
     * set up brokerQueueTable undo information, in preparation for a set.
     * Undo storage is in (* brokerQueueFlowStoppedCount_val_ptr )*
     */

    return rc;
}                               /* brokerQueueTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerQueueTable_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerQueueTable undo.
     * brokerQueueTable undo information, in response to a failed set.
     * Undo storage is in (* brokerQueueFlowStoppedCount_val_ptr )*
     */

    return rc;
}                               /* brokerQueueTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerQueueTable_undo_cleanup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_undo_cleanup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerQueueTable undo.
     * Undo storage is in (* brokerQueueFlowStoppedCount_val_ptr )*
     */

    return rc;
}                               /* brokerQueueTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerQueueTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerQueueTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerQueueTable_commit(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerQueueTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerQUEUEVHOSTREF_FLAG) {
        save_flags &= ~COLUMN_brokerQUEUEVHOSTREF_FLAG; /* clear brokerQueueVhostRef */
        /*
         * TODO:482:o: |-> commit column brokerQueueVhostRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerQueueTable column brokerQueueVhostRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerQueueVhostRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerQUEUEVHOSTREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerQUEUENAME_FLAG) {
        save_flags &= ~COLUMN_brokerQUEUENAME_FLAG;     /* clear brokerQueueName */
        /*
         * TODO:482:o: |-> commit column brokerQueueName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerQueueTable column brokerQueueName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerQueueName
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerQUEUENAME_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerQUEUEDURABLE_FLAG) {
        save_flags &= ~COLUMN_brokerQUEUEDURABLE_FLAG;  /* clear brokerQueueDurable */
        /*
         * TODO:482:o: |-> commit column brokerQueueDurable.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerQueueTable column brokerQueueDurable commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerQueueDurable
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerQUEUEDURABLE_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerQUEUEAUTODELETE_FLAG) {
        save_flags &= ~COLUMN_brokerQUEUEAUTODELETE_FLAG;       /* clear brokerQueueAutoDelete */
        /*
         * TODO:482:o: |-> commit column brokerQueueAutoDelete.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerQueueTable column brokerQueueAutoDelete commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerQueueAutoDelete
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerQUEUEAUTODELETE_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerQUEUEEXCLUSIVE_FLAG) {
        save_flags &= ~COLUMN_brokerQUEUEEXCLUSIVE_FLAG;        /* clear brokerQueueExclusive */
        /*
         * TODO:482:o: |-> commit column brokerQueueExclusive.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerQueueTable column brokerQueueExclusive commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerQueueExclusive
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerQUEUEEXCLUSIVE_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerQueueTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerQueueTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerQueueTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerQueueTable_undo_commit(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueTable_undo_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerQueueTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerQueueTable_undo_commit */

/*
 * TODO:440:M: Implement brokerQueueTable node value checks.
 * TODO:450:M: Implement brokerQueueTable undo functions.
 * TODO:460:M: Implement brokerQueueTable set functions.
 * TODO:480:M: Implement brokerQueueTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueVhostRef
 * brokerQueueVhostRef is subid 1 of brokerQueueEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.1
 * Description:
Queue vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerQueueVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerQueueVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerQueueVhostRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerQueueTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerQueueVhostRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerQueueVhostRef_check_value(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                                char *brokerQueueVhostRef_val_ptr,
                                size_t brokerQueueVhostRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueVhostRef_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerQueueVhostRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerQueueVhostRef value.
     */

    return MFD_SUCCESS;         /* brokerQueueVhostRef value not illegal */
}                               /* brokerQueueVhostRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerQueueTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerQueueVhostRef_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueVhostRef_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerQueueVhostRef undo.
     */
    /*
     * copy brokerQueueVhostRef and brokerQueueVhostRef_len data
     * set rowreq_ctx->undo->brokerQueueVhostRef from rowreq_ctx->data.brokerQueueVhostRef
     */
    memcpy(rowreq_ctx->undo->brokerQueueVhostRef,
           rowreq_ctx->data.brokerQueueVhostRef,
           (rowreq_ctx->data.brokerQueueVhostRef_len *
            sizeof(rowreq_ctx->undo->brokerQueueVhostRef[0])));
    rowreq_ctx->undo->brokerQueueVhostRef_len =
        rowreq_ctx->data.brokerQueueVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerQueueVhostRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerQueueVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerQueueVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerQueueVhostRef_val_ptr
 */
int
brokerQueueVhostRef_set(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                        char *brokerQueueVhostRef_val_ptr,
                        size_t brokerQueueVhostRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueVhostRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerQueueVhostRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerQueueVhostRef value.
     * set brokerQueueVhostRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerQueueVhostRef,
           brokerQueueVhostRef_val_ptr, brokerQueueVhostRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerQueueVhostRef_len =
        brokerQueueVhostRef_val_ptr_len /
        sizeof(brokerQueueVhostRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerQueueVhostRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerQueueVhostRef_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueVhostRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerQueueVhostRef undo.
     */
    /*
     * copy brokerQueueVhostRef and brokerQueueVhostRef_len data
     * set rowreq_ctx->data.brokerQueueVhostRef from rowreq_ctx->undo->brokerQueueVhostRef
     */
    memcpy(rowreq_ctx->data.brokerQueueVhostRef,
           rowreq_ctx->undo->brokerQueueVhostRef,
           (rowreq_ctx->undo->brokerQueueVhostRef_len *
            sizeof(rowreq_ctx->data.brokerQueueVhostRef[0])));
    rowreq_ctx->data.brokerQueueVhostRef_len =
        rowreq_ctx->undo->brokerQueueVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerQueueVhostRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueName
 * brokerQueueName is subid 2 of brokerQueueEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.2
 * Description:
Queue name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerQueueName_val_ptr
 *        A char containing the new value.
 * @param brokerQueueName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerQueueName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerQueueTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerQueueName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerQueueName_check_value(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                            char *brokerQueueName_val_ptr,
                            size_t brokerQueueName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueName_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerQueueName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerQueueName value.
     */

    return MFD_SUCCESS;         /* brokerQueueName value not illegal */
}                               /* brokerQueueName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerQueueTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerQueueName_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueName_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerQueueName undo.
     */
    /*
     * copy brokerQueueName and brokerQueueName_len data
     * set rowreq_ctx->undo->brokerQueueName from rowreq_ctx->data.brokerQueueName
     */
    memcpy(rowreq_ctx->undo->brokerQueueName,
           rowreq_ctx->data.brokerQueueName,
           (rowreq_ctx->data.brokerQueueName_len *
            sizeof(rowreq_ctx->undo->brokerQueueName[0])));
    rowreq_ctx->undo->brokerQueueName_len =
        rowreq_ctx->data.brokerQueueName_len;


    return MFD_SUCCESS;
}                               /* brokerQueueName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerQueueName_val_ptr
 *        A char containing the new value.
 * @param brokerQueueName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerQueueName_val_ptr
 */
int
brokerQueueName_set(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                    char *brokerQueueName_val_ptr,
                    size_t brokerQueueName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueName_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerQueueName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerQueueName value.
     * set brokerQueueName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerQueueName, brokerQueueName_val_ptr,
           brokerQueueName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerQueueName_len =
        brokerQueueName_val_ptr_len / sizeof(brokerQueueName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerQueueName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerQueueName_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueName_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerQueueName undo.
     */
    /*
     * copy brokerQueueName and brokerQueueName_len data
     * set rowreq_ctx->data.brokerQueueName from rowreq_ctx->undo->brokerQueueName
     */
    memcpy(rowreq_ctx->data.brokerQueueName,
           rowreq_ctx->undo->brokerQueueName,
           (rowreq_ctx->undo->brokerQueueName_len *
            sizeof(rowreq_ctx->data.brokerQueueName[0])));
    rowreq_ctx->data.brokerQueueName_len =
        rowreq_ctx->undo->brokerQueueName_len;


    return MFD_SUCCESS;
}                               /* brokerQueueName_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueDurable
 * brokerQueueDurable is subid 3 of brokerQueueEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.3
 * Description:
Queue durable
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerQueueDurable_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerQueueTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerQueueDurable_check_value(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                               u_long brokerQueueDurable_val)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueDurable_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerQueueDurable value.
     */

    return MFD_SUCCESS;         /* brokerQueueDurable value not illegal */
}                               /* brokerQueueDurable_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerQueueTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerQueueDurable_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueDurable_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerQueueDurable undo.
     */
    /*
     * copy brokerQueueDurable data
     * set rowreq_ctx->undo->brokerQueueDurable from rowreq_ctx->data.brokerQueueDurable
     */
    rowreq_ctx->undo->brokerQueueDurable =
        rowreq_ctx->data.brokerQueueDurable;


    return MFD_SUCCESS;
}                               /* brokerQueueDurable_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerQueueDurable_val
 *        A long containing the new value.
 */
int
brokerQueueDurable_set(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                       u_long brokerQueueDurable_val)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueDurable_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerQueueDurable value.
     * set brokerQueueDurable value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerQueueDurable = brokerQueueDurable_val;

    return MFD_SUCCESS;
}                               /* brokerQueueDurable_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerQueueDurable_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueDurable_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerQueueDurable undo.
     */
    /*
     * copy brokerQueueDurable data
     * set rowreq_ctx->data.brokerQueueDurable from rowreq_ctx->undo->brokerQueueDurable
     */
    rowreq_ctx->data.brokerQueueDurable =
        rowreq_ctx->undo->brokerQueueDurable;


    return MFD_SUCCESS;
}                               /* brokerQueueDurable_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueAutoDelete
 * brokerQueueAutoDelete is subid 4 of brokerQueueEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.4
 * Description:
Queue autoDelete
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerQueueAutoDelete_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerQueueTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerQueueAutoDelete_check_value(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                                  u_long brokerQueueAutoDelete_val)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueAutoDelete_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerQueueAutoDelete value.
     */

    return MFD_SUCCESS;         /* brokerQueueAutoDelete value not illegal */
}                               /* brokerQueueAutoDelete_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerQueueTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerQueueAutoDelete_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueAutoDelete_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerQueueAutoDelete undo.
     */
    /*
     * copy brokerQueueAutoDelete data
     * set rowreq_ctx->undo->brokerQueueAutoDelete from rowreq_ctx->data.brokerQueueAutoDelete
     */
    rowreq_ctx->undo->brokerQueueAutoDelete =
        rowreq_ctx->data.brokerQueueAutoDelete;


    return MFD_SUCCESS;
}                               /* brokerQueueAutoDelete_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerQueueAutoDelete_val
 *        A long containing the new value.
 */
int
brokerQueueAutoDelete_set(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                          u_long brokerQueueAutoDelete_val)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueAutoDelete_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerQueueAutoDelete value.
     * set brokerQueueAutoDelete value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerQueueAutoDelete = brokerQueueAutoDelete_val;

    return MFD_SUCCESS;
}                               /* brokerQueueAutoDelete_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerQueueAutoDelete_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueAutoDelete_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerQueueAutoDelete undo.
     */
    /*
     * copy brokerQueueAutoDelete data
     * set rowreq_ctx->data.brokerQueueAutoDelete from rowreq_ctx->undo->brokerQueueAutoDelete
     */
    rowreq_ctx->data.brokerQueueAutoDelete =
        rowreq_ctx->undo->brokerQueueAutoDelete;


    return MFD_SUCCESS;
}                               /* brokerQueueAutoDelete_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerQueueEntry.brokerQueueExclusive
 * brokerQueueExclusive is subid 5 of brokerQueueEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.6.1.1.5
 * Description:
Queue exclusive
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerQueueExclusive_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerQueueTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerQueueExclusive_check_value(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                                 u_long brokerQueueExclusive_val)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueExclusive_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerQueueExclusive value.
     */

    return MFD_SUCCESS;         /* brokerQueueExclusive value not illegal */
}                               /* brokerQueueExclusive_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerQueueTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerQueueTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerQueueExclusive_undo_setup(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueExclusive_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerQueueExclusive undo.
     */
    /*
     * copy brokerQueueExclusive data
     * set rowreq_ctx->undo->brokerQueueExclusive from rowreq_ctx->data.brokerQueueExclusive
     */
    rowreq_ctx->undo->brokerQueueExclusive =
        rowreq_ctx->data.brokerQueueExclusive;


    return MFD_SUCCESS;
}                               /* brokerQueueExclusive_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerQueueExclusive_val
 *        A long containing the new value.
 */
int
brokerQueueExclusive_set(brokerQueueTable_rowreq_ctx * rowreq_ctx,
                         u_long brokerQueueExclusive_val)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueExclusive_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerQueueExclusive value.
     * set brokerQueueExclusive value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerQueueExclusive = brokerQueueExclusive_val;

    return MFD_SUCCESS;
}                               /* brokerQueueExclusive_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerQueueExclusive_undo(brokerQueueTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerQueueTable:brokerQueueExclusive_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerQueueExclusive undo.
     */
    /*
     * copy brokerQueueExclusive data
     * set rowreq_ctx->data.brokerQueueExclusive from rowreq_ctx->undo->brokerQueueExclusive
     */
    rowreq_ctx->data.brokerQueueExclusive =
        rowreq_ctx->undo->brokerQueueExclusive;


    return MFD_SUCCESS;
}                               /* brokerQueueExclusive_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerQueueTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerQueueTable if you don't have dependencies)
 */
int
brokerQueueTable_check_dependencies(brokerQueueTable_rowreq_ctx *
                                    rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerQueueTable:brokerQueueTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerQueueTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerQueueTable_check_dependencies */

/** @} */
