/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/** \page MFD helper for brokerSessionTable
 *
 * \section intro Introduction
 * Introductory text.
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "SessionTable.h"

#include <net-snmp/agent/mib_modules.h>

#include "SessionTable_interface.h"

const oid       brokerSessionTable_oid[] = { brokerSESSIONTABLE_OID };

const int       brokerSessionTable_oid_size =
OID_LENGTH(brokerSessionTable_oid);

brokerSessionTable_registration brokerSessionTable_user_context;

void            initialize_table_brokerSessionTable(void);
void            shutdown_table_brokerSessionTable(void);


/**
 * Initializes the brokerSessionTable module
 */
void
init_SessionTable(void)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:init_SessionTable",
                "called\n"));

    /*
     * TODO:300:o: Perform brokerSessionTable one-time module initialization.
     */

    /*
     * here we initialize all the tables we're planning on supporting
     */
    if (should_init("brokerSessionTable"))
        initialize_table_brokerSessionTable();

}                               /* init_SessionTable */

/**
 * Shut-down the brokerSessionTable module (agent is exiting)
 */
void
shutdown_brokerSessionTable(void)
{
    if (should_init("brokerSessionTable"))
        shutdown_table_brokerSessionTable();

}

/**
 * Initialize the table brokerSessionTable 
 *    (Define its contents and how it's structured)
 */
void
initialize_table_brokerSessionTable(void)
{
    brokerSessionTable_registration *user_context;
    u_long          flags;

    DEBUGMSGTL(("verbose:brokerSessionTable:initialize_table_brokerSessionTable", "called\n"));

    /*
     * TODO:301:o: Perform brokerSessionTable one-time table initialization.
     */

    /*
     * TODO:302:o: |->Initialize brokerSessionTable user context
     * if you'd like to pass in a pointer to some data for this
     * table, allocate or set it up here.
     */
    /*
     * a netsnmp_data_list is a simple way to store void pointers. A simple
     * string token is used to add, find or remove pointers.
     */
    user_context =
        netsnmp_create_data_list("brokerSessionTable", NULL, NULL);

    /*
     * No support for any flags yet, but in the future you would
     * set any flags here.
     */
    flags = 0;

    /*
     * call interface initialization code
     */
    _brokerSessionTable_initialize_interface(user_context, flags);
}                               /* initialize_table_brokerSessionTable */

/**
 * Shutdown the table brokerSessionTable 
 */
void
shutdown_table_brokerSessionTable(void)
{
    /*
     * call interface shutdown code
     */
    _brokerSessionTable_shutdown_interface
        (&brokerSessionTable_user_context);
}

/**
 * extra context initialization (eg default values)
 *
 * @param rowreq_ctx    : row request context
 * @param user_init_ctx : void pointer for user (parameter to rowreq_ctx_allocate)
 *
 * @retval MFD_SUCCESS  : no errors
 * @retval MFD_ERROR    : error (context allocate will fail)
 */
int
brokerSessionTable_rowreq_ctx_init(brokerSessionTable_rowreq_ctx *
                                   rowreq_ctx, void *user_init_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_rowreq_ctx_init", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:210:o: |-> Perform extra brokerSessionTable rowreq initialization. (eg DEFVALS)
     */
    rowreq_ctx->data.brokerSessionVhostRef_len = sizeof(rowreq_ctx->data.brokerSessionVhostRef) /
    		sizeof(rowreq_ctx->data.brokerSessionVhostRef[0]);
    rowreq_ctx->data.brokerSessionName_len = sizeof(rowreq_ctx->data.brokerSessionName) /
    		sizeof(rowreq_ctx->data.brokerSessionName[0]);
    rowreq_ctx->data.brokerSessionConnectionRef_len = sizeof(rowreq_ctx->data.brokerSessionConnectionRef) /
    		sizeof(rowreq_ctx->data.brokerSessionConnectionRef[0]);

    return MFD_SUCCESS;
}                               /* brokerSessionTable_rowreq_ctx_init */

/**
 * extra context cleanup
 *
 */
void
brokerSessionTable_rowreq_ctx_cleanup(brokerSessionTable_rowreq_ctx *
                                      rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_rowreq_ctx_cleanup", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:211:o: |-> Perform extra brokerSessionTable rowreq cleanup.
     */
}                               /* brokerSessionTable_rowreq_ctx_cleanup */

/************************************************************
 * the *_should_save routine is called to determine if a row
 * should be stored persistently.
 *
 * Note that this is not a 'dirty' check (i.e. if a row has changed),
 * but a check for volatile rows that should not be saved between
 * restarts.
 *
 * return 1 if the row should be stored
 * return 0 if the row should not be stored
 */
int
brokerSessionTable_container_should_save(brokerSessionTable_rowreq_ctx *
                                         rowreq_ctx)
{

    return 1;                   /* save the row */
}

/**
 * pre-request callback
 *
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_ERROR                : other error
 */
int
brokerSessionTable_pre_request(brokerSessionTable_registration *
                               user_context)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_pre_request", "called\n"));

    /*
     * TODO:510:o: Perform brokerSessionTable pre-request actions.
     */

    return MFD_SUCCESS;
}                               /* brokerSessionTable_pre_request */

/**
 * post-request callback
 *
 * Note:
 *   New rows have been inserted into the container, and
 *   deleted rows have been removed from the container and
 *   released.
 *
 * @param user_context
 * @param rc : MFD_SUCCESS if all requests succeeded
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : other error (ignored)
 */
int
brokerSessionTable_post_request(brokerSessionTable_registration *
                                user_context, int rc)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_post_request", "called\n"));

    /*
     * TODO:511:o: Perform brokerSessionTable post-request actions.
     */

    /*
     * check to set if any rows were changed.
     */
    if (brokerSessionTable_dirty_get()) {
        /*
         * check if request was successful. If so, this would be
         * a good place to save data to its persistent store.
         */
        if (MFD_SUCCESS == rc) {
            /*
             * save changed rows, if you haven't already
             */
            snmp_store(netsnmp_ds_get_string(NETSNMP_DS_LIBRARY_ID,
                                             NETSNMP_DS_LIB_APPTYPE));
        }

        brokerSessionTable_dirty_set(0);        /* clear table dirty flag */
    }

    return MFD_SUCCESS;
}                               /* brokerSessionTable_post_request */


/** @{ */
