/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "../qpid_api.h"

/*
 * include our parent header 
 */
#include "SessionTable.h"


#include "SessionTable_data_access.h"

/** @ingroup interface
 * @addtogroup data_access data_access: Routines to access data
 *
 * These routines are used to locate the data used to satisfy
 * requests.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerSessionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerSessionTable is subid 1 of brokerSessions.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1, length: 12
 */

/**
 * initialization for brokerSessionTable data access
 *
 * This function is called during startup to allow you to
 * allocate any resources you need for the data table.
 *
 * @param brokerSessionTable_reg
 *        Pointer to brokerSessionTable_registration
 *
 * @retval MFD_SUCCESS : success.
 * @retval MFD_ERROR   : unrecoverable error.
 */
int
brokerSessionTable_init_data(brokerSessionTable_registration *
                             brokerSessionTable_reg)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_init_data",
                "called\n"));

    /*
     * TODO:303:o: Initialize brokerSessionTable data.
     */
    /*
     ***************************************************
     ***             START EXAMPLE CODE              ***
     ***---------------------------------------------***/
    /*
     * if you are the sole writer for the file, you could
     * open it here. However, as stated earlier, we are assuming
     * the worst case, which in this case means that the file is
     * written to by someone else, and might not even exist when
     * we start up. So we can't do anything here.
     */
    /*
     ***---------------------------------------------***
     ***              END  EXAMPLE CODE              ***
     ***************************************************/

    return MFD_SUCCESS;
}                               /* brokerSessionTable_init_data */

/**
 * container overview
 *
 */

/**
 * container initialization
 *
 * @param container_ptr_ptr A pointer to a container pointer. If you
 *        create a custom container, use this parameter to return it
 *        to the MFD helper. If set to NULL, the MFD helper will
 *        allocate a container for you.
 * @param  cache A pointer to a cache structure. You can set the timeout
 *         and other cache flags using this pointer.
 *
 *  This function is called at startup to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases. If no custom
 *  container is allocated, the MFD code will create one for your.
 *
 *  This is also the place to set up cache behavior. The default, to
 *  simply set the cache timeout, will work well with the default
 *  container. If you are using a custom container, you may want to
 *  look at the cache helper documentation to see if there are any
 *  flags you want to set.
 *
 * @remark
 *  This would also be a good place to do any initialization needed
 *  for you data source. For example, opening a connection to another
 *  process that will supply the data, opening a database, etc.
 */
void
brokerSessionTable_container_init(netsnmp_container ** container_ptr_ptr,
                                  netsnmp_cache * cache)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_container_init", "called\n"));

    if (NULL == container_ptr_ptr) {
        snmp_log(LOG_ERR,
                 "bad container param to brokerSessionTable_container_init\n");
        return;
    }

    /*
     * For advanced users, you can use a custom container. If you
     * do not create one, one will be created for you.
     */
    *container_ptr_ptr = NULL;

    if (NULL == cache) {
        snmp_log(LOG_ERR,
                 "bad cache param to brokerSessionTable_container_init\n");
        return;
    }

    /* **EA**
        * preload to assign initial index values
        */

    cache->timeout = brokerSESSIONTABLE_CACHE_TIMEOUT;  /* seconds */
    //cache->flags |= NETSNMP_CACHE_PRELOAD;
}                               /* brokerSessionTable_container_init */

/**
 * container shutdown
 *
 * @param container_ptr A pointer to the container.
 *
 *  This function is called at shutdown to allow you to customize certain
 *  aspects of the access method. For the most part, it is for advanced
 *  users. The default code should suffice for most cases.
 *
 *  This function is called before brokerSessionTable_container_free().
 *
 * @remark
 *  This would also be a good place to do any cleanup needed
 *  for you data source. For example, closing a connection to another
 *  process that supplied the data, closing a database, etc.
 */
void
brokerSessionTable_container_shutdown(netsnmp_container * container_ptr)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_container_shutdown", "called\n"));

    if (NULL == container_ptr) {
        snmp_log(LOG_ERR,
                 "bad params to brokerSessionTable_container_shutdown\n");
        return;
    }

}                               /* brokerSessionTable_container_shutdown */

/**
 * load initial data
 *
 * TODO:350:M: Implement brokerSessionTable data load
 * This function will also be called by the cache helper to load
 * the container again (after the container free function has been
 * called to free the previous contents).
 *
 * @param container container to which items should be inserted
 *
 * @retval MFD_SUCCESS              : success.
 * @retval MFD_RESOURCE_UNAVAILABLE : Can't access data source
 * @retval MFD_ERROR                : other error.
 *
 *  This function is called to load the index(es) (and data, optionally)
 *  for the every row in the data set.
 *
 * @remark
 *  While loading the data, the only important thing is the indexes.
 *  If access to your data is cheap/fast (e.g. you have a pointer to a
 *  structure in memory), it would make sense to update the data here.
 *  If, however, the accessing the data invovles more work (e.g. parsing
 *  some other existing data, or peforming calculations to derive the data),
 *  then you can limit yourself to setting the indexes and saving any
 *  information you will need later. Then use the saved information in
 *  brokerSessionTable_row_prep() for populating data.
 *
 * @note
 *  If you need consistency between rows (like you want statistics
 *  for each row to be from the same time frame), you should set all
 *  data here.
 *
 */
int
brokerSessionTable_container_load(netsnmp_container * container)
{
    brokerSessionTable_rowreq_ctx *rowreq_ctx;
    size_t          count = 0;

    /*
     * temporary storage for index values
     */
    /*
     * brokerSessionInternalIndex(15)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h
     */
    u_long          brokerSessionInternalIndex;
    brokerSessionTable_data qmfData;


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_container_load", "called\n"));

    uint64_t u64Data;

    void *pEvent = qpidGet("session");

    int index;
    uint objects;
    objects = qpidGetCount(pEvent);

    brokerSessionInternalIndex = 0;
    for (index = 0; index < objects; ++index) {

    	void * pRow = qpidGetDataRow(pEvent, index);
    	if (!pRow)
    		continue;

        strncpy(qmfData.brokerSessionVhostRef,
        		qpidGetString(pRow, "vhostRef"), 254);
        qmfData.brokerSessionVhostRef_len = strlen(qmfData.brokerSessionVhostRef) + 1;

        strncpy(qmfData.brokerSessionName,
        		qpidGetString(pRow, "name"), 254);
        qmfData.brokerSessionName_len = strlen(qmfData.brokerSessionName) + 1;

        qmfData.brokerSessionChannelId = qpidGetU16(pRow, "channelId");

        strncpy(qmfData.brokerSessionConnectionRef,
        		qpidGetString(pRow, "connectionRef"), 254);
        qmfData.brokerSessionConnectionRef_len = strlen(qmfData.brokerSessionConnectionRef) + 1;

        qmfData.brokerSessionDetachedLifespan = qpidGetU32(pRow, "detachedLifespan");
        qmfData.brokerSessionAttached = qpidGetBool(pRow, "attached");
        qmfData.brokerSessionExpireTime = qpidGetU32(pRow, "expireTime");
        qmfData.brokerSessionMaxClientRate = qpidGetU32(pRow, "maxClientRate");

        u64Data = qpidGetU64(pRow, "unackedMessages");
        qmfData.brokerSessionUnackedMessages.high = HIGHLONG(u64Data);
        qmfData.brokerSessionUnackedMessages.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "TxnStarts");
        qmfData.brokerSessionTxnStarts.high = HIGHLONG(u64Data);
        qmfData.brokerSessionTxnStarts.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "TxnCommits");
        qmfData.brokerSessionTxnCommits.high = HIGHLONG(u64Data);
        qmfData.brokerSessionTxnCommits.low = LOWLONG(u64Data);

        u64Data = qpidGetU64(pRow, "TxnRejects");
        qmfData.brokerSessionTxnRejects.high = HIGHLONG(u64Data);
        qmfData.brokerSessionTxnRejects.low = LOWLONG(u64Data);

        qmfData.brokerSessionTxnCount = qpidGetU32(pRow, "TxnCount");
        qmfData.brokerSessionClientCredit = qpidGetU32(pRow, "clientCredit");

        /*
         * set indexes in new brokerSessionTable rowreq context.
         * data context will be set from the param (unless NULL,
         *      in which case a new data context will be allocated)
         */
        rowreq_ctx = brokerSessionTable_allocate_rowreq_ctx(NULL);
        if (NULL == rowreq_ctx) {
            snmp_log(LOG_ERR, "memory allocation failed\n");
            return MFD_RESOURCE_UNAVAILABLE;
        }
        if (MFD_SUCCESS !=
            brokerSessionTable_indexes_set(rowreq_ctx,
                                           brokerSessionInternalIndex)) {
            snmp_log(LOG_ERR,
                     "error setting index while loading "
                     "brokerSessionTable data.\n");
            brokerSessionTable_release_rowreq_ctx(rowreq_ctx);
            continue;
        }
        brokerSessionInternalIndex++;

        /*
         * setup/save data for brokerSessionVhostRef
         * brokerSessionVhostRef(1)/ObjId/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerSessionVhostRef data
         */
        if ((NULL == rowreq_ctx->data.brokerSessionVhostRef) ||
            (rowreq_ctx->data.brokerSessionVhostRef_len <
             (qmfData.brokerSessionVhostRef_len *
              sizeof(qmfData.brokerSessionVhostRef[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerSessionVhostRef)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerSessionVhostRef_len =
        		qmfData.brokerSessionVhostRef_len * sizeof(qmfData.brokerSessionVhostRef[0]);
        memcpy(rowreq_ctx->data.brokerSessionVhostRef,
        		qmfData.brokerSessionVhostRef,
        		qmfData.brokerSessionVhostRef_len *
               sizeof(qmfData.brokerSessionVhostRef[0]));

        /*
         * setup/save data for brokerSessionName
         * brokerSessionName(2)/Sstr/ASN_OCTET_STR/char(char)//L/A/W/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerSessionName data
         */
        if ((NULL == rowreq_ctx->data.brokerSessionName) ||
            (rowreq_ctx->data.brokerSessionName_len <
             (qmfData.brokerSessionName_len * sizeof(qmfData.brokerSessionName[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerSessionName)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerSessionName_len =
        		qmfData.brokerSessionName_len * sizeof(qmfData.brokerSessionName[0]);
        memcpy(rowreq_ctx->data.brokerSessionName, qmfData.brokerSessionName,
        		qmfData.brokerSessionName_len * sizeof(qmfData.brokerSessionName[0]));

        /*
         * setup/save data for brokerSessionChannelId
         * brokerSessionChannelId(3)/Uint16/ASN_INTEGER/long(long)//l/A/w/e/r/d/H
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionChannelId = qmfData.brokerSessionChannelId;

        /*
         * setup/save data for brokerSessionConnectionRef
         * brokerSessionConnectionRef(4)/ObjId/ASN_OCTET_STR/char(char)//L/A/w/e/R/d/H
         */
    /** no mapping */
        /*
         * make sure there is enough space for brokerSessionConnectionRef data
         */
        if ((NULL == rowreq_ctx->data.brokerSessionConnectionRef) ||
            (rowreq_ctx->data.brokerSessionConnectionRef_len <
             (qmfData.brokerSessionConnectionRef_len *
              sizeof(qmfData.brokerSessionConnectionRef[0])))) {
            snmp_log(LOG_ERR,
                     "not enough space for value (brokerSessionConnectionRef)\n");
            return MFD_ERROR;
        }
        rowreq_ctx->data.brokerSessionConnectionRef_len =
        		qmfData.brokerSessionConnectionRef_len *
            sizeof(qmfData.brokerSessionConnectionRef[0]);
        memcpy(rowreq_ctx->data.brokerSessionConnectionRef,
        		qmfData.brokerSessionConnectionRef,
        		qmfData.brokerSessionConnectionRef_len *
               sizeof(qmfData.brokerSessionConnectionRef[0]));

        /*
         * setup/save data for brokerSessionDetachedLifespan
         * brokerSessionDetachedLifespan(5)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionDetachedLifespan =
        		qmfData.brokerSessionDetachedLifespan;

        /*
         * setup/save data for brokerSessionAttached
         * brokerSessionAttached(6)/TruthValue/ASN_INTEGER/long(u_long)//l/A/w/E/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionAttached = qmfData.brokerSessionAttached;

        /*
         * setup/save data for brokerSessionExpireTime
         * brokerSessionExpireTime(7)/TICKS/ASN_TIMETICKS/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionExpireTime = qmfData.brokerSessionExpireTime;

        /*
         * setup/save data for brokerSessionMaxClientRate
         * brokerSessionMaxClientRate(8)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionMaxClientRate =
        		qmfData.brokerSessionMaxClientRate;

        /*
         * setup/save data for brokerSessionUnackedMessages
         * brokerSessionUnackedMessages(9)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionUnackedMessages.high =
        		qmfData.brokerSessionUnackedMessages.high;
        rowreq_ctx->data.brokerSessionUnackedMessages.low =
        		qmfData.brokerSessionUnackedMessages.low;

        /*
         * setup/save data for brokerSessionTxnStarts
         * brokerSessionTxnStarts(10)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionTxnStarts.high =
        		qmfData.brokerSessionTxnStarts.high;
        rowreq_ctx->data.brokerSessionTxnStarts.low =
        		qmfData.brokerSessionTxnStarts.low;

        /*
         * setup/save data for brokerSessionTxnCommits
         * brokerSessionTxnCommits(11)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionTxnCommits.high =
        		qmfData.brokerSessionTxnCommits.high;
        rowreq_ctx->data.brokerSessionTxnCommits.low =
        		qmfData.brokerSessionTxnCommits.low;

        /*
         * setup/save data for brokerSessionTxnRejects
         * brokerSessionTxnRejects(12)/COUNTER64/ASN_COUNTER64/U64(U64)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionTxnRejects.high =
        		qmfData.brokerSessionTxnRejects.high;
        rowreq_ctx->data.brokerSessionTxnRejects.low =
        		qmfData.brokerSessionTxnRejects.low;

        /*
         * setup/save data for brokerSessionTxnCount
         * brokerSessionTxnCount(13)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionTxnCount = qmfData.brokerSessionTxnCount;

        /*
         * setup/save data for brokerSessionClientCredit
         * brokerSessionClientCredit(14)/COUNTER/ASN_COUNTER/u_long(u_long)//l/A/w/e/r/d/h
         */
    /** no mapping */
        rowreq_ctx->data.brokerSessionClientCredit =
        		qmfData.brokerSessionClientCredit;


        /*
         * insert into table container
         */
        CONTAINER_INSERT(container, rowreq_ctx);
        ++count;

        qpidReleaseDataRow(pRow);
    }
    qpidRelease(pEvent);

    DEBUGMSGT(("verbose:brokerSessionTable:brokerSessionTable_container_load", "inserted %d records\n", count));

    return MFD_SUCCESS;
}                               /* brokerSessionTable_container_load */

/**
 * container clean up
 *
 * @param container container with all current items
 *
 *  This optional callback is called prior to all
 *  item's being removed from the container. If you
 *  need to do any processing before that, do it here.
 *
 * @note
 *  The MFD helper will take care of releasing all the row contexts.
 *
 */
void
brokerSessionTable_container_free(netsnmp_container * container)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_container_free", "called\n"));

    /*
     * TODO:380:M: Free brokerSessionTable container data.
     */
}                               /* brokerSessionTable_container_free */

/**
 * prepare row for processing.
 *
 *  When the agent has located the row for a request, this function is
 *  called to prepare the row for processing. If you fully populated
 *  the data context during the index setup phase, you may not need to
 *  do anything.
 *
 * @param rowreq_ctx pointer to a context.
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 */
int
brokerSessionTable_row_prep(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_row_prep",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:390:o: Prepare row for request.
     * If populating row data was delayed, this is the place to
     * fill in the row for this request.
     */

    return MFD_SUCCESS;
}                               /* brokerSessionTable_row_prep */

/*
 * TODO:420:r: Implement brokerSessionTable index validation.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionInternalIndex
 * brokerSessionInternalIndex is subid 15 of brokerSessionEntry.
 * Its status is Current, and its access level is NoAccess.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.15
 * Description:
Internal index for session table
 *
 * Attributes:
 *   accessible 0     isscalar 0     enums  0      hasdefval 0
 *   readable   0     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 *
 *
 *
 * NOTE: NODE brokerSessionInternalIndex IS NOT ACCESSIBLE
 *
 *
 */
/**
 * check validity of brokerSessionInternalIndex index portion
 *
 * @retval MFD_SUCCESS   : the incoming value is legal
 * @retval MFD_ERROR     : the incoming value is NOT legal
 *
 * @note this is not the place to do any checks for the sanity
 *       of multiple indexes. Those types of checks should be done in the
 *       brokerSessionTable_validate_index() function.
 *
 * @note Also keep in mind that if the index refers to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 * The following checks have already been done for you:
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 */
int
brokerSessionInternalIndex_check_index(brokerSessionTable_rowreq_ctx *
                                       rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionInternalIndex_check_index", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:426:M: |-> Check brokerSessionTable index brokerSessionInternalIndex.
     * check that index value in the table context is legal.
     * (rowreq_ctx->tbl_index.brokerSessionInternalIndex)
     */

    return MFD_SUCCESS;         /* brokerSessionInternalIndex index ok */
}                               /* brokerSessionInternalIndex_check_index */

/**
 * verify specified index is valid.
 *
 * This check is independent of whether or not the values specified for
 * the columns of the new row are valid. Column values and row consistency
 * will be checked later. At this point, only the index values should be
 * checked.
 *
 * All of the individual index validation functions have been called, so this
 * is the place to make sure they are valid as a whole when combined. If
 * you only have one index, then you probably don't need to do anything else
 * here.
 * 
 * @note Keep in mind that if the indexes refer to a row in this or
 *       some other table, you can't check for that row here to make
 *       decisions, since that row might not be created yet, but may
 *       be created during the processing this request. If you have
 *       such checks, they should be done in the check_dependencies
 *       function, because any new/deleted/changed rows should be
 *       available then.
 *
 *
 * @param brokerSessionTable_reg
 *        Pointer to the user registration data
 * @param brokerSessionTable_rowreq_ctx
 *        Pointer to the users context.
 * @retval MFD_SUCCESS            : success
 * @retval MFD_CANNOT_CREATE_NOW  : index not valid right now
 * @retval MFD_CANNOT_CREATE_EVER : index never valid
 */
int
brokerSessionTable_validate_index(brokerSessionTable_registration *
                                  brokerSessionTable_reg,
                                  brokerSessionTable_rowreq_ctx *
                                  rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_validate_index", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:430:M: |-> Validate potential brokerSessionTable index.
     */
    if (1) {
        snmp_log(LOG_WARNING, "invalid index for a new row in the "
                 "brokerSessionTable table.\n");
        /*
         * determine failure type.
         *
         * If the index could not ever be created, return MFD_NOT_EVER
         * If the index can not be created under the present circumstances
         * (even though it could be created under other circumstances),
         * return MFD_NOT_NOW.
         */
        if (0) {
            return MFD_CANNOT_CREATE_EVER;
        } else {
            return MFD_CANNOT_CREATE_NOW;
        }
    }

    return rc;
}                               /* brokerSessionTable_validate_index */

/** @} */
