/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "SessionTable.h"


/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement brokerSessionTable get routines.
 * TODO:240:M: Implement brokerSessionTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerSessionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerSessionTable is subid 1 of brokerSessions.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement brokerSessionTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 * @param brokerSessionInternalIndex_val
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
brokerSessionTable_indexes_set_tbl_idx(brokerSessionTable_mib_index *
                                       tbl_idx,
                                       u_long
                                       brokerSessionInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_indexes_set_tbl_idx", "called\n"));

    /*
     * brokerSessionInternalIndex(15)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h 
     */
    tbl_idx->brokerSessionInternalIndex = brokerSessionInternalIndex_val;


    return MFD_SUCCESS;
}                               /* brokerSessionTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
brokerSessionTable_indexes_set(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                               u_long brokerSessionInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_indexes_set", "called\n"));

    if (MFD_SUCCESS !=
        brokerSessionTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                               brokerSessionInternalIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != brokerSessionTable_index_to_oid(&rowreq_ctx->oid_idx,
                                             &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* brokerSessionTable_indexes_set */


/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionVhostRef
 * brokerSessionVhostRef is subid 1 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.1
 * Description:
Session vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerSessionVhostRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionVhostRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerSessionVhostRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerSessionVhostRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerSessionVhostRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerSessionVhostRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerSessionVhostRef_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                          char **brokerSessionVhostRef_val_ptr_ptr,
                          size_t *brokerSessionVhostRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerSessionVhostRef_val_ptr_ptr)
                   && (NULL != *brokerSessionVhostRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerSessionVhostRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionVhostRef_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionVhostRef data.
     * copy (* brokerSessionVhostRef_val_ptr_ptr ) data and (* brokerSessionVhostRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerSessionVhostRef data
     */
    if ((NULL == (*brokerSessionVhostRef_val_ptr_ptr)) ||
        ((*brokerSessionVhostRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerSessionVhostRef_len *
          sizeof(rowreq_ctx->data.brokerSessionVhostRef[0])))) {
        /*
         * allocate space for brokerSessionVhostRef data
         */
        (*brokerSessionVhostRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerSessionVhostRef_len *
                   sizeof(rowreq_ctx->data.brokerSessionVhostRef[0]));
        if (NULL == (*brokerSessionVhostRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerSessionVhostRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerSessionVhostRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerSessionVhostRef_len *
        sizeof(rowreq_ctx->data.brokerSessionVhostRef[0]);
    memcpy((*brokerSessionVhostRef_val_ptr_ptr),
           rowreq_ctx->data.brokerSessionVhostRef,
           rowreq_ctx->data.brokerSessionVhostRef_len *
           sizeof(rowreq_ctx->data.brokerSessionVhostRef[0]));

    return MFD_SUCCESS;
}                               /* brokerSessionVhostRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionName
 * brokerSessionName is subid 2 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.2
 * Description:
Session name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerSessionName data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionName_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerSessionName_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerSessionName.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerSessionName_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerSessionName_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerSessionName_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                      char **brokerSessionName_val_ptr_ptr,
                      size_t *brokerSessionName_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerSessionName_val_ptr_ptr)
                   && (NULL != *brokerSessionName_val_ptr_ptr));
    netsnmp_assert(NULL != brokerSessionName_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionName_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionName data.
     * copy (* brokerSessionName_val_ptr_ptr ) data and (* brokerSessionName_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerSessionName data
     */
    if ((NULL == (*brokerSessionName_val_ptr_ptr)) ||
        ((*brokerSessionName_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerSessionName_len *
          sizeof(rowreq_ctx->data.brokerSessionName[0])))) {
        /*
         * allocate space for brokerSessionName data
         */
        (*brokerSessionName_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerSessionName_len *
                   sizeof(rowreq_ctx->data.brokerSessionName[0]));
        if (NULL == (*brokerSessionName_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerSessionName)\n");
            return MFD_ERROR;
        }
    }
    (*brokerSessionName_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerSessionName_len *
        sizeof(rowreq_ctx->data.brokerSessionName[0]);
    memcpy((*brokerSessionName_val_ptr_ptr),
           rowreq_ctx->data.brokerSessionName,
           rowreq_ctx->data.brokerSessionName_len *
           sizeof(rowreq_ctx->data.brokerSessionName[0]));

    return MFD_SUCCESS;
}                               /* brokerSessionName_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionChannelId
 * brokerSessionChannelId is subid 3 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.3
 * Description:
Session channelId
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   1
 *   settable   0
 *   hint: d
 *
 *
 * Its syntax is Uint16 (based on perltype INTEGER32)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (long)
 */
/**
 * Extract the current value of the brokerSessionChannelId data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionChannelId_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionChannelId_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                           long *brokerSessionChannelId_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionChannelId_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionChannelId_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionChannelId data.
     * copy (* brokerSessionChannelId_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionChannelId_val_ptr) =
        rowreq_ctx->data.brokerSessionChannelId;

    return MFD_SUCCESS;
}                               /* brokerSessionChannelId_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionConnectionRef
 * brokerSessionConnectionRef is subid 4 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.4
 * Description:
Session connectionRef
                     Additional info ( nodeType:property, references:Connection )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerSessionConnectionRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionConnectionRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerSessionConnectionRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerSessionConnectionRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerSessionConnectionRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerSessionConnectionRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerSessionConnectionRef_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                               char
                               **brokerSessionConnectionRef_val_ptr_ptr,
                               size_t
                               *brokerSessionConnectionRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerSessionConnectionRef_val_ptr_ptr)
                   && (NULL != *brokerSessionConnectionRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerSessionConnectionRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionConnectionRef_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionConnectionRef data.
     * copy (* brokerSessionConnectionRef_val_ptr_ptr ) data and (* brokerSessionConnectionRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerSessionConnectionRef data
     */
    if ((NULL == (*brokerSessionConnectionRef_val_ptr_ptr)) ||
        ((*brokerSessionConnectionRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerSessionConnectionRef_len *
          sizeof(rowreq_ctx->data.brokerSessionConnectionRef[0])))) {
        /*
         * allocate space for brokerSessionConnectionRef data
         */
        (*brokerSessionConnectionRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerSessionConnectionRef_len *
                   sizeof(rowreq_ctx->data.brokerSessionConnectionRef[0]));
        if (NULL == (*brokerSessionConnectionRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerSessionConnectionRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerSessionConnectionRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerSessionConnectionRef_len *
        sizeof(rowreq_ctx->data.brokerSessionConnectionRef[0]);
    memcpy((*brokerSessionConnectionRef_val_ptr_ptr),
           rowreq_ctx->data.brokerSessionConnectionRef,
           rowreq_ctx->data.brokerSessionConnectionRef_len *
           sizeof(rowreq_ctx->data.brokerSessionConnectionRef[0]));

    return MFD_SUCCESS;
}                               /* brokerSessionConnectionRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionDetachedLifespan
 * brokerSessionDetachedLifespan is subid 5 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.5
 * Description:
Session detachedLifespan
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionDetachedLifespan data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionDetachedLifespan_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionDetachedLifespan_get(brokerSessionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  u_long *
                                  brokerSessionDetachedLifespan_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionDetachedLifespan_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionDetachedLifespan_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionDetachedLifespan data.
     * copy (* brokerSessionDetachedLifespan_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionDetachedLifespan_val_ptr) =
        rowreq_ctx->data.brokerSessionDetachedLifespan;

    return MFD_SUCCESS;
}                               /* brokerSessionDetachedLifespan_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionAttached
 * brokerSessionAttached is subid 6 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.6
 * Description:
Session attached
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Extract the current value of the brokerSessionAttached data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionAttached_val_ptr
 *        Pointer to storage for a long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionAttached_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                          u_long * brokerSessionAttached_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionAttached_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionAttached_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionAttached data.
     * copy (* brokerSessionAttached_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionAttached_val_ptr) =
        rowreq_ctx->data.brokerSessionAttached;

    return MFD_SUCCESS;
}                               /* brokerSessionAttached_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionExpireTime
 * brokerSessionExpireTime is subid 7 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.7
 * Description:
Session expireTime
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is TICKS (based on perltype TICKS)
 * The net-snmp type is ASN_TIMETICKS. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionExpireTime data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionExpireTime_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionExpireTime_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                            u_long * brokerSessionExpireTime_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionExpireTime_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionExpireTime_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionExpireTime data.
     * copy (* brokerSessionExpireTime_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionExpireTime_val_ptr) =
        rowreq_ctx->data.brokerSessionExpireTime;

    return MFD_SUCCESS;
}                               /* brokerSessionExpireTime_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionMaxClientRate
 * brokerSessionMaxClientRate is subid 8 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.8
 * Description:
Session maxClientRate
                     Additional info ( nodeType:property, optional:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is UNSIGNED32 (based on perltype UNSIGNED32)
 * The net-snmp type is ASN_UNSIGNED. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionMaxClientRate data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionMaxClientRate_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionMaxClientRate_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                               u_long * brokerSessionMaxClientRate_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionMaxClientRate_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionMaxClientRate_get", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionMaxClientRate data.
     * copy (* brokerSessionMaxClientRate_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionMaxClientRate_val_ptr) =
        rowreq_ctx->data.brokerSessionMaxClientRate;

    return MFD_SUCCESS;
}                               /* brokerSessionMaxClientRate_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionUnackedMessages
 * brokerSessionUnackedMessages is subid 9 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.9
 * Description:
Session framesOutstanding
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER (based on perltype COUNTER)
 * The net-snmp type is ASN_COUNTER. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionUnackedMessages data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionUnackedMessages_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionUnackedMessages_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                                   U64 * brokerSessionUnackedMessages_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionUnackedMessages_val_ptr);
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionUnackedMessages data.
     * copy (* brokerSessionUnackedMessages_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionUnackedMessages_val_ptr).high =
        rowreq_ctx->data.brokerSessionUnackedMessages.high;
    (*brokerSessionUnackedMessages_val_ptr).low =
        rowreq_ctx->data.brokerSessionUnackedMessages.low;

    return MFD_SUCCESS;
}                               /* brokerSessionUnackedMessages_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionTxnStarts
 * brokerSessionTxnStarts is subid 10 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.10
 * Description:
Total transactions started 
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerSessionTxnStarts data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionTxnStarts_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionTxnStarts_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                           U64 * brokerSessionTxnStarts_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionTxnStarts_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerSessionTxnStarts data.
     * get (* brokerSessionTxnStarts_val_ptr ).low and (* brokerSessionTxnStarts_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerSessionTxnStarts_val_ptr).high =
        rowreq_ctx->data.brokerSessionTxnStarts.high;
    (*brokerSessionTxnStarts_val_ptr).low =
        rowreq_ctx->data.brokerSessionTxnStarts.low;


    return MFD_SUCCESS;
}                               /* brokerSessionTxnStarts_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionTxnCommits
 * brokerSessionTxnCommits is subid 11 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.11
 * Description:
Total transactions committed
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerSessionTxnCommits data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionTxnCommits_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionTxnCommits_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                            U64 * brokerSessionTxnCommits_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionTxnCommits_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerSessionTxnCommits data.
     * get (* brokerSessionTxnCommits_val_ptr ).low and (* brokerSessionTxnCommits_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerSessionTxnCommits_val_ptr).high =
        rowreq_ctx->data.brokerSessionTxnCommits.high;
    (*brokerSessionTxnCommits_val_ptr).low =
        rowreq_ctx->data.brokerSessionTxnCommits.low;


    return MFD_SUCCESS;
}                               /* brokerSessionTxnCommits_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionTxnRejects
 * brokerSessionTxnRejects is subid 12 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.12
 * Description:
Total transactions rejected
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER64 (based on perltype COUNTER64)
 * The net-snmp type is ASN_COUNTER64. The C type decl is U64 (U64)
 */
/**
 * Extract the current value of the brokerSessionTxnRejects data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionTxnRejects_val_ptr
 *        Pointer to storage for a U64 variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionTxnRejects_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                            U64 * brokerSessionTxnRejects_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionTxnRejects_val_ptr);

    /*
     * TODO:231:o: |-> copy brokerSessionTxnRejects data.
     * get (* brokerSessionTxnRejects_val_ptr ).low and (* brokerSessionTxnRejects_val_ptr ).high from rowreq_ctx->data
     */
    (*brokerSessionTxnRejects_val_ptr).high =
        rowreq_ctx->data.brokerSessionTxnRejects.high;
    (*brokerSessionTxnRejects_val_ptr).low =
        rowreq_ctx->data.brokerSessionTxnRejects.low;


    return MFD_SUCCESS;
}                               /* brokerSessionTxnRejects_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionTxnCount
 * brokerSessionTxnCount is subid 13 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.13
 * Description:
Current pending transactions
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER (based on perltype COUNTER)
 * The net-snmp type is ASN_COUNTER. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionTxnCount data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionTxnCount_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionTxnCount_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                          u_long * brokerSessionTxnCount_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionTxnCount_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTxnCount_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionTxnCount data.
     * copy (* brokerSessionTxnCount_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionTxnCount_val_ptr) =
        rowreq_ctx->data.brokerSessionTxnCount;

    return MFD_SUCCESS;
}                               /* brokerSessionTxnCount_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionClientCredit
 * brokerSessionClientCredit is subid 14 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.14
 * Description:
Client message credit
                     Additional info ( nodeType:statistic )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   0
 *
 *
 * Its syntax is COUNTER (based on perltype COUNTER)
 * The net-snmp type is ASN_COUNTER. The C type decl is u_long (u_long)
 */
/**
 * Extract the current value of the brokerSessionClientCredit data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionClientCredit_val_ptr
 *        Pointer to storage for a u_long variable
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
 */
int
brokerSessionClientCredit_get(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                              u_long * brokerSessionClientCredit_val_ptr)
{
   /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != brokerSessionClientCredit_val_ptr);


    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionClientCredit_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerSessionClientCredit data.
     * copy (* brokerSessionClientCredit_val_ptr ) from rowreq_ctx->data
     */
    (*brokerSessionClientCredit_val_ptr) =
        rowreq_ctx->data.brokerSessionClientCredit;

    return MFD_SUCCESS;
}                               /* brokerSessionClientCredit_get */



/** @} */
