/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "SessionTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerSessionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerSessionTable is subid 1 of brokerSessions.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerSessionTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerSessionTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSessionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerSessionTable_undo_setup(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_undo_setup",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerSessionTable undo.
     * set up brokerSessionTable undo information, in preparation for a set.
     * Undo storage is in (* brokerSessionClientCredit_val_ptr )*
     */

    return rc;
}                               /* brokerSessionTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSessionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerSessionTable_undo(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_undo",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerSessionTable undo.
     * brokerSessionTable undo information, in response to a failed set.
     * Undo storage is in (* brokerSessionClientCredit_val_ptr )*
     */

    return rc;
}                               /* brokerSessionTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSessionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSessionTable_undo_cleanup(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_undo_cleanup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerSessionTable undo.
     * Undo storage is in (* brokerSessionClientCredit_val_ptr )*
     */

    return rc;
}                               /* brokerSessionTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSessionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerSessionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSessionTable_commit(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_commit",
                "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerSessionTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerSESSIONVHOSTREF_FLAG) {
        save_flags &= ~COLUMN_brokerSESSIONVHOSTREF_FLAG;       /* clear brokerSessionVhostRef */
        /*
         * TODO:482:o: |-> commit column brokerSessionVhostRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSessionTable column brokerSessionVhostRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSessionVhostRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSESSIONVHOSTREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSESSIONNAME_FLAG) {
        save_flags &= ~COLUMN_brokerSESSIONNAME_FLAG;   /* clear brokerSessionName */
        /*
         * TODO:482:o: |-> commit column brokerSessionName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSessionTable column brokerSessionName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSessionName
             */
            rowreq_ctx->column_set_flags |= COLUMN_brokerSESSIONNAME_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerSessionTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSessionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerSessionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSessionTable_undo_commit(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionTable_undo_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerSessionTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerSessionTable_undo_commit */

/*
 * TODO:440:M: Implement brokerSessionTable node value checks.
 * TODO:450:M: Implement brokerSessionTable undo functions.
 * TODO:460:M: Implement brokerSessionTable set functions.
 * TODO:480:M: Implement brokerSessionTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionVhostRef
 * brokerSessionVhostRef is subid 1 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.1
 * Description:
Session vhostRef
                     Additional info ( nodeType:property, references:Vhost, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerSessionVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSessionVhostRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSessionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSessionVhostRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSessionVhostRef_check_value(brokerSessionTable_rowreq_ctx *
                                  rowreq_ctx,
                                  char *brokerSessionVhostRef_val_ptr,
                                  size_t brokerSessionVhostRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionVhostRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSessionVhostRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSessionVhostRef value.
     */

    return MFD_SUCCESS;         /* brokerSessionVhostRef value not illegal */
}                               /* brokerSessionVhostRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSessionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSessionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSessionVhostRef_undo_setup(brokerSessionTable_rowreq_ctx *
                                 rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionVhostRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSessionVhostRef undo.
     */
    /*
     * copy brokerSessionVhostRef and brokerSessionVhostRef_len data
     * set rowreq_ctx->undo->brokerSessionVhostRef from rowreq_ctx->data.brokerSessionVhostRef
     */
    memcpy(rowreq_ctx->undo->brokerSessionVhostRef,
           rowreq_ctx->data.brokerSessionVhostRef,
           (rowreq_ctx->data.brokerSessionVhostRef_len *
            sizeof(rowreq_ctx->undo->brokerSessionVhostRef[0])));
    rowreq_ctx->undo->brokerSessionVhostRef_len =
        rowreq_ctx->data.brokerSessionVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerSessionVhostRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSessionVhostRef_val_ptr
 *        A char containing the new value.
 * @param brokerSessionVhostRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSessionVhostRef_val_ptr
 */
int
brokerSessionVhostRef_set(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                          char *brokerSessionVhostRef_val_ptr,
                          size_t brokerSessionVhostRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionVhostRef_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSessionVhostRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSessionVhostRef value.
     * set brokerSessionVhostRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSessionVhostRef,
           brokerSessionVhostRef_val_ptr,
           brokerSessionVhostRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSessionVhostRef_len =
        brokerSessionVhostRef_val_ptr_len /
        sizeof(brokerSessionVhostRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSessionVhostRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSessionVhostRef_undo(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionVhostRef_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSessionVhostRef undo.
     */
    /*
     * copy brokerSessionVhostRef and brokerSessionVhostRef_len data
     * set rowreq_ctx->data.brokerSessionVhostRef from rowreq_ctx->undo->brokerSessionVhostRef
     */
    memcpy(rowreq_ctx->data.brokerSessionVhostRef,
           rowreq_ctx->undo->brokerSessionVhostRef,
           (rowreq_ctx->undo->brokerSessionVhostRef_len *
            sizeof(rowreq_ctx->data.brokerSessionVhostRef[0])));
    rowreq_ctx->data.brokerSessionVhostRef_len =
        rowreq_ctx->undo->brokerSessionVhostRef_len;


    return MFD_SUCCESS;
}                               /* brokerSessionVhostRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSessionEntry.brokerSessionName
 * brokerSessionName is subid 2 of brokerSessionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.13.1.1.2
 * Description:
Session name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSessionName_val_ptr
 *        A char containing the new value.
 * @param brokerSessionName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSessionName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSessionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSessionName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSessionName_check_value(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                              char *brokerSessionName_val_ptr,
                              size_t brokerSessionName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionName_check_value",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSessionName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSessionName value.
     */

    return MFD_SUCCESS;         /* brokerSessionName value not illegal */
}                               /* brokerSessionName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSessionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSessionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSessionName_undo_setup(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionName_undo_setup",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSessionName undo.
     */
    /*
     * copy brokerSessionName and brokerSessionName_len data
     * set rowreq_ctx->undo->brokerSessionName from rowreq_ctx->data.brokerSessionName
     */
    memcpy(rowreq_ctx->undo->brokerSessionName,
           rowreq_ctx->data.brokerSessionName,
           (rowreq_ctx->data.brokerSessionName_len *
            sizeof(rowreq_ctx->undo->brokerSessionName[0])));
    rowreq_ctx->undo->brokerSessionName_len =
        rowreq_ctx->data.brokerSessionName_len;


    return MFD_SUCCESS;
}                               /* brokerSessionName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSessionName_val_ptr
 *        A char containing the new value.
 * @param brokerSessionName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSessionName_val_ptr
 */
int
brokerSessionName_set(brokerSessionTable_rowreq_ctx * rowreq_ctx,
                      char *brokerSessionName_val_ptr,
                      size_t brokerSessionName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionName_set",
                "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSessionName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSessionName value.
     * set brokerSessionName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSessionName, brokerSessionName_val_ptr,
           brokerSessionName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSessionName_len =
        brokerSessionName_val_ptr_len /
        sizeof(brokerSessionName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSessionName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSessionName_undo(brokerSessionTable_rowreq_ctx * rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSessionTable:brokerSessionName_undo",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSessionName undo.
     */
    /*
     * copy brokerSessionName and brokerSessionName_len data
     * set rowreq_ctx->data.brokerSessionName from rowreq_ctx->undo->brokerSessionName
     */
    memcpy(rowreq_ctx->data.brokerSessionName,
           rowreq_ctx->undo->brokerSessionName,
           (rowreq_ctx->undo->brokerSessionName_len *
            sizeof(rowreq_ctx->data.brokerSessionName[0])));
    rowreq_ctx->data.brokerSessionName_len =
        rowreq_ctx->undo->brokerSessionName_len;


    return MFD_SUCCESS;
}                               /* brokerSessionName_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSessionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerSessionTable if you don't have dependencies)
 */
int
brokerSessionTable_check_dependencies(brokerSessionTable_rowreq_ctx *
                                      rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerSessionTable:brokerSessionTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerSessionTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerSessionTable_check_dependencies */

/** @} */
