/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "ManagementSetupState.h"

#include "../qpid_api.h"

/** Initializes the brokerManagementSetupState module */
void
init_ManagementSetupState(void)
{
    const oid       brokerManagementSetupStateObjectNum_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 14, 1 };
    const oid       brokerManagementSetupStateBootSequence_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 1, 14, 2 };

    DEBUGMSGTL(("brokerManagementSetupState", "Initializing\n"));

    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerManagementSetupStateObjectNum",
                             handle_brokerManagementSetupStateObjectNum,
                             brokerManagementSetupStateObjectNum_oid,
                             OID_LENGTH
                             (brokerManagementSetupStateObjectNum_oid),
                             HANDLER_CAN_RONLY));
    netsnmp_register_scalar(netsnmp_create_handler_registration
                            ("brokerManagementSetupStateBootSequence",
                             handle_brokerManagementSetupStateBootSequence,
                             brokerManagementSetupStateBootSequence_oid,
                             OID_LENGTH
                             (brokerManagementSetupStateBootSequence_oid),
                             HANDLER_CAN_RONLY));
}

int
handle_brokerManagementSetupStateObjectNum(netsnmp_mib_handler *handler,
                                           netsnmp_handler_registration
                                           *reginfo,
                                           netsnmp_agent_request_info
                                           *reqinfo,
                                           netsnmp_request_info *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	U64 count64;
	qpidGetScalarS64("managementSetupState", "objectNum", &count64);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_COUNTER64,
        		&count64, 			// a pointer to the scalar's data
                sizeof(count64) 	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerManagementSetupStateObjectNum\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}

int
handle_brokerManagementSetupStateBootSequence(netsnmp_mib_handler *handler,
                                              netsnmp_handler_registration
                                              *reginfo,
                                              netsnmp_agent_request_info
                                              *reqinfo,
                                              netsnmp_request_info
                                              *requests)
{
    /*
     * We are never called for a GETNEXT if it's registered as a
     * "instance", as it's "magically" handled for us.  
     */

    /*
     * a instance handler also only hands us one request at a time, so
     * we don't need to loop over a list of requests; we'll only get one. 
     */

	uint16_t u16;
	qpidGetScalarU16("managementSetupState", "bootSequence", &u16);

    switch (reqinfo->mode) {

    case MODE_GET:
        snmp_set_var_typed_value(requests->requestvb, ASN_INTEGER,
        		&u16,		// a pointer to the scalar's data
        		sizeof(u16)	// the length of the data in bytes
        );
        break;


    default:
        /*
         * we should never get here, so this is a really bad error 
         */
        snmp_log(LOG_ERR,
                 "unknown mode (%d) in handle_brokerManagementSetupStateBootSequence\n",
                 reqinfo->mode);
        return SNMP_ERR_GENERR;
    }

    return SNMP_ERR_NOERROR;
}
