/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $
 *
 * $Id:$
 *
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "SubscriptionTable.h"


/** @defgroup data_set data_set: Routines to set data
 *
 * These routines are used to set the value for individual objects. The
 * row context is passed, along with the new value.
 * 
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerSubscriptionTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerSubscriptionTable is subid 1 of brokerSubscriptions.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1, length: 12
 */
    /*
     * NOTE: if you update this chart, please update the versions in
     *       local/mib2c-conf.d/parent-set.m2i
     *       agent/mibgroup/helpers/baby_steps.c
     * while you're at it.
     */
    /*
     ***********************************************************************
     * Baby Steps Flow Chart (2004.06.05)                                  *
     *                                                                     *
     * +--------------+    +================+    U = unconditional path    *
     * |optional state|    ||required state||    S = path for success      *
     * +--------------+    +================+    E = path for error        *
     ***********************************************************************
     *
     *                        +--------------+
     *                        |     pre      |
     *                        |   request    |
     *                        +--------------+
     *                               | U
     *                        +==============+
     *       +----------------||  object    ||
     *       |              E ||  lookup    ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |              E ||   check    ||
     *       |<---------------||   values   ||
     *       |                +==============+
     *       |                       | S
     *       |                +==============+
     *       |       +<-------||   undo     ||
     *       |       |      E ||   setup    ||
     *       |       |        +==============+
     *       |       |               | S
     *       |       |        +==============+
     *       |       |        ||    set     ||-------------------------->+
     *       |       |        ||   value    || E                         |
     *       |       |        +==============+                           |
     *       |       |               | S                                 |
     *       |       |        +--------------+                           |
     *       |       |        |    check     |-------------------------->|
     *       |       |        |  consistency | E                         |
     *       |       |        +--------------+                           |
     *       |       |               | S                                 |
     *       |       |        +==============+         +==============+  |
     *       |       |        ||   commit   ||-------->||     undo   ||  |
     *       |       |        ||            || E       ||    commit  ||  |
     *       |       |        +==============+         +==============+  |
     *       |       |               | S                     U |<--------+
     *       |       |        +--------------+         +==============+
     *       |       |        | irreversible |         ||    undo    ||
     *       |       |        |    commit    |         ||     set    ||
     *       |       |        +--------------+         +==============+
     *       |       |               | U                     U |
     *       |       +-------------->|<------------------------+
     *       |                +==============+
     *       |                ||   undo     ||
     *       |                ||  cleanup   ||
     *       |                +==============+
     *       +---------------------->| U
     *                        +--------------+
     *                        |    post      |
     *                        |   request    |
     *                        +--------------+
     *
     */

/**
 * Setup up context with information needed to undo a set request.
 *
 * This function will be called before the individual node undo setup
 * functions are called. If you need to do any undo setup that is not
 * related to a specific column, you can do it here.
 *
 * Note that the undo context has been allocated with
 * brokerSubscriptionTable_allocate_data(), but may need extra
 * initialization similar to what you may have done in
 * brokerSubscriptionTable_rowreq_ctx_init().
 * Note that an individual node's undo_setup function will only be called
 * if that node is being set to a new value.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in the node's undo_setup
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerSubscriptionTable_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                   rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionTable_undo_setup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> Setup brokerSubscriptionTable undo.
     * set up brokerSubscriptionTable undo information, in preparation for a set.
     * Undo storage is in (* brokerSubscriptionDelivered_val_ptr )*
     */

    return rc;
}                               /* brokerSubscriptionTable_undo_setup */

/**
 * Undo a set request.
 *
 * This function will be called before the individual node undo
 * functions are called. If you need to do any undo that is not
 * related to a specific column, you can do it here.
 *
 * Note that an individual node's undo function will only be called
 * if that node is being set to a new value.
 *
 * If there is anything  specific to a particular column (e.g. releasing
 * memory for a string), you should do that setup in the node's undo
 * function, so it won't be done unless it is necessary.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 */
int
brokerSubscriptionTable_undo(brokerSubscriptionTable_rowreq_ctx *
                             rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionTable_undo", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:451:M: |-> brokerSubscriptionTable undo.
     * brokerSubscriptionTable undo information, in response to a failed set.
     * Undo storage is in (* brokerSubscriptionDelivered_val_ptr )*
     */

    return rc;
}                               /* brokerSubscriptionTable_undo_setup */

/**
 * Cleanup up context undo information.
 *
 * This function will be called after set/commit processing. If you
 * allocated any resources in undo_setup, this is the place to release
 * those resources.
 *
 * This function is called regardless of the success or failure of the set
 * request. If you need to perform different steps for cleanup depending
 * on success or failure, you can add a flag to the rowreq_ctx.
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSubscriptionTable_undo_cleanup(brokerSubscriptionTable_rowreq_ctx *
                                     rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionTable_undo_cleanup", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:452:M: |-> Cleanup brokerSubscriptionTable undo.
     * Undo storage is in (* brokerSubscriptionDelivered_val_ptr )*
     */

    return rc;
}                               /* brokerSubscriptionTable_undo_cleanup */

/**
 * commit new values.
 *
 * At this point, you should have done everything you can to ensure that
 * this commit will not fail.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSubscriptionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerSubscriptionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSubscriptionTable_commit(brokerSubscriptionTable_rowreq_ctx *
                               rowreq_ctx)
{
    int             rc = MFD_SUCCESS;
    int             save_flags;

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionTable_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * save flags, then clear until we actually do something
     */
    save_flags = rowreq_ctx->column_set_flags;
    rowreq_ctx->column_set_flags = 0;

    /*
     * commit brokerSubscriptionTable data
     * 1) check the column's flag in save_flags to see if it was set.
     * 2) clear the flag when you handle that column
     * 3) set the column's flag in column_set_flags if it needs undo
     *    processing in case of a failure.
     */
    if (save_flags & COLUMN_brokerSUBSCRIPTIONSESSIONREF_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONSESSIONREF_FLAG;        /* clear brokerSubscriptionSessionRef */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionSessionRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionSessionRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionSessionRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONSESSIONREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONQUEUEREF_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONQUEUEREF_FLAG;  /* clear brokerSubscriptionQueueRef */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionQueueRef.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionQueueRef commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionQueueRef
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONQUEUEREF_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONNAME_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONNAME_FLAG;      /* clear brokerSubscriptionName */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionName.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionName commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionName
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONNAME_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONBROWSING_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONBROWSING_FLAG;  /* clear brokerSubscriptionBrowsing */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionBrowsing.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionBrowsing commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionBrowsing
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONBROWSING_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONACKNOWLEDGED_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONACKNOWLEDGED_FLAG;      /* clear brokerSubscriptionAcknowledged */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionAcknowledged.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionAcknowledged commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionAcknowledged
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONACKNOWLEDGED_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONEXCLUSIVE_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONEXCLUSIVE_FLAG; /* clear brokerSubscriptionExclusive */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionExclusive.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionExclusive commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionExclusive
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONEXCLUSIVE_FLAG;
        }
    }

    if (save_flags & COLUMN_brokerSUBSCRIPTIONARGUMENTS_FLAG) {
        save_flags &= ~COLUMN_brokerSUBSCRIPTIONARGUMENTS_FLAG; /* clear brokerSubscriptionArguments */
        /*
         * TODO:482:o: |-> commit column brokerSubscriptionArguments.
         */
        rc = -1;
        if (-1 == rc) {
            snmp_log(LOG_ERR,
                     "brokerSubscriptionTable column brokerSubscriptionArguments commit failed\n");
        } else {
            /*
             * set flag, in case we need to undo brokerSubscriptionArguments
             */
            rowreq_ctx->column_set_flags |=
                COLUMN_brokerSUBSCRIPTIONARGUMENTS_FLAG;
        }
    }

    /*
     * if we successfully commited this row, set the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags |= MFD_ROW_DIRTY;
    }

    if (save_flags) {
        snmp_log(LOG_ERR, "unhandled columns (0x%x) in commit\n",
                 save_flags);
        return MFD_ERROR;
    }

    return rc;
}                               /* brokerSubscriptionTable_commit */

/**
 * undo commit new values.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSubscriptionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @param brokerSubscriptionTable_rowreq_ctx
 *        Pointer to the users context.
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error
 */
int
brokerSubscriptionTable_undo_commit(brokerSubscriptionTable_rowreq_ctx *
                                    rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionTable_undo_commit", "called\n"));

    /** we should have a non-NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:485:M: |-> Undo brokerSubscriptionTable commit.
     * check the column's flag in rowreq_ctx->column_set_flags to see
     * if it was set during commit, then undo it.
     *
     * eg: if (rowreq_ctx->column_set_flags & COLUMN__FLAG) {}
     */


    /*
     * if we successfully un-commited this row, clear the dirty flag.
     */
    if (MFD_SUCCESS == rc) {
        rowreq_ctx->rowreq_flags &= ~MFD_ROW_DIRTY;
    }

    return rc;
}                               /* brokerSubscriptionTable_undo_commit */

/*
 * TODO:440:M: Implement brokerSubscriptionTable node value checks.
 * TODO:450:M: Implement brokerSubscriptionTable undo functions.
 * TODO:460:M: Implement brokerSubscriptionTable set functions.
 * TODO:480:M: Implement brokerSubscriptionTable commit functions.
 */
/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionSessionRef
 * brokerSubscriptionSessionRef is subid 1 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.1
 * Description:
Subscription sessionRef
                     Additional info ( nodeType:property, references:Session, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionSessionRef_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionSessionRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionSessionRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSubscriptionSessionRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionSessionRef_check_value(brokerSubscriptionTable_rowreq_ctx
                                         * rowreq_ctx,
                                         char
                                         *brokerSubscriptionSessionRef_val_ptr,
                                         size_t
                                         brokerSubscriptionSessionRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionSessionRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionSessionRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionSessionRef value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionSessionRef value not illegal */
}                               /* brokerSubscriptionSessionRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionSessionRef_undo_setup(brokerSubscriptionTable_rowreq_ctx
                                        * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionSessionRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionSessionRef undo.
     */
    /*
     * copy brokerSubscriptionSessionRef and brokerSubscriptionSessionRef_len data
     * set rowreq_ctx->undo->brokerSubscriptionSessionRef from rowreq_ctx->data.brokerSubscriptionSessionRef
     */
    memcpy(rowreq_ctx->undo->brokerSubscriptionSessionRef,
           rowreq_ctx->data.brokerSubscriptionSessionRef,
           (rowreq_ctx->data.brokerSubscriptionSessionRef_len *
            sizeof(rowreq_ctx->undo->brokerSubscriptionSessionRef[0])));
    rowreq_ctx->undo->brokerSubscriptionSessionRef_len =
        rowreq_ctx->data.brokerSubscriptionSessionRef_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionSessionRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionSessionRef_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionSessionRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionSessionRef_val_ptr
 */
int
brokerSubscriptionSessionRef_set(brokerSubscriptionTable_rowreq_ctx *
                                 rowreq_ctx,
                                 char
                                 *brokerSubscriptionSessionRef_val_ptr,
                                 size_t
                                 brokerSubscriptionSessionRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionSessionRef_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionSessionRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionSessionRef value.
     * set brokerSubscriptionSessionRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionSessionRef,
           brokerSubscriptionSessionRef_val_ptr,
           brokerSubscriptionSessionRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSubscriptionSessionRef_len =
        brokerSubscriptionSessionRef_val_ptr_len /
        sizeof(brokerSubscriptionSessionRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSubscriptionSessionRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionSessionRef_undo(brokerSubscriptionTable_rowreq_ctx *
                                  rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionSessionRef_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionSessionRef undo.
     */
    /*
     * copy brokerSubscriptionSessionRef and brokerSubscriptionSessionRef_len data
     * set rowreq_ctx->data.brokerSubscriptionSessionRef from rowreq_ctx->undo->brokerSubscriptionSessionRef
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionSessionRef,
           rowreq_ctx->undo->brokerSubscriptionSessionRef,
           (rowreq_ctx->undo->brokerSubscriptionSessionRef_len *
            sizeof(rowreq_ctx->data.brokerSubscriptionSessionRef[0])));
    rowreq_ctx->data.brokerSubscriptionSessionRef_len =
        rowreq_ctx->undo->brokerSubscriptionSessionRef_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionSessionRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionQueueRef
 * brokerSubscriptionQueueRef is subid 2 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.2
 * Description:
Subscription queueRef
                     Additional info ( nodeType:property, references:Queue, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionQueueRef_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionQueueRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionQueueRef_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSubscriptionQueueRef).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionQueueRef_check_value(brokerSubscriptionTable_rowreq_ctx *
                                       rowreq_ctx,
                                       char
                                       *brokerSubscriptionQueueRef_val_ptr,
                                       size_t
                                       brokerSubscriptionQueueRef_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionQueueRef_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionQueueRef_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionQueueRef value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionQueueRef value not illegal */
}                               /* brokerSubscriptionQueueRef_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionQueueRef_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                      rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionQueueRef_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionQueueRef undo.
     */
    /*
     * copy brokerSubscriptionQueueRef and brokerSubscriptionQueueRef_len data
     * set rowreq_ctx->undo->brokerSubscriptionQueueRef from rowreq_ctx->data.brokerSubscriptionQueueRef
     */
    memcpy(rowreq_ctx->undo->brokerSubscriptionQueueRef,
           rowreq_ctx->data.brokerSubscriptionQueueRef,
           (rowreq_ctx->data.brokerSubscriptionQueueRef_len *
            sizeof(rowreq_ctx->undo->brokerSubscriptionQueueRef[0])));
    rowreq_ctx->undo->brokerSubscriptionQueueRef_len =
        rowreq_ctx->data.brokerSubscriptionQueueRef_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionQueueRef_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionQueueRef_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionQueueRef_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionQueueRef_val_ptr
 */
int
brokerSubscriptionQueueRef_set(brokerSubscriptionTable_rowreq_ctx *
                               rowreq_ctx,
                               char *brokerSubscriptionQueueRef_val_ptr,
                               size_t
                               brokerSubscriptionQueueRef_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionQueueRef_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionQueueRef_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionQueueRef value.
     * set brokerSubscriptionQueueRef value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionQueueRef,
           brokerSubscriptionQueueRef_val_ptr,
           brokerSubscriptionQueueRef_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSubscriptionQueueRef_len =
        brokerSubscriptionQueueRef_val_ptr_len /
        sizeof(brokerSubscriptionQueueRef_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSubscriptionQueueRef_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionQueueRef_undo(brokerSubscriptionTable_rowreq_ctx *
                                rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionQueueRef_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionQueueRef undo.
     */
    /*
     * copy brokerSubscriptionQueueRef and brokerSubscriptionQueueRef_len data
     * set rowreq_ctx->data.brokerSubscriptionQueueRef from rowreq_ctx->undo->brokerSubscriptionQueueRef
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionQueueRef,
           rowreq_ctx->undo->brokerSubscriptionQueueRef,
           (rowreq_ctx->undo->brokerSubscriptionQueueRef_len *
            sizeof(rowreq_ctx->data.brokerSubscriptionQueueRef[0])));
    rowreq_ctx->data.brokerSubscriptionQueueRef_len =
        rowreq_ctx->undo->brokerSubscriptionQueueRef_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionQueueRef_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionName
 * brokerSubscriptionName is subid 3 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.3
 * Description:
Subscription name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionName_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionName_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSubscriptionName).
 *    The length is in (one of) the range set(s):  0 - 255
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionName_check_value(brokerSubscriptionTable_rowreq_ctx *
                                   rowreq_ctx,
                                   char *brokerSubscriptionName_val_ptr,
                                   size_t
                                   brokerSubscriptionName_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionName_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionName_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionName value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionName value not illegal */
}                               /* brokerSubscriptionName_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionName_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                  rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionName_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionName undo.
     */
    /*
     * copy brokerSubscriptionName and brokerSubscriptionName_len data
     * set rowreq_ctx->undo->brokerSubscriptionName from rowreq_ctx->data.brokerSubscriptionName
     */
    memcpy(rowreq_ctx->undo->brokerSubscriptionName,
           rowreq_ctx->data.brokerSubscriptionName,
           (rowreq_ctx->data.brokerSubscriptionName_len *
            sizeof(rowreq_ctx->undo->brokerSubscriptionName[0])));
    rowreq_ctx->undo->brokerSubscriptionName_len =
        rowreq_ctx->data.brokerSubscriptionName_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionName_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionName_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionName_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionName_val_ptr
 */
int
brokerSubscriptionName_set(brokerSubscriptionTable_rowreq_ctx * rowreq_ctx,
                           char *brokerSubscriptionName_val_ptr,
                           size_t brokerSubscriptionName_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionName_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionName_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionName value.
     * set brokerSubscriptionName value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionName,
           brokerSubscriptionName_val_ptr,
           brokerSubscriptionName_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSubscriptionName_len =
        brokerSubscriptionName_val_ptr_len /
        sizeof(brokerSubscriptionName_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSubscriptionName_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionName_undo(brokerSubscriptionTable_rowreq_ctx *
                            rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionName_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionName undo.
     */
    /*
     * copy brokerSubscriptionName and brokerSubscriptionName_len data
     * set rowreq_ctx->data.brokerSubscriptionName from rowreq_ctx->undo->brokerSubscriptionName
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionName,
           rowreq_ctx->undo->brokerSubscriptionName,
           (rowreq_ctx->undo->brokerSubscriptionName_len *
            sizeof(rowreq_ctx->data.brokerSubscriptionName[0])));
    rowreq_ctx->data.brokerSubscriptionName_len =
        rowreq_ctx->undo->brokerSubscriptionName_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionName_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionBrowsing
 * brokerSubscriptionBrowsing is subid 4 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.4
 * Description:
Subscription browsing
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionBrowsing_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionBrowsing_check_value(brokerSubscriptionTable_rowreq_ctx *
                                       rowreq_ctx,
                                       u_long
                                       brokerSubscriptionBrowsing_val)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionBrowsing_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionBrowsing value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionBrowsing value not illegal */
}                               /* brokerSubscriptionBrowsing_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionBrowsing_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                      rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionBrowsing_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionBrowsing undo.
     */
    /*
     * copy brokerSubscriptionBrowsing data
     * set rowreq_ctx->undo->brokerSubscriptionBrowsing from rowreq_ctx->data.brokerSubscriptionBrowsing
     */
    rowreq_ctx->undo->brokerSubscriptionBrowsing =
        rowreq_ctx->data.brokerSubscriptionBrowsing;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionBrowsing_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionBrowsing_val
 *        A long containing the new value.
 */
int
brokerSubscriptionBrowsing_set(brokerSubscriptionTable_rowreq_ctx *
                               rowreq_ctx,
                               u_long brokerSubscriptionBrowsing_val)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionBrowsing_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionBrowsing value.
     * set brokerSubscriptionBrowsing value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerSubscriptionBrowsing =
        brokerSubscriptionBrowsing_val;

    return MFD_SUCCESS;
}                               /* brokerSubscriptionBrowsing_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionBrowsing_undo(brokerSubscriptionTable_rowreq_ctx *
                                rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionBrowsing_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionBrowsing undo.
     */
    /*
     * copy brokerSubscriptionBrowsing data
     * set rowreq_ctx->data.brokerSubscriptionBrowsing from rowreq_ctx->undo->brokerSubscriptionBrowsing
     */
    rowreq_ctx->data.brokerSubscriptionBrowsing =
        rowreq_ctx->undo->brokerSubscriptionBrowsing;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionBrowsing_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionAcknowledged
 * brokerSubscriptionAcknowledged is subid 5 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.5
 * Description:
Subscription acknowledged
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionAcknowledged_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionAcknowledged_check_value
    (brokerSubscriptionTable_rowreq_ctx * rowreq_ctx,
     u_long brokerSubscriptionAcknowledged_val)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionAcknowledged_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionAcknowledged value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionAcknowledged value not illegal */
}                               /* brokerSubscriptionAcknowledged_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionAcknowledged_undo_setup
    (brokerSubscriptionTable_rowreq_ctx * rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionAcknowledged_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionAcknowledged undo.
     */
    /*
     * copy brokerSubscriptionAcknowledged data
     * set rowreq_ctx->undo->brokerSubscriptionAcknowledged from rowreq_ctx->data.brokerSubscriptionAcknowledged
     */
    rowreq_ctx->undo->brokerSubscriptionAcknowledged =
        rowreq_ctx->data.brokerSubscriptionAcknowledged;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionAcknowledged_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionAcknowledged_val
 *        A long containing the new value.
 */
int
brokerSubscriptionAcknowledged_set(brokerSubscriptionTable_rowreq_ctx *
                                   rowreq_ctx,
                                   u_long
                                   brokerSubscriptionAcknowledged_val)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionAcknowledged_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionAcknowledged value.
     * set brokerSubscriptionAcknowledged value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerSubscriptionAcknowledged =
        brokerSubscriptionAcknowledged_val;

    return MFD_SUCCESS;
}                               /* brokerSubscriptionAcknowledged_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionAcknowledged_undo(brokerSubscriptionTable_rowreq_ctx *
                                    rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionAcknowledged_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionAcknowledged undo.
     */
    /*
     * copy brokerSubscriptionAcknowledged data
     * set rowreq_ctx->data.brokerSubscriptionAcknowledged from rowreq_ctx->undo->brokerSubscriptionAcknowledged
     */
    rowreq_ctx->data.brokerSubscriptionAcknowledged =
        rowreq_ctx->undo->brokerSubscriptionAcknowledged;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionAcknowledged_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionExclusive
 * brokerSubscriptionExclusive is subid 6 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.6
 * Description:
Subscription exclusive
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  1      hasdefval 0
 *   readable   1     iscolumn 1     ranges 0      hashint   0
 *   settable   1
 *
 * Enum range: 2/8. Values:  true(1), false(2)
 *
 * Its syntax is TruthValue (based on perltype INTEGER)
 * The net-snmp type is ASN_INTEGER. The C type decl is long (u_long)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionExclusive_val
 *        A long containing the new value.
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_INTEGER
 *    The value is one of  true(1), false(2)
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionExclusive_check_value(brokerSubscriptionTable_rowreq_ctx
                                        * rowreq_ctx,
                                        u_long
                                        brokerSubscriptionExclusive_val)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionExclusive_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionExclusive value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionExclusive value not illegal */
}                               /* brokerSubscriptionExclusive_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionExclusive_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                       rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionExclusive_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionExclusive undo.
     */
    /*
     * copy brokerSubscriptionExclusive data
     * set rowreq_ctx->undo->brokerSubscriptionExclusive from rowreq_ctx->data.brokerSubscriptionExclusive
     */
    rowreq_ctx->undo->brokerSubscriptionExclusive =
        rowreq_ctx->data.brokerSubscriptionExclusive;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionExclusive_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionExclusive_val
 *        A long containing the new value.
 */
int
brokerSubscriptionExclusive_set(brokerSubscriptionTable_rowreq_ctx *
                                rowreq_ctx,
                                u_long brokerSubscriptionExclusive_val)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionExclusive_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionExclusive value.
     * set brokerSubscriptionExclusive value in rowreq_ctx->data
     */
    rowreq_ctx->data.brokerSubscriptionExclusive =
        brokerSubscriptionExclusive_val;

    return MFD_SUCCESS;
}                               /* brokerSubscriptionExclusive_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionExclusive_undo(brokerSubscriptionTable_rowreq_ctx *
                                 rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionExclusive_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionExclusive undo.
     */
    /*
     * copy brokerSubscriptionExclusive data
     * set rowreq_ctx->data.brokerSubscriptionExclusive from rowreq_ctx->undo->brokerSubscriptionExclusive
     */
    rowreq_ctx->data.brokerSubscriptionExclusive =
        rowreq_ctx->undo->brokerSubscriptionExclusive;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionExclusive_undo */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerSubscriptionEntry.brokerSubscriptionArguments
 * brokerSubscriptionArguments is subid 8 of brokerSubscriptionEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.9.1.1.8
 * Description:
Subscription arguments
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 65535a
 *
 * Ranges:  0 - 65535;
 *
 * Its syntax is Map (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 65535)
 */
/**
 * Check that the proposed new value is potentially valid.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerSubscriptionArguments_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionArguments_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionArguments_val_ptr
 *
 * @retval MFD_SUCCESS        : incoming value is legal
 * @retval MFD_NOT_VALID_NOW  : incoming value is not valid now
 * @retval MFD_NOT_VALID_EVER : incoming value is never valid
 *
 * This is the place to check for requirements that are not
 * expressed in the mib syntax (for example, a requirement that
 * is detailed in the description for an object).
 *
 * You should check that the requested change between the undo value and the
 * new value is legal (ie, the transistion from one value to another
 * is legal).
 *      
 *@note
 * This check is only to determine if the new value
 * is \b potentially valid. This is the first check of many, and
 * is one of the simplest ones.
 * 
 *@note
 * this is not the place to do any checks for values
 * which depend on some other value in the mib. Those
 * types of checks should be done in the
 * brokerSubscriptionTable_check_dependencies() function.
 *
 * The following checks have already been done for you:
 *    The syntax is ASN_OCTET_STR
 *    The length is < sizeof(rowreq_ctx->data.brokerSubscriptionArguments).
 *    The length is in (one of) the range set(s):  0 - 65535
 *
 * If there a no other checks you need to do, simply return MFD_SUCCESS.
 *
 */
int
brokerSubscriptionArguments_check_value(brokerSubscriptionTable_rowreq_ctx
                                        * rowreq_ctx,
                                        char
                                        *brokerSubscriptionArguments_val_ptr,
                                        size_t
                                        brokerSubscriptionArguments_val_ptr_len)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionArguments_check_value", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionArguments_val_ptr);

    /*
     * TODO:441:o: |-> Check for valid brokerSubscriptionArguments value.
     */

    return MFD_SUCCESS;         /* brokerSubscriptionArguments value not illegal */
}                               /* brokerSubscriptionArguments_check_value */

/**
 * Save old value information
 *
 * @param rowreq_ctx
 *        Pointer to the table context (brokerSubscriptionTable_rowreq_ctx)
 *
 * @retval MFD_SUCCESS : success
 * @retval MFD_ERROR   : error. set will fail.
 *
 * This function will be called after the table level undo setup function
 * brokerSubscriptionTable_undo_setup has been called.
 *
 *@note
 * this function will only be called if a new value is set for this column.
 *
 * If there is any setup specific to a particular column (e.g. allocating
 * memory for a string), you should do that setup in this function, so it
 * won't be done unless it is necessary.
 */
int
brokerSubscriptionArguments_undo_setup(brokerSubscriptionTable_rowreq_ctx *
                                       rowreq_ctx)
{
    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionArguments_undo_setup", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:455:o: |-> Setup brokerSubscriptionArguments undo.
     */
    /*
     * copy brokerSubscriptionArguments and brokerSubscriptionArguments_len data
     * set rowreq_ctx->undo->brokerSubscriptionArguments from rowreq_ctx->data.brokerSubscriptionArguments
     */
    memcpy(rowreq_ctx->undo->brokerSubscriptionArguments,
           rowreq_ctx->data.brokerSubscriptionArguments,
           (rowreq_ctx->data.brokerSubscriptionArguments_len *
            sizeof(rowreq_ctx->undo->brokerSubscriptionArguments[0])));
    rowreq_ctx->undo->brokerSubscriptionArguments_len =
        rowreq_ctx->data.brokerSubscriptionArguments_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionArguments_undo_setup */

/**
 * Set the new value.
 *
 * @param rowreq_ctx
 *        Pointer to the users context. You should know how to
 *        manipulate the value from this object.
 * @param brokerSubscriptionArguments_val_ptr
 *        A char containing the new value.
 * @param brokerSubscriptionArguments_val_ptr_len
 *        The size (in bytes) of the data pointed to by brokerSubscriptionArguments_val_ptr
 */
int
brokerSubscriptionArguments_set(brokerSubscriptionTable_rowreq_ctx *
                                rowreq_ctx,
                                char *brokerSubscriptionArguments_val_ptr,
                                size_t
                                brokerSubscriptionArguments_val_ptr_len)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionArguments_set", "called\n"));

    /** should never get a NULL pointer */
    netsnmp_assert(NULL != rowreq_ctx);
    netsnmp_assert(NULL != brokerSubscriptionArguments_val_ptr);

    /*
     * TODO:461:M: |-> Set brokerSubscriptionArguments value.
     * set brokerSubscriptionArguments value in rowreq_ctx->data
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionArguments,
           brokerSubscriptionArguments_val_ptr,
           brokerSubscriptionArguments_val_ptr_len);
    /** convert bytes to number of char */
    rowreq_ctx->data.brokerSubscriptionArguments_len =
        brokerSubscriptionArguments_val_ptr_len /
        sizeof(brokerSubscriptionArguments_val_ptr[0]);

    return MFD_SUCCESS;
}                               /* brokerSubscriptionArguments_set */

/**
 * undo the previous set.
 *
 * @param rowreq_ctx
 *        Pointer to the users context.
 */
int
brokerSubscriptionArguments_undo(brokerSubscriptionTable_rowreq_ctx *
                                 rowreq_ctx)
{

    DEBUGMSGTL(("verbose:brokerSubscriptionTable:brokerSubscriptionArguments_undo", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:456:o: |-> Clean up brokerSubscriptionArguments undo.
     */
    /*
     * copy brokerSubscriptionArguments and brokerSubscriptionArguments_len data
     * set rowreq_ctx->data.brokerSubscriptionArguments from rowreq_ctx->undo->brokerSubscriptionArguments
     */
    memcpy(rowreq_ctx->data.brokerSubscriptionArguments,
           rowreq_ctx->undo->brokerSubscriptionArguments,
           (rowreq_ctx->undo->brokerSubscriptionArguments_len *
            sizeof(rowreq_ctx->data.brokerSubscriptionArguments[0])));
    rowreq_ctx->data.brokerSubscriptionArguments_len =
        rowreq_ctx->undo->brokerSubscriptionArguments_len;


    return MFD_SUCCESS;
}                               /* brokerSubscriptionArguments_undo */

/**
 * check dependencies
 *
 * This is useful for for tables which have dependencies between columns
 * (or rows, or tables). For example, two columns allocating a percentage
 * of something add up 100%.
 *
 * Should you need different behavior depending on which columns were
 * set, rowreq_ctx->column_set_flags will indicate which writeable columns were
 * set. The definitions for the COLUMN_*_FLAG bits can be found in
 * brokerSubscriptionTable_oids.h.
 * A new row will have the MFD_ROW_CREATED bit set in rowreq_flags.
 *
 * @retval MFD_SUCCESS all the changes to the row are legal
 * @retval MFD_ERROR   one or more changes are not legal
 *
 * (see README-table-brokerSubscriptionTable if you don't have dependencies)
 */
int
brokerSubscriptionTable_check_dependencies
    (brokerSubscriptionTable_rowreq_ctx * rowreq_ctx)
{
    int             rc = MFD_SUCCESS;

    DEBUGMSGTL(("internal:brokerSubscriptionTable:brokerSubscriptionTable_check_dependencies", "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:470:o: Check brokerSubscriptionTable row dependencies.
     * check that all new value are legal and consistent with each other
     */
    return rc;
}                               /* brokerSubscriptionTable_check_dependencies */

/** @} */
