/*
 * Note: this file originally auto-generated by mib2c using
 *        $
 */

#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include "Events.h"

#include "../qpid_api.h"

extern const oid snmptrap_oid[];
extern const size_t snmptrap_oid_len;

int
send_brokerEvtClientConnect_trap(const char * rHost, const char * user)
{
	// sanity check the args
	if (!rHost || !user) {
		char * badArg = "rHost";
		if (!user)
			badArg = "user";
		// if both are null, only user gets reported
		DEBUGMSGTL(("qpid-snmp/send_brokerEvtClientConnect_trap", "NULL %s\n", badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtClientConnect_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 1 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtClientConnect_oid,
                              sizeof(brokerEvtClientConnect_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));

    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtClientConnectFail_trap(const char * rHost, const char * user, const char * reason)
{
	// sanity check the args
	if (!rHost || !user || !reason) {
		char * badArg = "rHost";
		if (!user)
			badArg = "user";
		else if (!reason)
			badArg = "reason";

		// if multiple are null, only one of them gets reported
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtClientConnectFail_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 2 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtReason_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 12, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtClientConnectFail_oid,
                              sizeof(brokerEvtClientConnectFail_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtReason_oid,
                              OID_LENGTH(brokerEvtReason_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtReason 
                               */
                              reason, strlen(reason));

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtClientDisconnect_trap(const char * rHost, const char * user)
{
	// sanity check the args
	if (!rHost || !user) {
		char * badArg = "rHost";
		if (!user)
			badArg = "user";
		// if both are null, only user gets reported
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtClientDisconnect_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 3 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtClientDisconnect_oid,
                              sizeof(brokerEvtClientDisconnect_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtBrokerLinkUp_trap(const char *rHost)
{
	// sanity check the args
	if (!rHost) {
		DEBUGMSGTL(("qpid-snmp", "/%s: rHost was NULL\n", __func__));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtBrokerLinkUp_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 4 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtBrokerLinkUp_oid,
                              sizeof(brokerEvtBrokerLinkUp_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtBrokerLinkDown_trap(const char *rHost)
{
	// sanity check the args
	if (!rHost) {
		DEBUGMSGTL(("qpid-snmp", "/%s: rHost was NULL\n", __func__));
		return SNMP_ERR_BADVALUE;
	}
    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtBrokerLinkDown_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 5 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtBrokerLinkDown_oid,
                              sizeof(brokerEvtBrokerLinkDown_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtQueueDeclare_trap(const char *rHost, const char * user, const char * qName,
		int durable, int exclusive, int autoDelete, const char *altEx,
		const char *args, const char *disp)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!qName)
		badArg = "qName";
	else if (!altEx)
		badArg = "altEx";
	else if (!args)
		badArg = "args";
	else if (!disp)
		badArg = "disp";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtQueueDeclare_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 6 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };
    const oid       brokerEvtDurable_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 6, 0 };
    const oid       brokerEvtExcl_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 9, 0 };
    const oid       brokerEvtAutoDel_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 3, 0 };
    const oid       brokerEvtAltEx_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 1, 0 };
    const oid       brokerEvtArgs_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 2, 0 };
    const oid       brokerEvtDisp_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 5, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtQueueDeclare_oid,
                              sizeof(brokerEvtQueueDeclare_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDurable_oid,
                              OID_LENGTH(brokerEvtDurable_oid),
                              ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtDurable 
                               */
                              &durable, sizeof(durable));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExcl_oid,
                              OID_LENGTH(brokerEvtExcl_oid), ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtExcl 
                               */
                              &exclusive, sizeof(exclusive));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAutoDel_oid,
                              OID_LENGTH(brokerEvtAutoDel_oid),
                              ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtAutoDel 
                               */
                              &autoDelete, sizeof(autoDelete));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAltEx_oid,
                              OID_LENGTH(brokerEvtAltEx_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtAltEx 
                               */
                              altEx, strlen(altEx));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArgs_oid,
                              OID_LENGTH(brokerEvtArgs_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArgs 
                               */
                              args, strlen(args));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDisp_oid,
                              OID_LENGTH(brokerEvtDisp_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtDisp 
                               */
                              disp, strlen(disp));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtQueueDelete_trap(const char *rHost, const char * user, const char * qName)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!qName)
		badArg = "qName";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtQueueDelete_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 7 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtQueueDelete_oid,
                              sizeof(brokerEvtQueueDelete_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtExchangeDeclare_trap(const char *rHost, const char * user, const char * exName,
		const char *exType, const char *altEx, int durable, int autoDelete,
		const char *args, const char *disp)
{

	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!exName)
		badArg = "exName";
	else if (!exType)
		badArg = "exType";
	else if (!altEx)
		badArg = "altEx";
	else if (!args)
		badArg = "args";
	else if (!disp)
		badArg = "disp";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtExchangeDeclare_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 8 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtExName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 7, 0 };
    const oid       brokerEvtExType_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 8, 0 };
    const oid       brokerEvtAltEx_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 1, 0 };
    const oid       brokerEvtDurable_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 6, 0 };
    const oid       brokerEvtAutoDel_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 3, 0 };
    const oid       brokerEvtArgs_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 2, 0 };
    const oid       brokerEvtDisp_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 5, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtExchangeDeclare_oid,
                              sizeof(brokerEvtExchangeDeclare_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExName_oid,
                              OID_LENGTH(brokerEvtExName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtExName 
                               */
                              exName, strlen(exName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExType_oid,
                              OID_LENGTH(brokerEvtExType_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtExType 
                               */
                              exType, strlen(exType));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAltEx_oid,
                              OID_LENGTH(brokerEvtAltEx_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtAltEx 
                               */
                              altEx, strlen(altEx));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDurable_oid,
                              OID_LENGTH(brokerEvtDurable_oid),
                              ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtDurable 
                               */
                              &durable, sizeof(durable));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAutoDel_oid,
                              OID_LENGTH(brokerEvtAutoDel_oid),
                              ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtAutoDel 
                               */
                              &autoDelete, sizeof(autoDelete));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArgs_oid,
                              OID_LENGTH(brokerEvtArgs_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArgs 
                               */
                              args, strlen(args));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDisp_oid,
                              OID_LENGTH(brokerEvtDisp_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtDisp 
                               */
                              disp, strlen(disp));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtExchangeDelete_trap(const char *rHost, const char * user, const char * exName)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!exName)
		badArg = "exName";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtExchangeDelete_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 9 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtExName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 7, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtExchangeDelete_oid,
                              sizeof(brokerEvtExchangeDelete_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExName_oid,
                              OID_LENGTH(brokerEvtExName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtExName 
                               */
                              exName, strlen(exName));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtBind_trap(const char *rHost, const char * user,
		const char *exName, const char *qName, const char * key, const char * args)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!exName)
		badArg = "exName";
	else if (!qName)
		badArg = "qName";
	else if (!key)
		badArg = "key";
	else if (!args)
		badArg = "args";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

		netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtBind_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 10 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtExName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 7, 0 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };
    const oid       brokerEvtKey_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 10, 0 };
    const oid       brokerEvtArgs_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 2, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtBind_oid,
                              sizeof(brokerEvtBind_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExName_oid,
                              OID_LENGTH(brokerEvtExName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtExName 
                               */
                              exName, strlen(exName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtKey_oid,
                              OID_LENGTH(brokerEvtKey_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtKey 
                               */
                              key, strlen(key));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArgs_oid,
                              OID_LENGTH(brokerEvtArgs_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArgs 
                               */
                              args, strlen(args));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtUnbind_trap(const char *rHost, const char * user,
		const char *exName, const char *qName, const char * key)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!exName)
		badArg = "exName";
	else if (!qName)
		badArg = "qName";
	else if (!key)
		badArg = "key";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtUnbind_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 11 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtExName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 7, 0 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };
    const oid       brokerEvtKey_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 10, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtUnbind_oid,
                              sizeof(brokerEvtUnbind_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExName_oid,
                              OID_LENGTH(brokerEvtExName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtExName 
                               */
                              exName, strlen(exName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtKey_oid,
                              OID_LENGTH(brokerEvtKey_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtKey 
                               */
                              key, strlen(key));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtSubscribe_trap(const char *rHost, const char * user, const char * qName,
		int exclusive, const char *dest, const char *args)
{
	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!qName)
		badArg = "qName";
	else if (!dest)
		badArg = "dest";
	else if (!args)
		badArg = "args";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtSubscribe_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 12 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };
    const oid       brokerEvtDest_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 4, 0 };
    const oid       brokerEvtExcl_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 9, 0 };
    const oid       brokerEvtArgs_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 2, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtSubscribe_oid,
                              sizeof(brokerEvtSubscribe_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDest_oid,
                              OID_LENGTH(brokerEvtDest_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtDest 
                               */
                              dest, strlen(dest));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtExcl_oid,
                              OID_LENGTH(brokerEvtExcl_oid), ASN_INTEGER,
                              /*
                               * Set an appropriate value for brokerEvtExcl 
                               */
                              &exclusive, sizeof(exclusive));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArgs_oid,
                              OID_LENGTH(brokerEvtArgs_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArgs 
                               */
                              args, strlen(args));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

//	  <event name="unsubscribe"       sev="inform" args="rhost, user, dest"/>
int
send_brokerEvtUnsubscribe_trap(const char *rHost, const char * user, const char *dest)
{

	// sanity check the args
	char * badArg = NULL;
	if (!rHost)
		badArg = "rHost";
	else if (!user)
		badArg = "user";
	else if (!dest)
		badArg = "dest";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}


	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtUnsubscribe_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 13 };
    const oid       brokerEvtRhost_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 13, 0 };
    const oid       brokerEvtUser_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 14, 0 };
    const oid       brokerEvtDest_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 4, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtUnsubscribe_oid,
                              sizeof(brokerEvtUnsubscribe_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtRhost_oid,
                              OID_LENGTH(brokerEvtRhost_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtRhost 
                               */
                              rHost, strlen(rHost));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUser_oid,
                              OID_LENGTH(brokerEvtUser_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUser 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtDest_oid,
                              OID_LENGTH(brokerEvtDest_oid), ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtDest 
                               */
                              dest, strlen(dest));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtQueueThresholdExceeded_trap(const char *qName, uint64_t msgDepth, uint64_t byteDepth)
{
	// sanity check the args
	if (!qName) {
		DEBUGMSGTL(("qpid-snmp", "/%s: qName was NULL\n", __func__));
		return SNMP_ERR_BADVALUE;
	}
	U64 u64MsgDepth, u64ByteDepth;
	u64MsgDepth.high = HIGHLONG(msgDepth);
	u64MsgDepth.low = LOWLONG(msgDepth);
	u64ByteDepth.high = HIGHLONG(byteDepth);
	u64ByteDepth.low = LOWLONG(byteDepth);

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtQueueThresholdExceeded_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 14 };
    const oid       brokerEvtQName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 11, 0 };
    const oid       brokerEvtMsgDepth_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 15, 0 };
    const oid       brokerEvtByteDepth_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 16, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtQueueThresholdExceeded_oid,
                              sizeof(brokerEvtQueueThresholdExceeded_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtQName_oid,
                              OID_LENGTH(brokerEvtQName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtQName 
                               */
                              qName, strlen(qName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtMsgDepth_oid,
                              OID_LENGTH(brokerEvtMsgDepth_oid),
                              ASN_COUNTER64,
                              /*
                               * Set an appropriate value for brokerEvtMsgDepth 
                               */
                              &u64MsgDepth, sizeof(u64MsgDepth));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtByteDepth_oid,
                              OID_LENGTH(brokerEvtByteDepth_oid),
                              ASN_COUNTER64,
                              /*
                               * Set an appropriate value for brokerEvtByteDepth 
                               */
                              &u64ByteDepth, sizeof(u64ByteDepth));

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtAllow_trap(const char *user, const char *action, const char *objectType, const char *objectName, const char *args)
{
	// sanity check the args
	char * badArg = NULL;
	if (!user)
		badArg = "user";
	else if (!action)
		badArg = "action";
	else if (!objectType)
		badArg = "objectType";
	else if (!objectName)
		badArg = "objectName";
	else if (!args)
		badArg = "args";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtAllow_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 15 };
    const oid       brokerEvtUserId_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 21, 0 };
    const oid       brokerEvtAction_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 17, 0 };
    const oid       brokerEvtObjectType_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 20, 0 };
    const oid       brokerEvtObjectName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 19, 0 };
    const oid       brokerEvtArguments_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 18, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtAllow_oid,
                              sizeof(brokerEvtAllow_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUserId_oid,
                              OID_LENGTH(brokerEvtUserId_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUserId 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAction_oid,
                              OID_LENGTH(brokerEvtAction_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtAction 
                               */
                              action, strlen(action));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtObjectType_oid,
                              OID_LENGTH(brokerEvtObjectType_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtObjectType 
                               */
                              objectType, strlen(objectType));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtObjectName_oid,
                              OID_LENGTH(brokerEvtObjectName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtObjectName 
                               */
                              objectType, strlen(objectType));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArguments_oid,
                              OID_LENGTH(brokerEvtArguments_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArguments 
                               */
                              args, strlen(args));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtDeny_trap(const char *user, const char *action, const char *objectType, const char *objectName, const char *args)
{
	// sanity check the args
	char * badArg = NULL;
	if (!user)
		badArg = "user";
	else if (!action)
		badArg = "action";
	else if (!objectType)
		badArg = "objectType";
	else if (!objectName)
		badArg = "objectName";
	else if (!args)
		badArg = "args";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

    netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtDeny_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 16 };
    const oid       brokerEvtUserId_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 21, 0 };
    const oid       brokerEvtAction_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 17, 0 };
    const oid       brokerEvtObjectType_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 20, 0 };
    const oid       brokerEvtObjectName_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 19, 0 };
    const oid       brokerEvtArguments_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 18, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtDeny_oid,
                              sizeof(brokerEvtDeny_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUserId_oid,
                              OID_LENGTH(brokerEvtUserId_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUserId 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtAction_oid,
                              OID_LENGTH(brokerEvtAction_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtAction 
                               */
                              action, strlen(action));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtObjectType_oid,
                              OID_LENGTH(brokerEvtObjectType_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtObjectType 
                               */
                              objectType, strlen(objectType));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtObjectName_oid,
                              OID_LENGTH(brokerEvtObjectName_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtObjectName 
                               */
                              objectName, strlen(objectName));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtArguments_oid,
                              OID_LENGTH(brokerEvtArguments_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtArguments 
                               */
                              args, strlen(args));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtFileLoaded_trap(const char *user)
{
	// sanity check the args
	if (!user) {
		DEBUGMSGTL(("qpid-snmp", "/%s: user was NULL\n", __func__));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtFileLoaded_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 17 };
    const oid       brokerEvtUserId_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 21, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtFileLoaded_oid,
                              sizeof(brokerEvtFileLoaded_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUserId_oid,
                              OID_LENGTH(brokerEvtUserId_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUserId 
                               */
                              user, strlen(user));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}

int
send_brokerEvtFileLoadFailed_trap(const char *user, const char *reason)
{
	// sanity check the args
	char * badArg = NULL;
	if (!user)
		badArg = "user";
	else if (!reason)
		badArg = "reason";
	// if more than one is NULL, only first NULL gets reported
	if (badArg != NULL) {
		DEBUGMSGTL(("qpid-snmp", "/%s: %s was NULL\n", __func__, badArg));
		return SNMP_ERR_BADVALUE;
	}

	netsnmp_variable_list *var_list = NULL;
    const oid       brokerEvtFileLoadFailed_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 0, 18 };
    const oid       brokerEvtUserId_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 21, 0 };
    const oid       brokerEvtReason_oid[] =
        { 1, 3, 6, 1, 4, 1, 18060,5672, 3, 2, 1, 12, 0 };

    /*
     * Set the snmpTrapOid.0 value
     */
    snmp_varlist_add_variable(&var_list,
                              snmptrap_oid, snmptrap_oid_len,
                              ASN_OBJECT_ID,
                              brokerEvtFileLoadFailed_oid,
                              sizeof(brokerEvtFileLoadFailed_oid));

    /*
     * Add any objects from the trap definition
     */
    snmp_varlist_add_variable(&var_list,
                              brokerEvtUserId_oid,
                              OID_LENGTH(brokerEvtUserId_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtUserId 
                               */
                              user, strlen(user));
    snmp_varlist_add_variable(&var_list,
                              brokerEvtReason_oid,
                              OID_LENGTH(brokerEvtReason_oid),
                              ASN_OCTET_STR,
                              /*
                               * Set an appropriate value for brokerEvtReason 
                               */
                              reason, strlen(reason));

    /*
     * Add any extra (optional) objects here
     */

    /*
     * Send the trap to the list of configured destinations
     *  and clean up
     */
    send_v2trap(var_list);
    snmp_free_varbind(var_list);

    return SNMP_ERR_NOERROR;
}
