/*
 * Note: this file originally auto-generated by mib2c using
 *       version $ of $ 
 *
 * $Id:$
 */
/*
 * standard Net-SNMP includes 
 */
#include <net-snmp/net-snmp-config.h>
#include "../include/net-snmp-features.h"
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/*
 * include our parent header 
 */
#include "VhostTable.h"


/** @defgroup data_get data_get: Routines to get data
 *
 * TODO:230:M: Implement brokerVhostTable get routines.
 * TODO:240:M: Implement brokerVhostTable mapping routines (if any).
 *
 * These routine are used to get the value for individual objects. The
 * row context is passed, along with a pointer to the memory where the
 * value should be copied.
 *
 * @{
 */
/**********************************************************************
 **********************************************************************
 ***
 *** Table brokerVhostTable
 ***
 **********************************************************************
 **********************************************************************/
/*
 * QPID-MESSAGING-MIB::brokerVhostTable is subid 1 of brokerVhosts.
 * Its status is Current.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.5.1, length: 12
 */

/*
 * ---------------------------------------------------------------------
 * * TODO:200:r: Implement brokerVhostTable data context functions.
 */


/**
 * set mib index(es)
 *
 * @param tbl_idx mib index structure
 * @param brokerVhostInternalIndex_val
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This convenience function is useful for setting all the MIB index
 *  components with a single function call. It is assume that the C values
 *  have already been mapped from their native/rawformat to the MIB format.
 */
int
brokerVhostTable_indexes_set_tbl_idx(brokerVhostTable_mib_index * tbl_idx,
                                     u_long brokerVhostInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerVhostTable:brokerVhostTable_indexes_set_tbl_idx", "called\n"));

    /*
     * brokerVhostInternalIndex(4)/UNSIGNED32/ASN_UNSIGNED/u_long(u_long)//l/a/w/e/r/d/h 
     */
    tbl_idx->brokerVhostInternalIndex = brokerVhostInternalIndex_val;


    return MFD_SUCCESS;
}                               /* brokerVhostTable_indexes_set_tbl_idx */

/**
 * @internal
 * set row context indexes
 *
 * @param reqreq_ctx the row context that needs updated indexes
 *
 * @retval MFD_SUCCESS     : success.
 * @retval MFD_ERROR       : other error.
 *
 * @remark
 *  This function sets the mib indexs, then updates the oid indexs
 *  from the mib index.
 */
int
brokerVhostTable_indexes_set(brokerVhostTable_rowreq_ctx * rowreq_ctx,
                             u_long brokerVhostInternalIndex_val)
{
    DEBUGMSGTL(("verbose:brokerVhostTable:brokerVhostTable_indexes_set",
                "called\n"));

    if (MFD_SUCCESS !=
        brokerVhostTable_indexes_set_tbl_idx(&rowreq_ctx->tbl_idx,
                                             brokerVhostInternalIndex_val))
        return MFD_ERROR;

    /*
     * convert mib index to oid index
     */
    rowreq_ctx->oid_idx.len = sizeof(rowreq_ctx->oid_tmp) / sizeof(oid);
    if (0 != brokerVhostTable_index_to_oid(&rowreq_ctx->oid_idx,
                                           &rowreq_ctx->tbl_idx)) {
        return MFD_ERROR;
    }

    return MFD_SUCCESS;
}                               /* brokerVhostTable_indexes_set */


/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerVhostEntry.brokerVhostBrokerRef
 * brokerVhostBrokerRef is subid 1 of brokerVhostEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.5.1.1.1
 * Description:
Vhost brokerRef
                     Additional info ( nodeType:property, references:Broker, index:y, parentRef:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is ObjId (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerVhostBrokerRef data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerVhostBrokerRef_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerVhostBrokerRef_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerVhostBrokerRef.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerVhostBrokerRef_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerVhostBrokerRef_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerVhostBrokerRef_get(brokerVhostTable_rowreq_ctx * rowreq_ctx,
                         char **brokerVhostBrokerRef_val_ptr_ptr,
                         size_t *brokerVhostBrokerRef_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerVhostBrokerRef_val_ptr_ptr)
                   && (NULL != *brokerVhostBrokerRef_val_ptr_ptr));
    netsnmp_assert(NULL != brokerVhostBrokerRef_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerVhostTable:brokerVhostBrokerRef_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerVhostBrokerRef data.
     * copy (* brokerVhostBrokerRef_val_ptr_ptr ) data and (* brokerVhostBrokerRef_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerVhostBrokerRef data
     */
    if ((NULL == (*brokerVhostBrokerRef_val_ptr_ptr)) ||
        ((*brokerVhostBrokerRef_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerVhostBrokerRef_len *
          sizeof(rowreq_ctx->data.brokerVhostBrokerRef[0])))) {
        /*
         * allocate space for brokerVhostBrokerRef data
         */
        (*brokerVhostBrokerRef_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerVhostBrokerRef_len *
                   sizeof(rowreq_ctx->data.brokerVhostBrokerRef[0]));
        if (NULL == (*brokerVhostBrokerRef_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerVhostBrokerRef)\n");
            return MFD_ERROR;
        }
    }
    (*brokerVhostBrokerRef_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerVhostBrokerRef_len *
        sizeof(rowreq_ctx->data.brokerVhostBrokerRef[0]);
    memcpy((*brokerVhostBrokerRef_val_ptr_ptr),
           rowreq_ctx->data.brokerVhostBrokerRef,
           rowreq_ctx->data.brokerVhostBrokerRef_len *
           sizeof(rowreq_ctx->data.brokerVhostBrokerRef[0]));

    return MFD_SUCCESS;
}                               /* brokerVhostBrokerRef_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerVhostEntry.brokerVhostName
 * brokerVhostName is subid 2 of brokerVhostEntry.
 * Its status is Current, and its access level is ReadWrite.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.5.1.1.2
 * Description:
Vhost name
                     Additional info ( nodeType:property, index:y )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   1
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerVhostName data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerVhostName_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerVhostName_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerVhostName.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerVhostName_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerVhostName_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerVhostName_get(brokerVhostTable_rowreq_ctx * rowreq_ctx,
                    char **brokerVhostName_val_ptr_ptr,
                    size_t *brokerVhostName_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerVhostName_val_ptr_ptr)
                   && (NULL != *brokerVhostName_val_ptr_ptr));
    netsnmp_assert(NULL != brokerVhostName_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerVhostTable:brokerVhostName_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerVhostName data.
     * copy (* brokerVhostName_val_ptr_ptr ) data and (* brokerVhostName_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerVhostName data
     */
    if ((NULL == (*brokerVhostName_val_ptr_ptr)) ||
        ((*brokerVhostName_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerVhostName_len *
          sizeof(rowreq_ctx->data.brokerVhostName[0])))) {
        /*
         * allocate space for brokerVhostName data
         */
        (*brokerVhostName_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerVhostName_len *
                   sizeof(rowreq_ctx->data.brokerVhostName[0]));
        if (NULL == (*brokerVhostName_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerVhostName)\n");
            return MFD_ERROR;
        }
    }
    (*brokerVhostName_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerVhostName_len *
        sizeof(rowreq_ctx->data.brokerVhostName[0]);
    memcpy((*brokerVhostName_val_ptr_ptr),
           rowreq_ctx->data.brokerVhostName,
           rowreq_ctx->data.brokerVhostName_len *
           sizeof(rowreq_ctx->data.brokerVhostName[0]));

    return MFD_SUCCESS;
}                               /* brokerVhostName_get */

/*---------------------------------------------------------------------
 * QPID-MESSAGING-MIB::brokerVhostEntry.brokerVhostFederationTag
 * brokerVhostFederationTag is subid 3 of brokerVhostEntry.
 * Its status is Current, and its access level is ReadOnly.
 * OID: .1.3.6.1.4.1.18060.5672.1.1.5.1.1.3
 * Description:
Vhost federationTag
                     Additional info ( nodeType:property )
 *
 * Attributes:
 *   accessible 1     isscalar 0     enums  0      hasdefval 0
 *   readable   1     iscolumn 1     ranges 1      hashint   1
 *   settable   0
 *   hint: 255a
 *
 * Ranges:  0 - 255;
 *
 * Its syntax is Sstr (based on perltype OCTETSTR)
 * The net-snmp type is ASN_OCTET_STR. The C type decl is char (char)
 * This data type requires a length.  (Max 255)
 */
/**
 * Extract the current value of the brokerVhostFederationTag data.
 *
 * Set a value using the data context for the row.
 *
 * @param rowreq_ctx
 *        Pointer to the row request context.
 * @param brokerVhostFederationTag_val_ptr_ptr
 *        Pointer to storage for a char variable
 * @param brokerVhostFederationTag_val_ptr_len_ptr
 *        Pointer to a size_t. On entry, it will contain the size (in bytes)
 *        pointed to by brokerVhostFederationTag.
 *        On exit, this value should contain the data size (in bytes).
 *
 * @retval MFD_SUCCESS         : success
 * @retval MFD_SKIP            : skip this node (no value for now)
 * @retval MFD_ERROR           : Any other error
*
 * @note If you need more than (*brokerVhostFederationTag_val_ptr_len_ptr) bytes of memory,
 *       allocate it using malloc() and update brokerVhostFederationTag_val_ptr_ptr.
 *       <b>DO NOT</b> free the previous pointer.
 *       The MFD helper will release the memory you allocate.
 *
 * @remark If you call this function yourself, you are responsible
 *         for checking if the pointer changed, and freeing any
 *         previously allocated memory. (Not necessary if you pass
 *         in a pointer to static memory, obviously.)
 */
int
brokerVhostFederationTag_get(brokerVhostTable_rowreq_ctx * rowreq_ctx,
                             char **brokerVhostFederationTag_val_ptr_ptr,
                             size_t
                             *brokerVhostFederationTag_val_ptr_len_ptr)
{
   /** we should have a non-NULL pointer and enough storage */
    netsnmp_assert((NULL != brokerVhostFederationTag_val_ptr_ptr)
                   && (NULL != *brokerVhostFederationTag_val_ptr_ptr));
    netsnmp_assert(NULL != brokerVhostFederationTag_val_ptr_len_ptr);


    DEBUGMSGTL(("verbose:brokerVhostTable:brokerVhostFederationTag_get",
                "called\n"));

    netsnmp_assert(NULL != rowreq_ctx);

    /*
     * TODO:231:o: |-> Extract the current value of the brokerVhostFederationTag data.
     * copy (* brokerVhostFederationTag_val_ptr_ptr ) data and (* brokerVhostFederationTag_val_ptr_len_ptr ) from rowreq_ctx->data
     */
    /*
     * make sure there is enough space for brokerVhostFederationTag data
     */
    if ((NULL == (*brokerVhostFederationTag_val_ptr_ptr)) ||
        ((*brokerVhostFederationTag_val_ptr_len_ptr) <
         (rowreq_ctx->data.brokerVhostFederationTag_len *
          sizeof(rowreq_ctx->data.brokerVhostFederationTag[0])))) {
        /*
         * allocate space for brokerVhostFederationTag data
         */
        (*brokerVhostFederationTag_val_ptr_ptr) =
            malloc(rowreq_ctx->data.brokerVhostFederationTag_len *
                   sizeof(rowreq_ctx->data.brokerVhostFederationTag[0]));
        if (NULL == (*brokerVhostFederationTag_val_ptr_ptr)) {
            snmp_log(LOG_ERR,
                     "could not allocate memory (rowreq_ctx->data.brokerVhostFederationTag)\n");
            return MFD_ERROR;
        }
    }
    (*brokerVhostFederationTag_val_ptr_len_ptr) =
        rowreq_ctx->data.brokerVhostFederationTag_len *
        sizeof(rowreq_ctx->data.brokerVhostFederationTag[0]);
    memcpy((*brokerVhostFederationTag_val_ptr_ptr),
           rowreq_ctx->data.brokerVhostFederationTag,
           rowreq_ctx->data.brokerVhostFederationTag_len *
           sizeof(rowreq_ctx->data.brokerVhostFederationTag[0]));

    return MFD_SUCCESS;
}                               /* brokerVhostFederationTag_get */



/** @} */
